/*
 * Copyright 2013 The Native Client Authors.  All rights reserved.
 * Use of this source code is governed by a BSD-style license that can
 * be found in the LICENSE file.
 */

// DO NOT EDIT: GENERATED CODE

#ifndef NACL_TRUSTED_BUT_NOT_TCB
#error This file is not meant for use in the TCB
#endif


#ifndef NATIVE_CLIENT_SRC_TRUSTED_VALIDATOR_ARM_GEN_ARM32_DECODE_NAMED_DECODER_H_
#define NATIVE_CLIENT_SRC_TRUSTED_VALIDATOR_ARM_GEN_ARM32_DECODE_NAMED_DECODER_H_

#include "native_client/src/trusted/validator_arm/decode.h"
#include "native_client/src/trusted/validator_arm/gen/arm32_decode_named_classes.h"
#include "native_client/src/trusted/validator_arm/named_class_decoder.h"

namespace nacl_arm_test {

// Defines a (named) decoder class selector for instructions
class NamedArm32DecoderState : nacl_arm_dec::DecoderState {
 public:
  explicit NamedArm32DecoderState();

  // Parses the given instruction, returning the named class
  // decoder to use.
  const NamedClassDecoder& decode_named(
     const nacl_arm_dec::Instruction) const;

  // Parses the given instruction, returning the class decoder
  // to use.
  virtual const nacl_arm_dec::ClassDecoder& decode(
     const nacl_arm_dec::Instruction) const;

  // The following fields define the set of class decoders
  // that can be returned by the API function "decode_named". They
  // are created once as instance fields, and then returned
  // by the table methods above. This speeds up the code since
  // the class decoders need to only be bulit once (and reused
  // for each call to "decode_named").
  const NamedBinary2RegisterBitRangeMsbGeLsb_BFI Binary2RegisterBitRangeMsbGeLsb_BFI_instance_;
  const NamedBinary2RegisterBitRangeNotRnIsPcBitfieldExtract_SBFX Binary2RegisterBitRangeNotRnIsPcBitfieldExtract_SBFX_instance_;
  const NamedBinary2RegisterBitRangeNotRnIsPcBitfieldExtract_UBFX Binary2RegisterBitRangeNotRnIsPcBitfieldExtract_UBFX_instance_;
  const NamedBinary2RegisterImmedShiftedTest_CMN_register Binary2RegisterImmedShiftedTest_CMN_register_instance_;
  const NamedBinary2RegisterImmedShiftedTest_CMP_register Binary2RegisterImmedShiftedTest_CMP_register_instance_;
  const NamedBinary2RegisterImmedShiftedTest_TEQ_register Binary2RegisterImmedShiftedTest_TEQ_register_instance_;
  const NamedBinary2RegisterImmedShiftedTest_TST_register Binary2RegisterImmedShiftedTest_TST_register_instance_;
  const NamedBinary2RegisterImmediateOp_ADC_immediate Binary2RegisterImmediateOp_ADC_immediate_instance_;
  const NamedBinary2RegisterImmediateOp_AND_immediate Binary2RegisterImmediateOp_AND_immediate_instance_;
  const NamedBinary2RegisterImmediateOp_EOR_immediate Binary2RegisterImmediateOp_EOR_immediate_instance_;
  const NamedBinary2RegisterImmediateOp_RSB_immediate Binary2RegisterImmediateOp_RSB_immediate_instance_;
  const NamedBinary2RegisterImmediateOp_RSC_immediate Binary2RegisterImmediateOp_RSC_immediate_instance_;
  const NamedBinary2RegisterImmediateOp_SBC_immediate Binary2RegisterImmediateOp_SBC_immediate_instance_;
  const NamedBinary2RegisterImmediateOpAddSub_ADD_immediate Binary2RegisterImmediateOpAddSub_ADD_immediate_instance_;
  const NamedBinary2RegisterImmediateOpAddSub_SUB_immediate Binary2RegisterImmediateOpAddSub_SUB_immediate_instance_;
  const NamedBinary2RegisterImmediateOpDynCodeReplace_ORR_immediate Binary2RegisterImmediateOpDynCodeReplace_ORR_immediate_instance_;
  const NamedBinary3RegisterOp_ASR_register Binary3RegisterOp_ASR_register_instance_;
  const NamedBinary3RegisterOp_LSL_register Binary3RegisterOp_LSL_register_instance_;
  const NamedBinary3RegisterOp_LSR_register Binary3RegisterOp_LSR_register_instance_;
  const NamedBinary3RegisterOp_ROR_register Binary3RegisterOp_ROR_register_instance_;
  const NamedBinary3RegisterOpAltA_MUL_A1 Binary3RegisterOpAltA_MUL_A1_instance_;
  const NamedBinary3RegisterOpAltA_SMULBB_SMULBT_SMULTB_SMULTT Binary3RegisterOpAltA_SMULBB_SMULBT_SMULTB_SMULTT_instance_;
  const NamedBinary3RegisterOpAltA_SMULWB_SMULWT Binary3RegisterOpAltA_SMULWB_SMULWT_instance_;
  const NamedBinary3RegisterOpAltA_USAD8 Binary3RegisterOpAltA_USAD8_instance_;
  const NamedBinary3RegisterOpAltANoCondsUpdate_SDIV Binary3RegisterOpAltANoCondsUpdate_SDIV_instance_;
  const NamedBinary3RegisterOpAltANoCondsUpdate_SMMUL Binary3RegisterOpAltANoCondsUpdate_SMMUL_instance_;
  const NamedBinary3RegisterOpAltANoCondsUpdate_SMUAD Binary3RegisterOpAltANoCondsUpdate_SMUAD_instance_;
  const NamedBinary3RegisterOpAltANoCondsUpdate_SMUSD Binary3RegisterOpAltANoCondsUpdate_SMUSD_instance_;
  const NamedBinary3RegisterOpAltANoCondsUpdate_UDIV Binary3RegisterOpAltANoCondsUpdate_UDIV_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_PKH Binary3RegisterOpAltBNoCondUpdates_PKH_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_QADD Binary3RegisterOpAltBNoCondUpdates_QADD_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_QADD16 Binary3RegisterOpAltBNoCondUpdates_QADD16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_QADD8 Binary3RegisterOpAltBNoCondUpdates_QADD8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_QASX Binary3RegisterOpAltBNoCondUpdates_QASX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_QDADD Binary3RegisterOpAltBNoCondUpdates_QDADD_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_QDSUB Binary3RegisterOpAltBNoCondUpdates_QDSUB_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_QSAX Binary3RegisterOpAltBNoCondUpdates_QSAX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_QSUB Binary3RegisterOpAltBNoCondUpdates_QSUB_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_QSUB16 Binary3RegisterOpAltBNoCondUpdates_QSUB16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_QSUB8 Binary3RegisterOpAltBNoCondUpdates_QSUB8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SADD16 Binary3RegisterOpAltBNoCondUpdates_SADD16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SADD8 Binary3RegisterOpAltBNoCondUpdates_SADD8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SASX Binary3RegisterOpAltBNoCondUpdates_SASX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SEL Binary3RegisterOpAltBNoCondUpdates_SEL_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SHADD16 Binary3RegisterOpAltBNoCondUpdates_SHADD16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SHADD8 Binary3RegisterOpAltBNoCondUpdates_SHADD8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SHASX Binary3RegisterOpAltBNoCondUpdates_SHASX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SHSAX Binary3RegisterOpAltBNoCondUpdates_SHSAX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SHSUB16 Binary3RegisterOpAltBNoCondUpdates_SHSUB16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SHSUB8 Binary3RegisterOpAltBNoCondUpdates_SHSUB8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SSAX Binary3RegisterOpAltBNoCondUpdates_SSAX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SSSUB16 Binary3RegisterOpAltBNoCondUpdates_SSSUB16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SSUB8 Binary3RegisterOpAltBNoCondUpdates_SSUB8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SXTAB Binary3RegisterOpAltBNoCondUpdates_SXTAB_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SXTAB16 Binary3RegisterOpAltBNoCondUpdates_SXTAB16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_SXTAH Binary3RegisterOpAltBNoCondUpdates_SXTAH_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UADD16 Binary3RegisterOpAltBNoCondUpdates_UADD16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UADD8 Binary3RegisterOpAltBNoCondUpdates_UADD8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UASX Binary3RegisterOpAltBNoCondUpdates_UASX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UHADD16 Binary3RegisterOpAltBNoCondUpdates_UHADD16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UHADD8 Binary3RegisterOpAltBNoCondUpdates_UHADD8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UHASX Binary3RegisterOpAltBNoCondUpdates_UHASX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UHSAX Binary3RegisterOpAltBNoCondUpdates_UHSAX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UHSUB16 Binary3RegisterOpAltBNoCondUpdates_UHSUB16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UHSUB8 Binary3RegisterOpAltBNoCondUpdates_UHSUB8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UQADD16 Binary3RegisterOpAltBNoCondUpdates_UQADD16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UQADD8 Binary3RegisterOpAltBNoCondUpdates_UQADD8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UQASX Binary3RegisterOpAltBNoCondUpdates_UQASX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UQSAX Binary3RegisterOpAltBNoCondUpdates_UQSAX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UQSUB16 Binary3RegisterOpAltBNoCondUpdates_UQSUB16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UQSUB8 Binary3RegisterOpAltBNoCondUpdates_UQSUB8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_USAX Binary3RegisterOpAltBNoCondUpdates_USAX_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_USUB16 Binary3RegisterOpAltBNoCondUpdates_USUB16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_USUB8 Binary3RegisterOpAltBNoCondUpdates_USUB8_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UXTAB Binary3RegisterOpAltBNoCondUpdates_UXTAB_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UXTAB16 Binary3RegisterOpAltBNoCondUpdates_UXTAB16_instance_;
  const NamedBinary3RegisterOpAltBNoCondUpdates_UXTAH Binary3RegisterOpAltBNoCondUpdates_UXTAH_instance_;
  const NamedBinary3RegisterShiftedOp_ADC_register Binary3RegisterShiftedOp_ADC_register_instance_;
  const NamedBinary3RegisterShiftedOp_ADD_register Binary3RegisterShiftedOp_ADD_register_instance_;
  const NamedBinary3RegisterShiftedOp_AND_register Binary3RegisterShiftedOp_AND_register_instance_;
  const NamedBinary3RegisterShiftedOp_BIC_register Binary3RegisterShiftedOp_BIC_register_instance_;
  const NamedBinary3RegisterShiftedOp_EOR_register Binary3RegisterShiftedOp_EOR_register_instance_;
  const NamedBinary3RegisterShiftedOp_ORR_register Binary3RegisterShiftedOp_ORR_register_instance_;
  const NamedBinary3RegisterShiftedOp_RSB_register Binary3RegisterShiftedOp_RSB_register_instance_;
  const NamedBinary3RegisterShiftedOp_RSC_register Binary3RegisterShiftedOp_RSC_register_instance_;
  const NamedBinary3RegisterShiftedOp_SBC_register Binary3RegisterShiftedOp_SBC_register_instance_;
  const NamedBinary3RegisterShiftedOp_SUB_register Binary3RegisterShiftedOp_SUB_register_instance_;
  const NamedBinary3RegisterShiftedTest_CMN_register_shifted_register Binary3RegisterShiftedTest_CMN_register_shifted_register_instance_;
  const NamedBinary3RegisterShiftedTest_CMP_register_shifted_register Binary3RegisterShiftedTest_CMP_register_shifted_register_instance_;
  const NamedBinary3RegisterShiftedTest_TEQ_register_shifted_register Binary3RegisterShiftedTest_TEQ_register_shifted_register_instance_;
  const NamedBinary3RegisterShiftedTest_TST_register_shifted_register Binary3RegisterShiftedTest_TST_register_shifted_register_instance_;
  const NamedBinary4RegisterDualOp_MLS_A1 Binary4RegisterDualOp_MLS_A1_instance_;
  const NamedBinary4RegisterDualOp_SMLABB_SMLABT_SMLATB_SMLATT Binary4RegisterDualOp_SMLABB_SMLABT_SMLATB_SMLATT_instance_;
  const NamedBinary4RegisterDualOp_SMLAWB_SMLAWT Binary4RegisterDualOp_SMLAWB_SMLAWT_instance_;
  const NamedBinary4RegisterDualOp_USADA8 Binary4RegisterDualOp_USADA8_instance_;
  const NamedBinary4RegisterDualOpLtV6RdNotRn_MLA_A1 Binary4RegisterDualOpLtV6RdNotRn_MLA_A1_instance_;
  const NamedBinary4RegisterDualOpNoCondsUpdate_SMLAD Binary4RegisterDualOpNoCondsUpdate_SMLAD_instance_;
  const NamedBinary4RegisterDualOpNoCondsUpdate_SMLSD Binary4RegisterDualOpNoCondsUpdate_SMLSD_instance_;
  const NamedBinary4RegisterDualOpNoCondsUpdate_SMMLA Binary4RegisterDualOpNoCondsUpdate_SMMLA_instance_;
  const NamedBinary4RegisterDualOpNoCondsUpdate_SMMLS Binary4RegisterDualOpNoCondsUpdate_SMMLS_instance_;
  const NamedBinary4RegisterDualResult_SMLALBB_SMLALBT_SMLALTB_SMLALTT Binary4RegisterDualResult_SMLALBB_SMLALBT_SMLALTB_SMLALTT_instance_;
  const NamedBinary4RegisterDualResult_UMAAL_A1 Binary4RegisterDualResult_UMAAL_A1_instance_;
  const NamedBinary4RegisterDualResultLtV6RdHiLoNotRn_SMLAL_A1 Binary4RegisterDualResultLtV6RdHiLoNotRn_SMLAL_A1_instance_;
  const NamedBinary4RegisterDualResultLtV6RdHiLoNotRn_UMLAL_A1 Binary4RegisterDualResultLtV6RdHiLoNotRn_UMLAL_A1_instance_;
  const NamedBinary4RegisterDualResultNoCondsUpdate_SMLALD Binary4RegisterDualResultNoCondsUpdate_SMLALD_instance_;
  const NamedBinary4RegisterDualResultNoCondsUpdate_SMLSLD Binary4RegisterDualResultNoCondsUpdate_SMLSLD_instance_;
  const NamedBinary4RegisterDualResultUsesRnRm_SMULL_A1 Binary4RegisterDualResultUsesRnRm_SMULL_A1_instance_;
  const NamedBinary4RegisterDualResultUsesRnRm_UMULL_A1 Binary4RegisterDualResultUsesRnRm_UMULL_A1_instance_;
  const NamedBinary4RegisterShiftedOp_ADC_register_shifted_register Binary4RegisterShiftedOp_ADC_register_shifted_register_instance_;
  const NamedBinary4RegisterShiftedOp_ADD_register_shifted_register Binary4RegisterShiftedOp_ADD_register_shifted_register_instance_;
  const NamedBinary4RegisterShiftedOp_AND_register_shifted_register Binary4RegisterShiftedOp_AND_register_shifted_register_instance_;
  const NamedBinary4RegisterShiftedOp_BIC_register_shifted_register Binary4RegisterShiftedOp_BIC_register_shifted_register_instance_;
  const NamedBinary4RegisterShiftedOp_EOR_register_shifted_register Binary4RegisterShiftedOp_EOR_register_shifted_register_instance_;
  const NamedBinary4RegisterShiftedOp_ORR_register_shifted_register Binary4RegisterShiftedOp_ORR_register_shifted_register_instance_;
  const NamedBinary4RegisterShiftedOp_RSB_register_shfited_register Binary4RegisterShiftedOp_RSB_register_shfited_register_instance_;
  const NamedBinary4RegisterShiftedOp_RSC_register_shifted_register Binary4RegisterShiftedOp_RSC_register_shifted_register_instance_;
  const NamedBinary4RegisterShiftedOp_SBC_register_shifted_register Binary4RegisterShiftedOp_SBC_register_shifted_register_instance_;
  const NamedBinary4RegisterShiftedOp_SUB_register_shifted_register Binary4RegisterShiftedOp_SUB_register_shifted_register_instance_;
  const NamedBinaryRegisterImmediateTest_CMN_immediate BinaryRegisterImmediateTest_CMN_immediate_instance_;
  const NamedBinaryRegisterImmediateTest_CMP_immediate BinaryRegisterImmediateTest_CMP_immediate_instance_;
  const NamedBinaryRegisterImmediateTest_TEQ_immediate BinaryRegisterImmediateTest_TEQ_immediate_instance_;
  const NamedBranchImmediate24_B BranchImmediate24_B_instance_;
  const NamedBranchImmediate24_BL_BLX_immediate BranchImmediate24_BL_BLX_immediate_instance_;
  const NamedBranchToRegister_BLX_register BranchToRegister_BLX_register_instance_;
  const NamedBranchToRegister_Bx BranchToRegister_Bx_instance_;
  const NamedBreakPointAndConstantPoolHead_BKPT BreakPointAndConstantPoolHead_BKPT_instance_;
  const NamedCondDecoder_NOP CondDecoder_NOP_instance_;
  const NamedCondDecoder_YIELD CondDecoder_YIELD_instance_;
  const NamedCondVfpOp_VABS CondVfpOp_VABS_instance_;
  const NamedCondVfpOp_VADD_floating_point CondVfpOp_VADD_floating_point_instance_;
  const NamedCondVfpOp_VCMP_VCMPE CondVfpOp_VCMP_VCMPE_instance_;
  const NamedCondVfpOp_VCVTB_VCVTT CondVfpOp_VCVTB_VCVTT_instance_;
  const NamedCondVfpOp_VCVT_VCVTR_between_floating_point_and_integer_Floating_point CondVfpOp_VCVT_VCVTR_between_floating_point_and_integer_Floating_point_instance_;
  const NamedCondVfpOp_VCVT_between_double_precision_and_single_precision CondVfpOp_VCVT_between_double_precision_and_single_precision_instance_;
  const NamedCondVfpOp_VDIV CondVfpOp_VDIV_instance_;
  const NamedCondVfpOp_VFMA_VFMS CondVfpOp_VFMA_VFMS_instance_;
  const NamedCondVfpOp_VFNMA_VFNMS CondVfpOp_VFNMA_VFNMS_instance_;
  const NamedCondVfpOp_VMLA_VMLS_floating_point CondVfpOp_VMLA_VMLS_floating_point_instance_;
  const NamedCondVfpOp_VMOV_immediate CondVfpOp_VMOV_immediate_instance_;
  const NamedCondVfpOp_VMOV_register CondVfpOp_VMOV_register_instance_;
  const NamedCondVfpOp_VMUL_floating_point CondVfpOp_VMUL_floating_point_instance_;
  const NamedCondVfpOp_VNEG CondVfpOp_VNEG_instance_;
  const NamedCondVfpOp_VNMLA_VNMLS CondVfpOp_VNMLA_VNMLS_instance_;
  const NamedCondVfpOp_VNMUL CondVfpOp_VNMUL_instance_;
  const NamedCondVfpOp_VSQRT CondVfpOp_VSQRT_instance_;
  const NamedCondVfpOp_VSUB_floating_point CondVfpOp_VSUB_floating_point_instance_;
  const NamedDataBarrier_DMB DataBarrier_DMB_instance_;
  const NamedDataBarrier_DSB DataBarrier_DSB_instance_;
  const NamedDeprecated_SWP_SWPB Deprecated_SWP_SWPB_instance_;
  const NamedDuplicateToAdvSIMDRegisters_VDUP_arm_core_register DuplicateToAdvSIMDRegisters_VDUP_arm_core_register_instance_;
  const NamedForbidden_DBG Forbidden_DBG_instance_;
  const NamedForbidden_MSR_immediate Forbidden_MSR_immediate_instance_;
  const NamedForbidden_SEV Forbidden_SEV_instance_;
  const NamedForbidden_WFE Forbidden_WFE_instance_;
  const NamedForbidden_WFI Forbidden_WFI_instance_;
  const NamedForbidden_BLX_immediate Forbidden_BLX_immediate_instance_;
  const NamedForbidden_CDP Forbidden_CDP_instance_;
  const NamedForbidden_CDP2 Forbidden_CDP2_instance_;
  const NamedForbidden_CLREX Forbidden_CLREX_instance_;
  const NamedForbidden_CPS Forbidden_CPS_instance_;
  const NamedForbidden_LDC2_immediate Forbidden_LDC2_immediate_instance_;
  const NamedForbidden_LDC2_literal Forbidden_LDC2_literal_instance_;
  const NamedForbidden_LDC_immediate Forbidden_LDC_immediate_instance_;
  const NamedForbidden_LDC_literal Forbidden_LDC_literal_instance_;
  const NamedForbidden_MCR Forbidden_MCR_instance_;
  const NamedForbidden_MCR2 Forbidden_MCR2_instance_;
  const NamedForbidden_MCRR Forbidden_MCRR_instance_;
  const NamedForbidden_MCRR2 Forbidden_MCRR2_instance_;
  const NamedForbidden_MRC Forbidden_MRC_instance_;
  const NamedForbidden_MRC2 Forbidden_MRC2_instance_;
  const NamedForbidden_MRRC Forbidden_MRRC_instance_;
  const NamedForbidden_MRRC2 Forbidden_MRRC2_instance_;
  const NamedForbidden_RFE Forbidden_RFE_instance_;
  const NamedForbidden_SETEND Forbidden_SETEND_instance_;
  const NamedForbidden_SRS Forbidden_SRS_instance_;
  const NamedForbidden_STC Forbidden_STC_instance_;
  const NamedForbidden_STC2 Forbidden_STC2_instance_;
  const NamedForbidden_SVC Forbidden_SVC_instance_;
  const NamedForbidden_None Forbidden_None_instance_;
  const NamedForbiddenCondDecoder_BXJ ForbiddenCondDecoder_BXJ_instance_;
  const NamedForbiddenCondDecoder_ERET ForbiddenCondDecoder_ERET_instance_;
  const NamedForbiddenCondDecoder_HVC ForbiddenCondDecoder_HVC_instance_;
  const NamedForbiddenCondDecoder_LDM_User_registers ForbiddenCondDecoder_LDM_User_registers_instance_;
  const NamedForbiddenCondDecoder_LDM_exception_return ForbiddenCondDecoder_LDM_exception_return_instance_;
  const NamedForbiddenCondDecoder_LDRBT_A1 ForbiddenCondDecoder_LDRBT_A1_instance_;
  const NamedForbiddenCondDecoder_LDRBT_A2 ForbiddenCondDecoder_LDRBT_A2_instance_;
  const NamedForbiddenCondDecoder_LDRT_A1 ForbiddenCondDecoder_LDRT_A1_instance_;
  const NamedForbiddenCondDecoder_LDRT_A2 ForbiddenCondDecoder_LDRT_A2_instance_;
  const NamedForbiddenCondDecoder_MRS_Banked_register ForbiddenCondDecoder_MRS_Banked_register_instance_;
  const NamedForbiddenCondDecoder_MSR_Banked_register ForbiddenCondDecoder_MSR_Banked_register_instance_;
  const NamedForbiddenCondDecoder_MSR_register ForbiddenCondDecoder_MSR_register_instance_;
  const NamedForbiddenCondDecoder_SMC ForbiddenCondDecoder_SMC_instance_;
  const NamedForbiddenCondDecoder_STM_User_registers ForbiddenCondDecoder_STM_User_registers_instance_;
  const NamedForbiddenCondDecoder_STRBT_A1 ForbiddenCondDecoder_STRBT_A1_instance_;
  const NamedForbiddenCondDecoder_STRBT_A2 ForbiddenCondDecoder_STRBT_A2_instance_;
  const NamedForbiddenCondDecoder_STRT_A1 ForbiddenCondDecoder_STRT_A1_instance_;
  const NamedForbiddenCondDecoder_STRT_A2 ForbiddenCondDecoder_STRT_A2_instance_;
  const NamedForbiddenCondDecoder_extra_load_store_instructions_unpriviledged ForbiddenCondDecoder_extra_load_store_instructions_unpriviledged_instance_;
  const NamedInstructionBarrier_ISB InstructionBarrier_ISB_instance_;
  const NamedLdrImmediateOp_LDR_immediate LdrImmediateOp_LDR_immediate_instance_;
  const NamedLoad2RegisterImm12Op_LDRB_immediate Load2RegisterImm12Op_LDRB_immediate_instance_;
  const NamedLoad2RegisterImm12Op_LDRB_literal Load2RegisterImm12Op_LDRB_literal_instance_;
  const NamedLoad2RegisterImm12Op_LDR_literal Load2RegisterImm12Op_LDR_literal_instance_;
  const NamedLoad2RegisterImm8DoubleOp_LDRD_immediate Load2RegisterImm8DoubleOp_LDRD_immediate_instance_;
  const NamedLoad2RegisterImm8Op_LDRH_immediate Load2RegisterImm8Op_LDRH_immediate_instance_;
  const NamedLoad2RegisterImm8Op_LDRSB_immediate Load2RegisterImm8Op_LDRSB_immediate_instance_;
  const NamedLoad2RegisterImm8Op_LDRSH_immediate Load2RegisterImm8Op_LDRSH_immediate_instance_;
  const NamedLoad3RegisterDoubleOp_LDRD_register Load3RegisterDoubleOp_LDRD_register_instance_;
  const NamedLoad3RegisterImm5Op_LDRB_register Load3RegisterImm5Op_LDRB_register_instance_;
  const NamedLoad3RegisterImm5Op_LDR_register Load3RegisterImm5Op_LDR_register_instance_;
  const NamedLoad3RegisterOp_LDRH_register Load3RegisterOp_LDRH_register_instance_;
  const NamedLoad3RegisterOp_LDRSB_register Load3RegisterOp_LDRSB_register_instance_;
  const NamedLoad3RegisterOp_LDRSH_register Load3RegisterOp_LDRSH_register_instance_;
  const NamedLoadExclusive2RegisterDoubleOp_LDREXD LoadExclusive2RegisterDoubleOp_LDREXD_instance_;
  const NamedLoadExclusive2RegisterOp_LDREX LoadExclusive2RegisterOp_LDREX_instance_;
  const NamedLoadExclusive2RegisterOp_LDREXB LoadExclusive2RegisterOp_LDREXB_instance_;
  const NamedLoadExclusive2RegisterOp_STREXH LoadExclusive2RegisterOp_STREXH_instance_;
  const NamedLoadRegisterImm8DoubleOp_LDRD_literal LoadRegisterImm8DoubleOp_LDRD_literal_instance_;
  const NamedLoadRegisterImm8Op_LDRH_literal LoadRegisterImm8Op_LDRH_literal_instance_;
  const NamedLoadRegisterImm8Op_LDRSB_literal LoadRegisterImm8Op_LDRSB_literal_instance_;
  const NamedLoadRegisterList_LDMDA_LDMFA LoadRegisterList_LDMDA_LDMFA_instance_;
  const NamedLoadRegisterList_LDMDB_LDMEA LoadRegisterList_LDMDB_LDMEA_instance_;
  const NamedLoadRegisterList_LDMIB_LDMED LoadRegisterList_LDMIB_LDMED_instance_;
  const NamedLoadRegisterList_LDM_LDMIA_LDMFD LoadRegisterList_LDM_LDMIA_LDMFD_instance_;
  const NamedLoadVectorRegister_VLDR LoadVectorRegister_VLDR_instance_;
  const NamedLoadVectorRegisterList_VLDM LoadVectorRegisterList_VLDM_instance_;
  const NamedLoadVectorRegisterList_VPOP LoadVectorRegisterList_VPOP_instance_;
  const NamedMaskedBinary2RegisterImmediateOp_BIC_immediate MaskedBinary2RegisterImmediateOp_BIC_immediate_instance_;
  const NamedMaskedBinaryRegisterImmediateTest_TST_immediate MaskedBinaryRegisterImmediateTest_TST_immediate_instance_;
  const NamedMoveDoubleVfpRegisterOp_VMOV_between_two_ARM_core_registers_and_a_doubleword_extension_register MoveDoubleVfpRegisterOp_VMOV_between_two_ARM_core_registers_and_a_doubleword_extension_register_instance_;
  const NamedMoveDoubleVfpRegisterOp_VMOV_between_two_ARM_core_registers_and_two_single_precision_registers MoveDoubleVfpRegisterOp_VMOV_between_two_ARM_core_registers_and_two_single_precision_registers_instance_;
  const NamedMoveImmediate12ToApsr_MSR_immediate MoveImmediate12ToApsr_MSR_immediate_instance_;
  const NamedMoveVfpRegisterOp_VMOV_between_ARM_core_register_and_single_precision_register MoveVfpRegisterOp_VMOV_between_ARM_core_register_and_single_precision_register_instance_;
  const NamedMoveVfpRegisterOpWithTypeSel_MOVE_scalar_to_ARM_core_register MoveVfpRegisterOpWithTypeSel_MOVE_scalar_to_ARM_core_register_instance_;
  const NamedMoveVfpRegisterOpWithTypeSel_VMOV_ARM_core_register_to_scalar MoveVfpRegisterOpWithTypeSel_VMOV_ARM_core_register_to_scalar_instance_;
  const NamedPermanentlyUndefined_UDF PermanentlyUndefined_UDF_instance_;
  const NamedPreloadRegisterImm12Op_PLD_PLDW_immediate PreloadRegisterImm12Op_PLD_PLDW_immediate_instance_;
  const NamedPreloadRegisterImm12Op_PLD_literal PreloadRegisterImm12Op_PLD_literal_instance_;
  const NamedPreloadRegisterImm12Op_PLI_immediate_literal PreloadRegisterImm12Op_PLI_immediate_literal_instance_;
  const NamedPreloadRegisterPairOp_PLD_PLDW_register PreloadRegisterPairOp_PLD_PLDW_register_instance_;
  const NamedPreloadRegisterPairOp_PLI_register PreloadRegisterPairOp_PLI_register_instance_;
  const NamedStore2RegisterImm12Op_STRB_immediate Store2RegisterImm12Op_STRB_immediate_instance_;
  const NamedStore2RegisterImm12Op_STR_immediate Store2RegisterImm12Op_STR_immediate_instance_;
  const NamedStore2RegisterImm8DoubleOp_STRD_immediate Store2RegisterImm8DoubleOp_STRD_immediate_instance_;
  const NamedStore2RegisterImm8Op_STRH_immediate Store2RegisterImm8Op_STRH_immediate_instance_;
  const NamedStore3RegisterDoubleOp_STRD_register Store3RegisterDoubleOp_STRD_register_instance_;
  const NamedStore3RegisterImm5Op_STRB_register Store3RegisterImm5Op_STRB_register_instance_;
  const NamedStore3RegisterImm5Op_STR_register Store3RegisterImm5Op_STR_register_instance_;
  const NamedStore3RegisterOp_STRH_register Store3RegisterOp_STRH_register_instance_;
  const NamedStoreExclusive3RegisterDoubleOp_STREXD StoreExclusive3RegisterDoubleOp_STREXD_instance_;
  const NamedStoreExclusive3RegisterOp_STREX StoreExclusive3RegisterOp_STREX_instance_;
  const NamedStoreExclusive3RegisterOp_STREXB StoreExclusive3RegisterOp_STREXB_instance_;
  const NamedStoreExclusive3RegisterOp_STREXH StoreExclusive3RegisterOp_STREXH_instance_;
  const NamedStoreRegisterList_STMDA_STMED StoreRegisterList_STMDA_STMED_instance_;
  const NamedStoreRegisterList_STMDB_STMFD StoreRegisterList_STMDB_STMFD_instance_;
  const NamedStoreRegisterList_STMIB_STMFA StoreRegisterList_STMIB_STMFA_instance_;
  const NamedStoreRegisterList_STM_STMIA_STMEA StoreRegisterList_STM_STMIA_STMEA_instance_;
  const NamedStoreVectorRegister_VSTR StoreVectorRegister_VSTR_instance_;
  const NamedStoreVectorRegisterList_VPUSH StoreVectorRegisterList_VPUSH_instance_;
  const NamedStoreVectorRegisterList_VSTM StoreVectorRegisterList_VSTM_instance_;
  const NamedUnary1RegisterBitRangeMsbGeLsb_BFC Unary1RegisterBitRangeMsbGeLsb_BFC_instance_;
  const NamedUnary1RegisterImmediateOp12DynCodeReplace_MOV_immediate_A1 Unary1RegisterImmediateOp12DynCodeReplace_MOV_immediate_A1_instance_;
  const NamedUnary1RegisterImmediateOp12DynCodeReplace_MVN_immediate Unary1RegisterImmediateOp12DynCodeReplace_MVN_immediate_instance_;
  const NamedUnary1RegisterImmediateOpDynCodeReplace_MOVT Unary1RegisterImmediateOpDynCodeReplace_MOVT_instance_;
  const NamedUnary1RegisterImmediateOpDynCodeReplace_MOVW Unary1RegisterImmediateOpDynCodeReplace_MOVW_instance_;
  const NamedUnary1RegisterImmediateOpPc_ADR_A1 Unary1RegisterImmediateOpPc_ADR_A1_instance_;
  const NamedUnary1RegisterImmediateOpPc_ADR_A2 Unary1RegisterImmediateOpPc_ADR_A2_instance_;
  const NamedUnary1RegisterSet_MRS Unary1RegisterSet_MRS_instance_;
  const NamedUnary1RegisterUse_MSR_register Unary1RegisterUse_MSR_register_instance_;
  const NamedUnary2RegisterImmedShiftedOp_RBIT Unary2RegisterImmedShiftedOp_RBIT_instance_;
  const NamedUnary2RegisterImmedShiftedOp_REV Unary2RegisterImmedShiftedOp_REV_instance_;
  const NamedUnary2RegisterImmedShiftedOp_REV16 Unary2RegisterImmedShiftedOp_REV16_instance_;
  const NamedUnary2RegisterImmedShiftedOp_REVSH Unary2RegisterImmedShiftedOp_REVSH_instance_;
  const NamedUnary2RegisterImmedShiftedOp_SXTB Unary2RegisterImmedShiftedOp_SXTB_instance_;
  const NamedUnary2RegisterImmedShiftedOp_SXTB16 Unary2RegisterImmedShiftedOp_SXTB16_instance_;
  const NamedUnary2RegisterImmedShiftedOp_SXTH Unary2RegisterImmedShiftedOp_SXTH_instance_;
  const NamedUnary2RegisterImmedShiftedOp_UXTB Unary2RegisterImmedShiftedOp_UXTB_instance_;
  const NamedUnary2RegisterImmedShiftedOp_UXTB16 Unary2RegisterImmedShiftedOp_UXTB16_instance_;
  const NamedUnary2RegisterImmedShiftedOp_UXTH Unary2RegisterImmedShiftedOp_UXTH_instance_;
  const NamedUnary2RegisterOp_MOV_register Unary2RegisterOp_MOV_register_instance_;
  const NamedUnary2RegisterOp_RRX Unary2RegisterOp_RRX_instance_;
  const NamedUnary2RegisterOpNotRmIsPc_CLZ Unary2RegisterOpNotRmIsPc_CLZ_instance_;
  const NamedUnary2RegisterSatImmedShiftedOp_SSAT Unary2RegisterSatImmedShiftedOp_SSAT_instance_;
  const NamedUnary2RegisterSatImmedShiftedOp_SSAT16 Unary2RegisterSatImmedShiftedOp_SSAT16_instance_;
  const NamedUnary2RegisterSatImmedShiftedOp_USAT Unary2RegisterSatImmedShiftedOp_USAT_instance_;
  const NamedUnary2RegisterSatImmedShiftedOp_USAT16 Unary2RegisterSatImmedShiftedOp_USAT16_instance_;
  const NamedUnary2RegisterShiftedOp_ASR_immediate Unary2RegisterShiftedOp_ASR_immediate_instance_;
  const NamedUnary2RegisterShiftedOp_LSR_immediate Unary2RegisterShiftedOp_LSR_immediate_instance_;
  const NamedUnary2RegisterShiftedOp_MVN_register Unary2RegisterShiftedOp_MVN_register_instance_;
  const NamedUnary2RegisterShiftedOpImmNotZero_LSL_immediate Unary2RegisterShiftedOpImmNotZero_LSL_immediate_instance_;
  const NamedUnary2RegisterShiftedOpImmNotZero_ROR_immediate Unary2RegisterShiftedOpImmNotZero_ROR_immediate_instance_;
  const NamedUnary3RegisterShiftedOp_MVN_register_shifted_register Unary3RegisterShiftedOp_MVN_register_shifted_register_instance_;
  const NamedUndefined_None Undefined_None_instance_;
  const NamedUnpredictable_None Unpredictable_None_instance_;
  const NamedVcvtPtAndFixedPoint_FloatingPoint_VCVT_between_floating_point_and_fixed_point_Floating_point VcvtPtAndFixedPoint_FloatingPoint_VCVT_between_floating_point_and_fixed_point_Floating_point_instance_;
  const NamedVector1RegisterImmediate_BIT_VBIC_immediate Vector1RegisterImmediate_BIT_VBIC_immediate_instance_;
  const NamedVector1RegisterImmediate_BIT_VORR_immediate Vector1RegisterImmediate_BIT_VORR_immediate_instance_;
  const NamedVector1RegisterImmediate_MOV_VMOV_immediate_A1 Vector1RegisterImmediate_MOV_VMOV_immediate_A1_instance_;
  const NamedVector1RegisterImmediate_MVN_VMVN_immediate Vector1RegisterImmediate_MVN_VMVN_immediate_instance_;
  const NamedVector2RegisterMiscellaneous_CVT_F2I_VCVT Vector2RegisterMiscellaneous_CVT_F2I_VCVT_instance_;
  const NamedVector2RegisterMiscellaneous_CVT_H2S_CVT_between_half_precision_and_single_precision Vector2RegisterMiscellaneous_CVT_H2S_CVT_between_half_precision_and_single_precision_instance_;
  const NamedVector2RegisterMiscellaneous_F32_VABS_A1 Vector2RegisterMiscellaneous_F32_VABS_A1_instance_;
  const NamedVector2RegisterMiscellaneous_F32_VCEQ_immediate_0 Vector2RegisterMiscellaneous_F32_VCEQ_immediate_0_instance_;
  const NamedVector2RegisterMiscellaneous_F32_VCGE_immediate_0 Vector2RegisterMiscellaneous_F32_VCGE_immediate_0_instance_;
  const NamedVector2RegisterMiscellaneous_F32_VCGT_immediate_0 Vector2RegisterMiscellaneous_F32_VCGT_immediate_0_instance_;
  const NamedVector2RegisterMiscellaneous_F32_VCLE_immediate_0 Vector2RegisterMiscellaneous_F32_VCLE_immediate_0_instance_;
  const NamedVector2RegisterMiscellaneous_F32_VCLT_immediate_0 Vector2RegisterMiscellaneous_F32_VCLT_immediate_0_instance_;
  const NamedVector2RegisterMiscellaneous_F32_VNEG Vector2RegisterMiscellaneous_F32_VNEG_instance_;
  const NamedVector2RegisterMiscellaneous_F32_VRECPE Vector2RegisterMiscellaneous_F32_VRECPE_instance_;
  const NamedVector2RegisterMiscellaneous_F32_VRSQRTE Vector2RegisterMiscellaneous_F32_VRSQRTE_instance_;
  const NamedVector2RegisterMiscellaneous_I16_32_64N_VQMOVN Vector2RegisterMiscellaneous_I16_32_64N_VQMOVN_instance_;
  const NamedVector2RegisterMiscellaneous_I16_32_64N_VQMOVUN Vector2RegisterMiscellaneous_I16_32_64N_VQMOVUN_instance_;
  const NamedVector2RegisterMiscellaneous_I8_16_32L_VSHLL_A2 Vector2RegisterMiscellaneous_I8_16_32L_VSHLL_A2_instance_;
  const NamedVector2RegisterMiscellaneous_RG_VREV16 Vector2RegisterMiscellaneous_RG_VREV16_instance_;
  const NamedVector2RegisterMiscellaneous_RG_VREV32 Vector2RegisterMiscellaneous_RG_VREV32_instance_;
  const NamedVector2RegisterMiscellaneous_RG_VREV64 Vector2RegisterMiscellaneous_RG_VREV64_instance_;
  const NamedVector2RegisterMiscellaneous_V16_32_64N_VMOVN Vector2RegisterMiscellaneous_V16_32_64N_VMOVN_instance_;
  const NamedVector2RegisterMiscellaneous_V8_VCNT Vector2RegisterMiscellaneous_V8_VCNT_instance_;
  const NamedVector2RegisterMiscellaneous_V8_VMVN_register Vector2RegisterMiscellaneous_V8_VMVN_register_instance_;
  const NamedVector2RegisterMiscellaneous_V8S_VSWP Vector2RegisterMiscellaneous_V8S_VSWP_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VABS_A1 Vector2RegisterMiscellaneous_V8_16_32_VABS_A1_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VCEQ_immediate_0 Vector2RegisterMiscellaneous_V8_16_32_VCEQ_immediate_0_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VCGE_immediate_0 Vector2RegisterMiscellaneous_V8_16_32_VCGE_immediate_0_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VCGT_immediate_0 Vector2RegisterMiscellaneous_V8_16_32_VCGT_immediate_0_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VCLE_immediate_0 Vector2RegisterMiscellaneous_V8_16_32_VCLE_immediate_0_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VCLS Vector2RegisterMiscellaneous_V8_16_32_VCLS_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VCLT_immediate_0 Vector2RegisterMiscellaneous_V8_16_32_VCLT_immediate_0_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VCLZ Vector2RegisterMiscellaneous_V8_16_32_VCLZ_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VNEG Vector2RegisterMiscellaneous_V8_16_32_VNEG_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VPADAL Vector2RegisterMiscellaneous_V8_16_32_VPADAL_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VPADDL Vector2RegisterMiscellaneous_V8_16_32_VPADDL_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VQABS Vector2RegisterMiscellaneous_V8_16_32_VQABS_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32_VQNEG Vector2RegisterMiscellaneous_V8_16_32_VQNEG_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32I_VUZP Vector2RegisterMiscellaneous_V8_16_32I_VUZP_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32I_VZIP Vector2RegisterMiscellaneous_V8_16_32I_VZIP_instance_;
  const NamedVector2RegisterMiscellaneous_V8_16_32T_VTRN Vector2RegisterMiscellaneous_V8_16_32T_VTRN_instance_;
  const NamedVectorBinary2RegisterScalar_F32_VMLA_by_scalar_A1 VectorBinary2RegisterScalar_F32_VMLA_by_scalar_A1_instance_;
  const NamedVectorBinary2RegisterScalar_F32_VMLS_by_scalar_A1 VectorBinary2RegisterScalar_F32_VMLS_by_scalar_A1_instance_;
  const NamedVectorBinary2RegisterScalar_F32_VMUL_by_scalar_A1 VectorBinary2RegisterScalar_F32_VMUL_by_scalar_A1_instance_;
  const NamedVectorBinary2RegisterScalar_I16_32_VMLA_by_scalar_A1 VectorBinary2RegisterScalar_I16_32_VMLA_by_scalar_A1_instance_;
  const NamedVectorBinary2RegisterScalar_I16_32_VMLS_by_scalar_A1 VectorBinary2RegisterScalar_I16_32_VMLS_by_scalar_A1_instance_;
  const NamedVectorBinary2RegisterScalar_I16_32_VMUL_by_scalar_A1 VectorBinary2RegisterScalar_I16_32_VMUL_by_scalar_A1_instance_;
  const NamedVectorBinary2RegisterScalar_I16_32_VQDMULH_A2 VectorBinary2RegisterScalar_I16_32_VQDMULH_A2_instance_;
  const NamedVectorBinary2RegisterScalar_I16_32_VQRDMULH VectorBinary2RegisterScalar_I16_32_VQRDMULH_instance_;
  const NamedVectorBinary2RegisterScalar_I16_32L_VMLAL_by_scalar_A2 VectorBinary2RegisterScalar_I16_32L_VMLAL_by_scalar_A2_instance_;
  const NamedVectorBinary2RegisterScalar_I16_32L_VMLSL_by_scalar_A2 VectorBinary2RegisterScalar_I16_32L_VMLSL_by_scalar_A2_instance_;
  const NamedVectorBinary2RegisterScalar_I16_32L_VMULL_by_scalar_A2 VectorBinary2RegisterScalar_I16_32L_VMULL_by_scalar_A2_instance_;
  const NamedVectorBinary2RegisterScalar_I16_32L_VQDMLAL_A1 VectorBinary2RegisterScalar_I16_32L_VQDMLAL_A1_instance_;
  const NamedVectorBinary2RegisterScalar_I16_32L_VQDMLSL_A1 VectorBinary2RegisterScalar_I16_32L_VQDMLSL_A1_instance_;
  const NamedVectorBinary2RegisterScalar_I16_32L_VQDMULL_A2 VectorBinary2RegisterScalar_I16_32L_VQDMULL_A2_instance_;
  const NamedVectorBinary2RegisterShiftAmount_CVT_VCVT_between_floating_point_and_fixed_point VectorBinary2RegisterShiftAmount_CVT_VCVT_between_floating_point_and_fixed_point_instance_;
  const NamedVectorBinary2RegisterShiftAmount_E8_16_32L_VSHLL_A1_or_VMOVL VectorBinary2RegisterShiftAmount_E8_16_32L_VSHLL_A1_or_VMOVL_instance_;
  const NamedVectorBinary2RegisterShiftAmount_I_VRSHR VectorBinary2RegisterShiftAmount_I_VRSHR_instance_;
  const NamedVectorBinary2RegisterShiftAmount_I_VRSRA VectorBinary2RegisterShiftAmount_I_VRSRA_instance_;
  const NamedVectorBinary2RegisterShiftAmount_I_VSHL_immediate VectorBinary2RegisterShiftAmount_I_VSHL_immediate_instance_;
  const NamedVectorBinary2RegisterShiftAmount_I_VSHR VectorBinary2RegisterShiftAmount_I_VSHR_instance_;
  const NamedVectorBinary2RegisterShiftAmount_I_VSLI VectorBinary2RegisterShiftAmount_I_VSLI_instance_;
  const NamedVectorBinary2RegisterShiftAmount_I_VSRA VectorBinary2RegisterShiftAmount_I_VSRA_instance_;
  const NamedVectorBinary2RegisterShiftAmount_I_VSRI VectorBinary2RegisterShiftAmount_I_VSRI_instance_;
  const NamedVectorBinary2RegisterShiftAmount_ILS_VQSHL_VQSHLU_immediate VectorBinary2RegisterShiftAmount_ILS_VQSHL_VQSHLU_immediate_instance_;
  const NamedVectorBinary2RegisterShiftAmount_N16_32_64R_VRSHRN VectorBinary2RegisterShiftAmount_N16_32_64R_VRSHRN_instance_;
  const NamedVectorBinary2RegisterShiftAmount_N16_32_64R_VSHRN VectorBinary2RegisterShiftAmount_N16_32_64R_VSHRN_instance_;
  const NamedVectorBinary2RegisterShiftAmount_N16_32_64RS_VQRSHRN VectorBinary2RegisterShiftAmount_N16_32_64RS_VQRSHRN_instance_;
  const NamedVectorBinary2RegisterShiftAmount_N16_32_64RS_VQRSHRUN VectorBinary2RegisterShiftAmount_N16_32_64RS_VQRSHRUN_instance_;
  const NamedVectorBinary2RegisterShiftAmount_N16_32_64RS_VQSHRN VectorBinary2RegisterShiftAmount_N16_32_64RS_VQSHRN_instance_;
  const NamedVectorBinary2RegisterShiftAmount_N16_32_64RS_VQSHRUN VectorBinary2RegisterShiftAmount_N16_32_64RS_VQSHRUN_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I16_32L_VQDMLAL_VQDMLSL_A1 VectorBinary3RegisterDifferentLength_I16_32L_VQDMLAL_VQDMLSL_A1_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I16_32L_VQDMULL_A1 VectorBinary3RegisterDifferentLength_I16_32L_VQDMULL_A1_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I16_32_64_VADDHN VectorBinary3RegisterDifferentLength_I16_32_64_VADDHN_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I16_32_64_VRADDHN VectorBinary3RegisterDifferentLength_I16_32_64_VRADDHN_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I16_32_64_VRSUBHN VectorBinary3RegisterDifferentLength_I16_32_64_VRSUBHN_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I16_32_64_VSUBHN VectorBinary3RegisterDifferentLength_I16_32_64_VSUBHN_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I8_16_32_VADDL_VADDW VectorBinary3RegisterDifferentLength_I8_16_32_VADDL_VADDW_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I8_16_32_VSUBL_VSUBW VectorBinary3RegisterDifferentLength_I8_16_32_VSUBL_VSUBW_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I8_16_32L_VABAL_A2 VectorBinary3RegisterDifferentLength_I8_16_32L_VABAL_A2_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I8_16_32L_VABDL_integer_A2 VectorBinary3RegisterDifferentLength_I8_16_32L_VABDL_integer_A2_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I8_16_32L_VMLAL_VMLSL_integer_A2 VectorBinary3RegisterDifferentLength_I8_16_32L_VMLAL_VMLSL_integer_A2_instance_;
  const NamedVectorBinary3RegisterDifferentLength_I8_16_32L_VMULL_integer_A2 VectorBinary3RegisterDifferentLength_I8_16_32L_VMULL_integer_A2_instance_;
  const NamedVectorBinary3RegisterDifferentLength_P8_VMULL_polynomial_A2 VectorBinary3RegisterDifferentLength_P8_VMULL_polynomial_A2_instance_;
  const NamedVectorBinary3RegisterImmOp_Vext_Rule_305_A1_P598 VectorBinary3RegisterImmOp_Vext_Rule_305_A1_P598_instance_;
  const NamedVectorBinary3RegisterLookupOp_Vtbl_Vtbx_Rule_406_A1_P798 VectorBinary3RegisterLookupOp_Vtbl_Vtbx_Rule_406_A1_P798_instance_;
  const NamedVectorBinary3RegisterSameLength32P_VPADD_floating_point VectorBinary3RegisterSameLength32P_VPADD_floating_point_instance_;
  const NamedVectorBinary3RegisterSameLength32P_VPMAX VectorBinary3RegisterSameLength32P_VPMAX_instance_;
  const NamedVectorBinary3RegisterSameLength32P_VPMIN VectorBinary3RegisterSameLength32P_VPMIN_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VABD_floating_point VectorBinary3RegisterSameLength32_DQ_VABD_floating_point_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VACGE VectorBinary3RegisterSameLength32_DQ_VACGE_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VACGT VectorBinary3RegisterSameLength32_DQ_VACGT_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VADD_floating_point_A1 VectorBinary3RegisterSameLength32_DQ_VADD_floating_point_A1_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VCEQ_register_A2 VectorBinary3RegisterSameLength32_DQ_VCEQ_register_A2_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VCGE_register_A2 VectorBinary3RegisterSameLength32_DQ_VCGE_register_A2_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VCGT_register_A2 VectorBinary3RegisterSameLength32_DQ_VCGT_register_A2_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VFMA_A1 VectorBinary3RegisterSameLength32_DQ_VFMA_A1_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VFMS_A1 VectorBinary3RegisterSameLength32_DQ_VFMS_A1_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VMAX_floating_point VectorBinary3RegisterSameLength32_DQ_VMAX_floating_point_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VMIN_floating_point VectorBinary3RegisterSameLength32_DQ_VMIN_floating_point_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VMLA_floating_point_A1 VectorBinary3RegisterSameLength32_DQ_VMLA_floating_point_A1_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VMLS_floating_point_A1 VectorBinary3RegisterSameLength32_DQ_VMLS_floating_point_A1_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VMUL_floating_point_A1 VectorBinary3RegisterSameLength32_DQ_VMUL_floating_point_A1_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VRECPS VectorBinary3RegisterSameLength32_DQ_VRECPS_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VRSQRTS VectorBinary3RegisterSameLength32_DQ_VRSQRTS_instance_;
  const NamedVectorBinary3RegisterSameLength32_DQ_VSUB_floating_point_A1 VectorBinary3RegisterSameLength32_DQ_VSUB_floating_point_A1_instance_;
  const NamedVectorBinary3RegisterSameLengthDI_VPADD_integer VectorBinary3RegisterSameLengthDI_VPADD_integer_instance_;
  const NamedVectorBinary3RegisterSameLengthDI_VPMAX VectorBinary3RegisterSameLengthDI_VPMAX_instance_;
  const NamedVectorBinary3RegisterSameLengthDI_VPMIN VectorBinary3RegisterSameLengthDI_VPMIN_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VADD_integer VectorBinary3RegisterSameLengthDQ_VADD_integer_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VAND_register VectorBinary3RegisterSameLengthDQ_VAND_register_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VBIC_register VectorBinary3RegisterSameLengthDQ_VBIC_register_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VBIF VectorBinary3RegisterSameLengthDQ_VBIF_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VBIT VectorBinary3RegisterSameLengthDQ_VBIT_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VBSL VectorBinary3RegisterSameLengthDQ_VBSL_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VEOR VectorBinary3RegisterSameLengthDQ_VEOR_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VORN_register VectorBinary3RegisterSameLengthDQ_VORN_register_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VORR_register_or_VMOV_register_A1 VectorBinary3RegisterSameLengthDQ_VORR_register_or_VMOV_register_A1_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VQADD VectorBinary3RegisterSameLengthDQ_VQADD_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VQRSHL VectorBinary3RegisterSameLengthDQ_VQRSHL_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VQSHL_register VectorBinary3RegisterSameLengthDQ_VQSHL_register_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VQSUB VectorBinary3RegisterSameLengthDQ_VQSUB_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VRSHL VectorBinary3RegisterSameLengthDQ_VRSHL_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VSHL_register VectorBinary3RegisterSameLengthDQ_VSHL_register_instance_;
  const NamedVectorBinary3RegisterSameLengthDQ_VSUB_integer VectorBinary3RegisterSameLengthDQ_VSUB_integer_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI16_32_VQDMULH_A1 VectorBinary3RegisterSameLengthDQI16_32_VQDMULH_A1_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI16_32_VQRDMULH_A1 VectorBinary3RegisterSameLengthDQI16_32_VQRDMULH_A1_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8P_VMUL_polynomial_A1 VectorBinary3RegisterSameLengthDQI8P_VMUL_polynomial_A1_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VABA VectorBinary3RegisterSameLengthDQI8_16_32_VABA_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VABD VectorBinary3RegisterSameLengthDQI8_16_32_VABD_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VCEQ_register_A1 VectorBinary3RegisterSameLengthDQI8_16_32_VCEQ_register_A1_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VCGE_register_A1 VectorBinary3RegisterSameLengthDQI8_16_32_VCGE_register_A1_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VCGT_register_A1 VectorBinary3RegisterSameLengthDQI8_16_32_VCGT_register_A1_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VHADD VectorBinary3RegisterSameLengthDQI8_16_32_VHADD_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VHSUB VectorBinary3RegisterSameLengthDQI8_16_32_VHSUB_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VMAX VectorBinary3RegisterSameLengthDQI8_16_32_VMAX_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VMIN VectorBinary3RegisterSameLengthDQI8_16_32_VMIN_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VMLA_integer_A1 VectorBinary3RegisterSameLengthDQI8_16_32_VMLA_integer_A1_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VMLS_integer_A1 VectorBinary3RegisterSameLengthDQI8_16_32_VMLS_integer_A1_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VMUL_integer_A1 VectorBinary3RegisterSameLengthDQI8_16_32_VMUL_integer_A1_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VRHADD VectorBinary3RegisterSameLengthDQI8_16_32_VRHADD_instance_;
  const NamedVectorBinary3RegisterSameLengthDQI8_16_32_VTST VectorBinary3RegisterSameLengthDQI8_16_32_VTST_instance_;
  const NamedVectorLoadSingle1AllLanes_VLD1_single_element_to_all_lanes VectorLoadSingle1AllLanes_VLD1_single_element_to_all_lanes_instance_;
  const NamedVectorLoadSingle2AllLanes_VLD2_single_2_element_structure_to_all_lanes VectorLoadSingle2AllLanes_VLD2_single_2_element_structure_to_all_lanes_instance_;
  const NamedVectorLoadSingle3AllLanes_VLD3_single_3_element_structure_to_all_lanes VectorLoadSingle3AllLanes_VLD3_single_3_element_structure_to_all_lanes_instance_;
  const NamedVectorLoadSingle4AllLanes_VLD4_single_4_element_structure_to_all_lanes VectorLoadSingle4AllLanes_VLD4_single_4_element_structure_to_all_lanes_instance_;
  const NamedVectorLoadStoreMultiple1_VLD1_multiple_single_elements VectorLoadStoreMultiple1_VLD1_multiple_single_elements_instance_;
  const NamedVectorLoadStoreMultiple1_VST1_multiple_single_elements VectorLoadStoreMultiple1_VST1_multiple_single_elements_instance_;
  const NamedVectorLoadStoreMultiple2_VLD2_multiple_2_element_structures VectorLoadStoreMultiple2_VLD2_multiple_2_element_structures_instance_;
  const NamedVectorLoadStoreMultiple2_VST2_multiple_2_element_structures VectorLoadStoreMultiple2_VST2_multiple_2_element_structures_instance_;
  const NamedVectorLoadStoreMultiple3_VLD3_multiple_3_element_structures VectorLoadStoreMultiple3_VLD3_multiple_3_element_structures_instance_;
  const NamedVectorLoadStoreMultiple3_VST3_multiple_3_element_structures VectorLoadStoreMultiple3_VST3_multiple_3_element_structures_instance_;
  const NamedVectorLoadStoreMultiple4_VLD4_multiple_4_element_structures VectorLoadStoreMultiple4_VLD4_multiple_4_element_structures_instance_;
  const NamedVectorLoadStoreMultiple4_VST4_multiple_4_element_structures VectorLoadStoreMultiple4_VST4_multiple_4_element_structures_instance_;
  const NamedVectorLoadStoreSingle1_VLD1_single_element_to_one_lane VectorLoadStoreSingle1_VLD1_single_element_to_one_lane_instance_;
  const NamedVectorLoadStoreSingle1_VST1_single_element_from_one_lane VectorLoadStoreSingle1_VST1_single_element_from_one_lane_instance_;
  const NamedVectorLoadStoreSingle2_VLD2_single_2_element_structure_to_one_lane VectorLoadStoreSingle2_VLD2_single_2_element_structure_to_one_lane_instance_;
  const NamedVectorLoadStoreSingle2_VST2_single_2_element_structure_from_one_lane VectorLoadStoreSingle2_VST2_single_2_element_structure_from_one_lane_instance_;
  const NamedVectorLoadStoreSingle3_VLD3_single_3_element_structure_to_one_lane VectorLoadStoreSingle3_VLD3_single_3_element_structure_to_one_lane_instance_;
  const NamedVectorLoadStoreSingle3_VST3_single_3_element_structure_from_one_lane VectorLoadStoreSingle3_VST3_single_3_element_structure_from_one_lane_instance_;
  const NamedVectorLoadStoreSingle4_VLD4_single_4_element_structure_to_one_lane VectorLoadStoreSingle4_VLD4_single_4_element_structure_to_one_lane_instance_;
  const NamedVectorLoadStoreSingle4_VST4_single_4_element_structure_form_one_lane VectorLoadStoreSingle4_VST4_single_4_element_structure_form_one_lane_instance_;
  const NamedVectorUnary2RegisterDup_Vdup_Rule_302_A1_P592 VectorUnary2RegisterDup_Vdup_Rule_302_A1_P592_instance_;
  const NamedVfpMrsOp_VMRS VfpMrsOp_VMRS_instance_;
  const NamedVfpUsesRegOp_VMSR VfpUsesRegOp_VMSR_instance_;
  const NamedActual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_ADC_immediate Actual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_ADC_immediate_instance_;
  const NamedActual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_AND_immediate Actual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_AND_immediate_instance_;
  const NamedActual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_EOR_immediate Actual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_EOR_immediate_instance_;
  const NamedActual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_RSB_immediate Actual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_RSB_immediate_instance_;
  const NamedActual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_RSC_immediate Actual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_RSC_immediate_instance_;
  const NamedActual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_SBC_immediate Actual_ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_1_SBC_immediate_instance_;
  const NamedActual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_ADC_register Actual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_ADC_register_instance_;
  const NamedActual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_ADD_register Actual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_ADD_register_instance_;
  const NamedActual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_AND_register Actual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_AND_register_instance_;
  const NamedActual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_BIC_register Actual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_BIC_register_instance_;
  const NamedActual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_EOR_register Actual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_EOR_register_instance_;
  const NamedActual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_ORR_register Actual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_ORR_register_instance_;
  const NamedActual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_RSB_register Actual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_RSB_register_instance_;
  const NamedActual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_RSC_register Actual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_RSC_register_instance_;
  const NamedActual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_SBC_register Actual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_SBC_register_instance_;
  const NamedActual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_SUB_register Actual_ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_1_SUB_register_instance_;
  const NamedActual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_ADC_register_shifted_register Actual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_ADC_register_shifted_register_instance_;
  const NamedActual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_ADD_register_shifted_register Actual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_ADD_register_shifted_register_instance_;
  const NamedActual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_AND_register_shifted_register Actual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_AND_register_shifted_register_instance_;
  const NamedActual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_BIC_register_shifted_register Actual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_BIC_register_shifted_register_instance_;
  const NamedActual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_EOR_register_shifted_register Actual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_EOR_register_shifted_register_instance_;
  const NamedActual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_ORR_register_shifted_register Actual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_ORR_register_shifted_register_instance_;
  const NamedActual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_RSB_register_shfited_register Actual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_RSB_register_shfited_register_instance_;
  const NamedActual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_RSC_register_shifted_register Actual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_RSC_register_shifted_register_instance_;
  const NamedActual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_SBC_register_shifted_register Actual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_SBC_register_shifted_register_instance_;
  const NamedActual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_SUB_register_shifted_register Actual_ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_1_SUB_register_shifted_register_instance_;
  const NamedActual_ADD_immediate_cccc0010100snnnnddddiiiiiiiiiiii_case_1_ADD_immediate Actual_ADD_immediate_cccc0010100snnnnddddiiiiiiiiiiii_case_1_ADD_immediate_instance_;
  const NamedActual_ADD_immediate_cccc0010100snnnnddddiiiiiiiiiiii_case_1_SUB_immediate Actual_ADD_immediate_cccc0010100snnnnddddiiiiiiiiiiii_case_1_SUB_immediate_instance_;
  const NamedActual_ADR_A1_cccc001010001111ddddiiiiiiiiiiii_case_1_ADR_A1 Actual_ADR_A1_cccc001010001111ddddiiiiiiiiiiii_case_1_ADR_A1_instance_;
  const NamedActual_ADR_A1_cccc001010001111ddddiiiiiiiiiiii_case_1_ADR_A2 Actual_ADR_A1_cccc001010001111ddddiiiiiiiiiiii_case_1_ADR_A2_instance_;
  const NamedActual_ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_1_ASR_immediate Actual_ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_1_ASR_immediate_instance_;
  const NamedActual_ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_1_LSR_immediate Actual_ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_1_LSR_immediate_instance_;
  const NamedActual_ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_1_MOV_register Actual_ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_1_MOV_register_instance_;
  const NamedActual_ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_1_MVN_register Actual_ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_1_MVN_register_instance_;
  const NamedActual_ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_1_RRX Actual_ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_1_RRX_instance_;
  const NamedActual_ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_1_ASR_register Actual_ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_1_ASR_register_instance_;
  const NamedActual_ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_1_LSL_register Actual_ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_1_LSL_register_instance_;
  const NamedActual_ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_1_LSR_register Actual_ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_1_LSR_register_instance_;
  const NamedActual_ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_1_MVN_register_shifted_register Actual_ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_1_MVN_register_shifted_register_instance_;
  const NamedActual_ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_1_ROR_register Actual_ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_1_ROR_register_instance_;
  const NamedActual_BIC_immediate_cccc0011110snnnnddddiiiiiiiiiiii_case_1_BIC_immediate Actual_BIC_immediate_cccc0011110snnnnddddiiiiiiiiiiii_case_1_BIC_immediate_instance_;
  const NamedActual_BKPT_cccc00010010iiiiiiiiiiii0111iiii_case_1_BKPT Actual_BKPT_cccc00010010iiiiiiiiiiii0111iiii_case_1_BKPT_instance_;
  const NamedActual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_DBG Actual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_DBG_instance_;
  const NamedActual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_MSR_immediate Actual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_MSR_immediate_instance_;
  const NamedActual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_SEV Actual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_SEV_instance_;
  const NamedActual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_WFE Actual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_WFE_instance_;
  const NamedActual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_WFI Actual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_WFI_instance_;
  const NamedActual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_None Actual_BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_1_None_instance_;
  const NamedActual_BLX_register_cccc000100101111111111110011mmmm_case_1_BLX_register Actual_BLX_register_cccc000100101111111111110011mmmm_case_1_BLX_register_instance_;
  const NamedActual_Bx_cccc000100101111111111110001mmmm_case_1_Bx Actual_Bx_cccc000100101111111111110001mmmm_case_1_Bx_instance_;
  const NamedActual_CLZ_cccc000101101111dddd11110001mmmm_case_1_CLZ Actual_CLZ_cccc000101101111dddd11110001mmmm_case_1_CLZ_instance_;
  const NamedActual_CMN_immediate_cccc00110111nnnn0000iiiiiiiiiiii_case_1_CMN_immediate Actual_CMN_immediate_cccc00110111nnnn0000iiiiiiiiiiii_case_1_CMN_immediate_instance_;
  const NamedActual_CMN_immediate_cccc00110111nnnn0000iiiiiiiiiiii_case_1_CMP_immediate Actual_CMN_immediate_cccc00110111nnnn0000iiiiiiiiiiii_case_1_CMP_immediate_instance_;
  const NamedActual_CMN_immediate_cccc00110111nnnn0000iiiiiiiiiiii_case_1_TEQ_immediate Actual_CMN_immediate_cccc00110111nnnn0000iiiiiiiiiiii_case_1_TEQ_immediate_instance_;
  const NamedActual_CMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_1_CMN_register Actual_CMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_1_CMN_register_instance_;
  const NamedActual_CMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_1_CMP_register Actual_CMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_1_CMP_register_instance_;
  const NamedActual_CMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_1_TEQ_register Actual_CMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_1_TEQ_register_instance_;
  const NamedActual_CMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_1_TST_register Actual_CMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_1_TST_register_instance_;
  const NamedActual_CMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_1_CMN_register_shifted_register Actual_CMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_1_CMN_register_shifted_register_instance_;
  const NamedActual_CMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_1_CMP_register_shifted_register Actual_CMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_1_CMP_register_shifted_register_instance_;
  const NamedActual_CMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_1_TEQ_register_shifted_register Actual_CMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_1_TEQ_register_shifted_register_instance_;
  const NamedActual_CMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_1_TST_register_shifted_register Actual_CMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_1_TST_register_shifted_register_instance_;
  const NamedActual_LDRD_immediate_cccc000pu1w0nnnnttttiiii1101iiii_case_1_LDRD_immediate Actual_LDRD_immediate_cccc000pu1w0nnnnttttiiii1101iiii_case_1_LDRD_immediate_instance_;
  const NamedActual_LDRD_literal_cccc0001u1001111ttttiiii1101iiii_case_1_LDRD_literal Actual_LDRD_literal_cccc0001u1001111ttttiiii1101iiii_case_1_LDRD_literal_instance_;
  const NamedActual_LDRD_register_cccc000pu0w0nnnntttt00001101mmmm_case_1_LDRD_register Actual_LDRD_register_cccc000pu0w0nnnntttt00001101mmmm_case_1_LDRD_register_instance_;
  const NamedActual_LDREXB_cccc00011101nnnntttt111110011111_case_1_LDREX Actual_LDREXB_cccc00011101nnnntttt111110011111_case_1_LDREX_instance_;
  const NamedActual_LDREXB_cccc00011101nnnntttt111110011111_case_1_LDREXB Actual_LDREXB_cccc00011101nnnntttt111110011111_case_1_LDREXB_instance_;
  const NamedActual_LDREXB_cccc00011101nnnntttt111110011111_case_1_STREXH Actual_LDREXB_cccc00011101nnnntttt111110011111_case_1_STREXH_instance_;
  const NamedActual_LDREXD_cccc00011011nnnntttt111110011111_case_1_LDREXD Actual_LDREXD_cccc00011011nnnntttt111110011111_case_1_LDREXD_instance_;
  const NamedActual_LDRH_immediate_cccc000pu1w1nnnnttttiiii1011iiii_case_1_LDRH_immediate Actual_LDRH_immediate_cccc000pu1w1nnnnttttiiii1011iiii_case_1_LDRH_immediate_instance_;
  const NamedActual_LDRH_immediate_cccc000pu1w1nnnnttttiiii1011iiii_case_1_LDRSB_immediate Actual_LDRH_immediate_cccc000pu1w1nnnnttttiiii1011iiii_case_1_LDRSB_immediate_instance_;
  const NamedActual_LDRH_immediate_cccc000pu1w1nnnnttttiiii1011iiii_case_1_LDRSH_immediate Actual_LDRH_immediate_cccc000pu1w1nnnnttttiiii1011iiii_case_1_LDRSH_immediate_instance_;
  const NamedActual_LDRH_literal_cccc000pu1w11111ttttiiii1011iiii_case_1_LDRH_literal Actual_LDRH_literal_cccc000pu1w11111ttttiiii1011iiii_case_1_LDRH_literal_instance_;
  const NamedActual_LDRH_literal_cccc000pu1w11111ttttiiii1011iiii_case_1_LDRSB_literal Actual_LDRH_literal_cccc000pu1w11111ttttiiii1011iiii_case_1_LDRSB_literal_instance_;
  const NamedActual_LDRH_register_cccc000pu0w1nnnntttt00001011mmmm_case_1_LDRH_register Actual_LDRH_register_cccc000pu0w1nnnntttt00001011mmmm_case_1_LDRH_register_instance_;
  const NamedActual_LDRH_register_cccc000pu0w1nnnntttt00001011mmmm_case_1_LDRSB_register Actual_LDRH_register_cccc000pu0w1nnnntttt00001011mmmm_case_1_LDRSB_register_instance_;
  const NamedActual_LDRH_register_cccc000pu0w1nnnntttt00001011mmmm_case_1_LDRSH_register Actual_LDRH_register_cccc000pu0w1nnnntttt00001011mmmm_case_1_LDRSH_register_instance_;
  const NamedActual_LSL_immediate_cccc0001101s0000ddddiiiii000mmmm_case_1_LSL_immediate Actual_LSL_immediate_cccc0001101s0000ddddiiiii000mmmm_case_1_LSL_immediate_instance_;
  const NamedActual_LSL_immediate_cccc0001101s0000ddddiiiii000mmmm_case_1_ROR_immediate Actual_LSL_immediate_cccc0001101s0000ddddiiiii000mmmm_case_1_ROR_immediate_instance_;
  const NamedActual_MLA_A1_cccc0000001sddddaaaammmm1001nnnn_case_1_MLA_A1 Actual_MLA_A1_cccc0000001sddddaaaammmm1001nnnn_case_1_MLA_A1_instance_;
  const NamedActual_MLS_A1_cccc00000110ddddaaaammmm1001nnnn_case_1_MLS_A1 Actual_MLS_A1_cccc00000110ddddaaaammmm1001nnnn_case_1_MLS_A1_instance_;
  const NamedActual_MLS_A1_cccc00000110ddddaaaammmm1001nnnn_case_1_SMLABB_SMLABT_SMLATB_SMLATT Actual_MLS_A1_cccc00000110ddddaaaammmm1001nnnn_case_1_SMLABB_SMLABT_SMLATB_SMLATT_instance_;
  const NamedActual_MLS_A1_cccc00000110ddddaaaammmm1001nnnn_case_1_SMLAWB_SMLAWT Actual_MLS_A1_cccc00000110ddddaaaammmm1001nnnn_case_1_SMLAWB_SMLAWT_instance_;
  const NamedActual_MOVT_cccc00110100iiiiddddiiiiiiiiiiii_case_1_MOVT Actual_MOVT_cccc00110100iiiiddddiiiiiiiiiiii_case_1_MOVT_instance_;
  const NamedActual_MOVT_cccc00110100iiiiddddiiiiiiiiiiii_case_1_MOVW Actual_MOVT_cccc00110100iiiiddddiiiiiiiiiiii_case_1_MOVW_instance_;
  const NamedActual_MOV_immediate_A1_cccc0011101s0000ddddiiiiiiiiiiii_case_1_MOV_immediate_A1 Actual_MOV_immediate_A1_cccc0011101s0000ddddiiiiiiiiiiii_case_1_MOV_immediate_A1_instance_;
  const NamedActual_MOV_immediate_A1_cccc0011101s0000ddddiiiiiiiiiiii_case_1_MVN_immediate Actual_MOV_immediate_A1_cccc0011101s0000ddddiiiiiiiiiiii_case_1_MVN_immediate_instance_;
  const NamedActual_MRS_cccc00010r001111dddd000000000000_case_1_MRS Actual_MRS_cccc00010r001111dddd000000000000_case_1_MRS_instance_;
  const NamedActual_MSR_immediate_cccc00110010mm001111iiiiiiiiiiii_case_1_MSR_immediate Actual_MSR_immediate_cccc00110010mm001111iiiiiiiiiiii_case_1_MSR_immediate_instance_;
  const NamedActual_MSR_register_cccc00010010mm00111100000000nnnn_case_1_MSR_register Actual_MSR_register_cccc00010010mm00111100000000nnnn_case_1_MSR_register_instance_;
  const NamedActual_MUL_A1_cccc0000000sdddd0000mmmm1001nnnn_case_1_MUL_A1 Actual_MUL_A1_cccc0000000sdddd0000mmmm1001nnnn_case_1_MUL_A1_instance_;
  const NamedActual_NOP_cccc0011001000001111000000000000_case_1_NOP Actual_NOP_cccc0011001000001111000000000000_case_1_NOP_instance_;
  const NamedActual_NOP_cccc0011001000001111000000000000_case_1_YIELD Actual_NOP_cccc0011001000001111000000000000_case_1_YIELD_instance_;
  const NamedActual_ORR_immediate_cccc0011100snnnnddddiiiiiiiiiiii_case_1_ORR_immediate Actual_ORR_immediate_cccc0011100snnnnddddiiiiiiiiiiii_case_1_ORR_immediate_instance_;
  const NamedActual_PKH_cccc01101000nnnnddddiiiiit01mmmm_case_1_QADD Actual_PKH_cccc01101000nnnnddddiiiiit01mmmm_case_1_QADD_instance_;
  const NamedActual_PKH_cccc01101000nnnnddddiiiiit01mmmm_case_1_QDADD Actual_PKH_cccc01101000nnnnddddiiiiit01mmmm_case_1_QDADD_instance_;
  const NamedActual_PKH_cccc01101000nnnnddddiiiiit01mmmm_case_1_QDSUB Actual_PKH_cccc01101000nnnnddddiiiiit01mmmm_case_1_QDSUB_instance_;
  const NamedActual_PKH_cccc01101000nnnnddddiiiiit01mmmm_case_1_QSUB Actual_PKH_cccc01101000nnnnddddiiiiit01mmmm_case_1_QSUB_instance_;
  const NamedActual_SMLALBB_SMLALBT_SMLALTB_SMLALTT_cccc00010100hhhhllllmmmm1xx0nnnn_case_1_SMLALBB_SMLALBT_SMLALTB_SMLALTT Actual_SMLALBB_SMLALBT_SMLALTB_SMLALTT_cccc00010100hhhhllllmmmm1xx0nnnn_case_1_SMLALBB_SMLALBT_SMLALTB_SMLALTT_instance_;
  const NamedActual_SMLALBB_SMLALBT_SMLALTB_SMLALTT_cccc00010100hhhhllllmmmm1xx0nnnn_case_1_UMAAL_A1 Actual_SMLALBB_SMLALBT_SMLALTB_SMLALTT_cccc00010100hhhhllllmmmm1xx0nnnn_case_1_UMAAL_A1_instance_;
  const NamedActual_SMLAL_A1_cccc0000111shhhhllllmmmm1001nnnn_case_1_SMLAL_A1 Actual_SMLAL_A1_cccc0000111shhhhllllmmmm1001nnnn_case_1_SMLAL_A1_instance_;
  const NamedActual_SMLAL_A1_cccc0000111shhhhllllmmmm1001nnnn_case_1_UMLAL_A1 Actual_SMLAL_A1_cccc0000111shhhhllllmmmm1001nnnn_case_1_UMLAL_A1_instance_;
  const NamedActual_SMULBB_SMULBT_SMULTB_SMULTT_cccc00010110dddd0000mmmm1xx0nnnn_case_1_SMULBB_SMULBT_SMULTB_SMULTT Actual_SMULBB_SMULBT_SMULTB_SMULTT_cccc00010110dddd0000mmmm1xx0nnnn_case_1_SMULBB_SMULBT_SMULTB_SMULTT_instance_;
  const NamedActual_SMULBB_SMULBT_SMULTB_SMULTT_cccc00010110dddd0000mmmm1xx0nnnn_case_1_SMULWB_SMULWT Actual_SMULBB_SMULBT_SMULTB_SMULTT_cccc00010110dddd0000mmmm1xx0nnnn_case_1_SMULWB_SMULWT_instance_;
  const NamedActual_SMULL_A1_cccc0000110shhhhllllmmmm1001nnnn_case_1_SMULL_A1 Actual_SMULL_A1_cccc0000110shhhhllllmmmm1001nnnn_case_1_SMULL_A1_instance_;
  const NamedActual_SMULL_A1_cccc0000110shhhhllllmmmm1001nnnn_case_1_UMULL_A1 Actual_SMULL_A1_cccc0000110shhhhllllmmmm1001nnnn_case_1_UMULL_A1_instance_;
  const NamedActual_STRD_immediate_cccc000pu1w0nnnnttttiiii1111iiii_case_1_STRD_immediate Actual_STRD_immediate_cccc000pu1w0nnnnttttiiii1111iiii_case_1_STRD_immediate_instance_;
  const NamedActual_STRD_register_cccc000pu0w0nnnntttt00001111mmmm_case_1_STRD_register Actual_STRD_register_cccc000pu0w0nnnntttt00001111mmmm_case_1_STRD_register_instance_;
  const NamedActual_STREXB_cccc00011100nnnndddd11111001tttt_case_1_STREX Actual_STREXB_cccc00011100nnnndddd11111001tttt_case_1_STREX_instance_;
  const NamedActual_STREXB_cccc00011100nnnndddd11111001tttt_case_1_STREXB Actual_STREXB_cccc00011100nnnndddd11111001tttt_case_1_STREXB_instance_;
  const NamedActual_STREXB_cccc00011100nnnndddd11111001tttt_case_1_STREXH Actual_STREXB_cccc00011100nnnndddd11111001tttt_case_1_STREXH_instance_;
  const NamedActual_STREXD_cccc00011010nnnndddd11111001tttt_case_1_STREXD Actual_STREXD_cccc00011010nnnndddd11111001tttt_case_1_STREXD_instance_;
  const NamedActual_STRH_immediate_cccc000pu1w0nnnnttttiiii1011iiii_case_1_STRH_immediate Actual_STRH_immediate_cccc000pu1w0nnnnttttiiii1011iiii_case_1_STRH_immediate_instance_;
  const NamedActual_STRH_register_cccc000pu0w0nnnntttt00001011mmmm_case_1_STRH_register Actual_STRH_register_cccc000pu0w0nnnntttt00001011mmmm_case_1_STRH_register_instance_;
  const NamedActual_TST_immediate_cccc00110001nnnn0000iiiiiiiiiiii_case_1_TST_immediate Actual_TST_immediate_cccc00110001nnnn0000iiiiiiiiiiii_case_1_TST_immediate_instance_;
  const NamedActual_Unnamed_case_1_None Actual_Unnamed_case_1_None_instance_;
  const NamedForbidden_BXJ Forbidden_BXJ_instance_;
  const NamedForbidden_ERET Forbidden_ERET_instance_;
  const NamedForbidden_HVC Forbidden_HVC_instance_;
  const NamedForbidden_MRS_Banked_register Forbidden_MRS_Banked_register_instance_;
  const NamedForbidden_MSR_Banked_register Forbidden_MSR_Banked_register_instance_;
  const NamedForbidden_MSR_register Forbidden_MSR_register_instance_;
  const NamedForbidden_SMC Forbidden_SMC_instance_;
 private:

  // The following list of methods correspond to each decoder table,
  // and implements the pattern matching of the corresponding bit
  // patterns. After matching the corresponding bit patterns, they
  // either call other methods in this list (corresponding to another
  // decoder table), or they return the instance field that implements
  // the class decoder that should be used to decode the particular
  // instruction.
  inline const NamedClassDecoder& decode_ARMv7(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_advanced_simd_data_processing_instructions(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_advanced_simd_element_or_structure_load_store_instructions(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_branch_branch_with_link_and_block_data_transfer(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_coprocessor_instructions_and_supervisor_call(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_data_processing_and_miscellaneous_instructions(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_data_processing_immediate(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_data_processing_register(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_data_processing_register_shifted_register(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_extension_register_load_store_instructions(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_extra_load_store_instructions(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_floating_point_data_processing_instructions(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_halfword_multiply_and_multiply_accumulate(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_load_store_word_and_unsigned_byte(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_media_instructions(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_memory_hints_advanced_simd_instructions_and_miscellaneous_instructions(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_miscellaneous_instructions(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_msr_immediate_and_hints(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_multiply_and_multiply_accumulate(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_other_floating_point_data_processing_instructions(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_packing_unpacking_saturation_and_reversal(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_parallel_addition_and_subtraction_signed(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_parallel_addition_and_subtraction_unsigned(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_saturating_addition_and_subtraction(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_signed_multiply_signed_and_unsigned_divide(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_simd_dp_1imm(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_simd_dp_2misc(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_simd_dp_2scalar(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_simd_dp_2shift(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_simd_dp_3diff(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_simd_dp_3same(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_synchronization_primitives(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_transfer_between_arm_core_and_extension_register_8_16_and_32_bit(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_transfer_between_arm_core_and_extension_registers_64_bit(
      const nacl_arm_dec::Instruction inst) const;
  inline const NamedClassDecoder& decode_unconditional_instructions(
      const nacl_arm_dec::Instruction inst) const;
  // Defines default action if parse tables don't define what action
  // to take.
  const NotImplementedNamed not_implemented_;
};

} // namespace nacl_arm_test
#endif  // NATIVE_CLIENT_SRC_TRUSTED_VALIDATOR_ARM_GEN_ARM32_DECODE_NAMED_DECODER_H_
