/*
 * Copyright 2013 The Native Client Authors.  All rights reserved.
 * Use of this source code is governed by a BSD-style license that can
 * be found in the LICENSE file.
 */

// DO NOT EDIT: GENERATED CODE

#ifndef NACL_TRUSTED_BUT_NOT_TCB
#error This file is not meant for use in the TCB
#endif


#ifndef NATIVE_CLIENT_SRC_TRUSTED_VALIDATOR_ARM_GEN_ARM32_DECODE_NAMED_BASES_H_
#define NATIVE_CLIENT_SRC_TRUSTED_VALIDATOR_ARM_GEN_ARM32_DECODE_NAMED_BASES_H_

#include "native_client/src/trusted/validator_arm/actual_classes.h"
#include "native_client/src/trusted/validator_arm/baseline_classes.h"
#include "native_client/src/trusted/validator_arm/named_class_decoder.h"
#include "native_client/src/trusted/validator_arm/gen/arm32_decode_baselines.h"

namespace nacl_arm_test {

/*
 * Define named class decoders for each automatically generated baseline
 * decoder.
 */
class NamedADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::ADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedADC_immediate_cccc0010101snnnnddddiiiiiiiiiiii_case_0);
};

class NamedADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::ADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedADC_register_cccc0000101snnnnddddiiiiitt0mmmm_case_0);
};

class NamedADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::ADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedADC_register_shifted_register_cccc0000101snnnnddddssss0tt1mmmm_case_0);
};

class NamedADD_immediate_cccc0010100snnnnddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedADD_immediate_cccc0010100snnnnddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "ADD_immediate_cccc0010100snnnnddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::ADD_immediate_cccc0010100snnnnddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedADD_immediate_cccc0010100snnnnddddiiiiiiiiiiii_case_0);
};

class NamedADD_register_cccc0000100snnnnddddiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedADD_register_cccc0000100snnnnddddiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "ADD_register_cccc0000100snnnnddddiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::ADD_register_cccc0000100snnnnddddiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedADD_register_cccc0000100snnnnddddiiiiitt0mmmm_case_0);
};

class NamedADD_register_shifted_register_cccc0000100snnnnddddssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedADD_register_shifted_register_cccc0000100snnnnddddssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "ADD_register_shifted_register_cccc0000100snnnnddddssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::ADD_register_shifted_register_cccc0000100snnnnddddssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedADD_register_shifted_register_cccc0000100snnnnddddssss0tt1mmmm_case_0);
};

class NamedADR_A1_cccc001010001111ddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedADR_A1_cccc001010001111ddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "ADR_A1_cccc001010001111ddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::ADR_A1_cccc001010001111ddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedADR_A1_cccc001010001111ddddiiiiiiiiiiii_case_0);
};

class NamedADR_A2_cccc001001001111ddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedADR_A2_cccc001001001111ddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "ADR_A2_cccc001001001111ddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::ADR_A2_cccc001001001111ddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedADR_A2_cccc001001001111ddddiiiiiiiiiiii_case_0);
};

class NamedAND_immediate_cccc0010000snnnnddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedAND_immediate_cccc0010000snnnnddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "AND_immediate_cccc0010000snnnnddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::AND_immediate_cccc0010000snnnnddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedAND_immediate_cccc0010000snnnnddddiiiiiiiiiiii_case_0);
};

class NamedAND_register_cccc0000000snnnnddddiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedAND_register_cccc0000000snnnnddddiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "AND_register_cccc0000000snnnnddddiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::AND_register_cccc0000000snnnnddddiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedAND_register_cccc0000000snnnnddddiiiiitt0mmmm_case_0);
};

class NamedAND_register_shifted_register_cccc0000000snnnnddddssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedAND_register_shifted_register_cccc0000000snnnnddddssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "AND_register_shifted_register_cccc0000000snnnnddddssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::AND_register_shifted_register_cccc0000000snnnnddddssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedAND_register_shifted_register_cccc0000000snnnnddddssss0tt1mmmm_case_0);
};

class NamedASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_0()
    : NamedClassDecoder(decoder_, "ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_0")
  {}

 private:
  nacl_arm_dec::ASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedASR_immediate_cccc0001101s0000ddddiiiii100mmmm_case_0);
};

class NamedASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_0()
    : NamedClassDecoder(decoder_, "ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_0")
  {}

 private:
  nacl_arm_dec::ASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedASR_register_cccc0001101s0000ddddmmmm0101nnnn_case_0);
};

class NamedBFC_cccc0111110mmmmmddddlllll0011111_case_0
    : public NamedClassDecoder {
 public:
  NamedBFC_cccc0111110mmmmmddddlllll0011111_case_0()
    : NamedClassDecoder(decoder_, "BFC_cccc0111110mmmmmddddlllll0011111_case_0")
  {}

 private:
  nacl_arm_dec::BFC_cccc0111110mmmmmddddlllll0011111_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedBFC_cccc0111110mmmmmddddlllll0011111_case_0);
};

class NamedBFI_cccc0111110mmmmmddddlllll001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedBFI_cccc0111110mmmmmddddlllll001nnnn_case_0()
    : NamedClassDecoder(decoder_, "BFI_cccc0111110mmmmmddddlllll001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::BFI_cccc0111110mmmmmddddlllll001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedBFI_cccc0111110mmmmmddddlllll001nnnn_case_0);
};

class NamedBIC_immediate_cccc0011110snnnnddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedBIC_immediate_cccc0011110snnnnddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "BIC_immediate_cccc0011110snnnnddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::BIC_immediate_cccc0011110snnnnddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedBIC_immediate_cccc0011110snnnnddddiiiiiiiiiiii_case_0);
};

class NamedBIC_register_cccc0001110snnnnddddiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedBIC_register_cccc0001110snnnnddddiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "BIC_register_cccc0001110snnnnddddiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::BIC_register_cccc0001110snnnnddddiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedBIC_register_cccc0001110snnnnddddiiiiitt0mmmm_case_0);
};

class NamedBIC_register_shifted_register_cccc0001110snnnnddddssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedBIC_register_shifted_register_cccc0001110snnnnddddssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "BIC_register_shifted_register_cccc0001110snnnnddddssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::BIC_register_shifted_register_cccc0001110snnnnddddssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedBIC_register_shifted_register_cccc0001110snnnnddddssss0tt1mmmm_case_0);
};

class NamedBKPT_cccc00010010iiiiiiiiiiii0111iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedBKPT_cccc00010010iiiiiiiiiiii0111iiii_case_0()
    : NamedClassDecoder(decoder_, "BKPT_cccc00010010iiiiiiiiiiii0111iiii_case_0")
  {}

 private:
  nacl_arm_dec::BKPT_cccc00010010iiiiiiiiiiii0111iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedBKPT_cccc00010010iiiiiiiiiiii0111iiii_case_0);
};

class NamedBLX_register_cccc000100101111111111110011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedBLX_register_cccc000100101111111111110011mmmm_case_0()
    : NamedClassDecoder(decoder_, "BLX_register_cccc000100101111111111110011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::BLX_register_cccc000100101111111111110011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedBLX_register_cccc000100101111111111110011mmmm_case_0);
};

class NamedBL_BLX_immediate_cccc1011iiiiiiiiiiiiiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedBL_BLX_immediate_cccc1011iiiiiiiiiiiiiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "BL_BLX_immediate_cccc1011iiiiiiiiiiiiiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::BL_BLX_immediate_cccc1011iiiiiiiiiiiiiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedBL_BLX_immediate_cccc1011iiiiiiiiiiiiiiiiiiiiiiii_case_0);
};

class NamedB_cccc1010iiiiiiiiiiiiiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedB_cccc1010iiiiiiiiiiiiiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "B_cccc1010iiiiiiiiiiiiiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::B_cccc1010iiiiiiiiiiiiiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedB_cccc1010iiiiiiiiiiiiiiiiiiiiiiii_case_0);
};

class NamedBx_cccc000100101111111111110001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedBx_cccc000100101111111111110001mmmm_case_0()
    : NamedClassDecoder(decoder_, "Bx_cccc000100101111111111110001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::Bx_cccc000100101111111111110001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedBx_cccc000100101111111111110001mmmm_case_0);
};

class NamedCLZ_cccc000101101111dddd11110001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedCLZ_cccc000101101111dddd11110001mmmm_case_0()
    : NamedClassDecoder(decoder_, "CLZ_cccc000101101111dddd11110001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::CLZ_cccc000101101111dddd11110001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCLZ_cccc000101101111dddd11110001mmmm_case_0);
};

class NamedCMN_immediate_cccc00110111nnnn0000iiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedCMN_immediate_cccc00110111nnnn0000iiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "CMN_immediate_cccc00110111nnnn0000iiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::CMN_immediate_cccc00110111nnnn0000iiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCMN_immediate_cccc00110111nnnn0000iiiiiiiiiiii_case_0);
};

class NamedCMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedCMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "CMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::CMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCMN_register_cccc00010111nnnn0000iiiiitt0mmmm_case_0);
};

class NamedCMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedCMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "CMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::CMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCMN_register_shifted_register_cccc00010111nnnn0000ssss0tt1mmmm_case_0);
};

class NamedCMP_immediate_cccc00110101nnnn0000iiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedCMP_immediate_cccc00110101nnnn0000iiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "CMP_immediate_cccc00110101nnnn0000iiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::CMP_immediate_cccc00110101nnnn0000iiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCMP_immediate_cccc00110101nnnn0000iiiiiiiiiiii_case_0);
};

class NamedCMP_register_cccc00010101nnnn0000iiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedCMP_register_cccc00010101nnnn0000iiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "CMP_register_cccc00010101nnnn0000iiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::CMP_register_cccc00010101nnnn0000iiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCMP_register_cccc00010101nnnn0000iiiiitt0mmmm_case_0);
};

class NamedCMP_register_shifted_register_cccc00010101nnnn0000ssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedCMP_register_shifted_register_cccc00010101nnnn0000ssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "CMP_register_shifted_register_cccc00010101nnnn0000ssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::CMP_register_shifted_register_cccc00010101nnnn0000ssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCMP_register_shifted_register_cccc00010101nnnn0000ssss0tt1mmmm_case_0);
};

class NamedCVT_between_half_precision_and_single_precision_111100111d11ss10dddd011p00m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedCVT_between_half_precision_and_single_precision_111100111d11ss10dddd011p00m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "CVT_between_half_precision_and_single_precision_111100111d11ss10dddd011p00m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::CVT_between_half_precision_and_single_precision_111100111d11ss10dddd011p00m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCVT_between_half_precision_and_single_precision_111100111d11ss10dddd011p00m0mmmm_case_0);
};

class NamedDBG_cccc001100100000111100001111iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedDBG_cccc001100100000111100001111iiii_case_0()
    : NamedClassDecoder(decoder_, "DBG_cccc001100100000111100001111iiii_case_0")
  {}

 private:
  nacl_arm_dec::DBG_cccc001100100000111100001111iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedDBG_cccc001100100000111100001111iiii_case_0);
};

class NamedDMB_1111010101111111111100000101xxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedDMB_1111010101111111111100000101xxxx_case_0()
    : NamedClassDecoder(decoder_, "DMB_1111010101111111111100000101xxxx_case_0")
  {}

 private:
  nacl_arm_dec::DMB_1111010101111111111100000101xxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedDMB_1111010101111111111100000101xxxx_case_0);
};

class NamedDSB_1111010101111111111100000100xxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedDSB_1111010101111111111100000100xxxx_case_0()
    : NamedClassDecoder(decoder_, "DSB_1111010101111111111100000100xxxx_case_0")
  {}

 private:
  nacl_arm_dec::DSB_1111010101111111111100000100xxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedDSB_1111010101111111111100000100xxxx_case_0);
};

class NamedEOR_immediate_cccc0010001snnnnddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedEOR_immediate_cccc0010001snnnnddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "EOR_immediate_cccc0010001snnnnddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::EOR_immediate_cccc0010001snnnnddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedEOR_immediate_cccc0010001snnnnddddiiiiiiiiiiii_case_0);
};

class NamedEOR_register_cccc0000001snnnnddddiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedEOR_register_cccc0000001snnnnddddiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "EOR_register_cccc0000001snnnnddddiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::EOR_register_cccc0000001snnnnddddiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedEOR_register_cccc0000001snnnnddddiiiiitt0mmmm_case_0);
};

class NamedEOR_register_shifted_register_cccc0000001snnnnddddssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedEOR_register_shifted_register_cccc0000001snnnnddddssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "EOR_register_shifted_register_cccc0000001snnnnddddssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::EOR_register_shifted_register_cccc0000001snnnnddddssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedEOR_register_shifted_register_cccc0000001snnnnddddssss0tt1mmmm_case_0);
};

class NamedISB_1111010101111111111100000110xxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedISB_1111010101111111111100000110xxxx_case_0()
    : NamedClassDecoder(decoder_, "ISB_1111010101111111111100000110xxxx_case_0")
  {}

 private:
  nacl_arm_dec::ISB_1111010101111111111100000110xxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedISB_1111010101111111111100000110xxxx_case_0);
};

class NamedLDMDA_LDMFA_cccc100000w1nnnnrrrrrrrrrrrrrrrr_case_0
    : public NamedClassDecoder {
 public:
  NamedLDMDA_LDMFA_cccc100000w1nnnnrrrrrrrrrrrrrrrr_case_0()
    : NamedClassDecoder(decoder_, "LDMDA_LDMFA_cccc100000w1nnnnrrrrrrrrrrrrrrrr_case_0")
  {}

 private:
  nacl_arm_dec::LDMDA_LDMFA_cccc100000w1nnnnrrrrrrrrrrrrrrrr_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDMDA_LDMFA_cccc100000w1nnnnrrrrrrrrrrrrrrrr_case_0);
};

class NamedLDMDB_LDMEA_cccc100100w1nnnnrrrrrrrrrrrrrrrr_case_0
    : public NamedClassDecoder {
 public:
  NamedLDMDB_LDMEA_cccc100100w1nnnnrrrrrrrrrrrrrrrr_case_0()
    : NamedClassDecoder(decoder_, "LDMDB_LDMEA_cccc100100w1nnnnrrrrrrrrrrrrrrrr_case_0")
  {}

 private:
  nacl_arm_dec::LDMDB_LDMEA_cccc100100w1nnnnrrrrrrrrrrrrrrrr_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDMDB_LDMEA_cccc100100w1nnnnrrrrrrrrrrrrrrrr_case_0);
};

class NamedLDMIB_LDMED_cccc100110w1nnnnrrrrrrrrrrrrrrrr_case_0
    : public NamedClassDecoder {
 public:
  NamedLDMIB_LDMED_cccc100110w1nnnnrrrrrrrrrrrrrrrr_case_0()
    : NamedClassDecoder(decoder_, "LDMIB_LDMED_cccc100110w1nnnnrrrrrrrrrrrrrrrr_case_0")
  {}

 private:
  nacl_arm_dec::LDMIB_LDMED_cccc100110w1nnnnrrrrrrrrrrrrrrrr_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDMIB_LDMED_cccc100110w1nnnnrrrrrrrrrrrrrrrr_case_0);
};

class NamedLDM_LDMIA_LDMFD_cccc100010w1nnnnrrrrrrrrrrrrrrrr_case_0
    : public NamedClassDecoder {
 public:
  NamedLDM_LDMIA_LDMFD_cccc100010w1nnnnrrrrrrrrrrrrrrrr_case_0()
    : NamedClassDecoder(decoder_, "LDM_LDMIA_LDMFD_cccc100010w1nnnnrrrrrrrrrrrrrrrr_case_0")
  {}

 private:
  nacl_arm_dec::LDM_LDMIA_LDMFD_cccc100010w1nnnnrrrrrrrrrrrrrrrr_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDM_LDMIA_LDMFD_cccc100010w1nnnnrrrrrrrrrrrrrrrr_case_0);
};

class NamedLDRB_immediate_cccc010pu1w1nnnnttttiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRB_immediate_cccc010pu1w1nnnnttttiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "LDRB_immediate_cccc010pu1w1nnnnttttiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::LDRB_immediate_cccc010pu1w1nnnnttttiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRB_immediate_cccc010pu1w1nnnnttttiiiiiiiiiiii_case_0);
};

class NamedLDRB_literal_cccc0101u1011111ttttiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRB_literal_cccc0101u1011111ttttiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "LDRB_literal_cccc0101u1011111ttttiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::LDRB_literal_cccc0101u1011111ttttiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRB_literal_cccc0101u1011111ttttiiiiiiiiiiii_case_0);
};

class NamedLDRB_register_cccc011pu1w1nnnnttttiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRB_register_cccc011pu1w1nnnnttttiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "LDRB_register_cccc011pu1w1nnnnttttiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::LDRB_register_cccc011pu1w1nnnnttttiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRB_register_cccc011pu1w1nnnnttttiiiiitt0mmmm_case_0);
};

class NamedLDRD_immediate_cccc000pu1w0nnnnttttiiii1101iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRD_immediate_cccc000pu1w0nnnnttttiiii1101iiii_case_0()
    : NamedClassDecoder(decoder_, "LDRD_immediate_cccc000pu1w0nnnnttttiiii1101iiii_case_0")
  {}

 private:
  nacl_arm_dec::LDRD_immediate_cccc000pu1w0nnnnttttiiii1101iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRD_immediate_cccc000pu1w0nnnnttttiiii1101iiii_case_0);
};

class NamedLDRD_literal_cccc0001u1001111ttttiiii1101iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRD_literal_cccc0001u1001111ttttiiii1101iiii_case_0()
    : NamedClassDecoder(decoder_, "LDRD_literal_cccc0001u1001111ttttiiii1101iiii_case_0")
  {}

 private:
  nacl_arm_dec::LDRD_literal_cccc0001u1001111ttttiiii1101iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRD_literal_cccc0001u1001111ttttiiii1101iiii_case_0);
};

class NamedLDRD_register_cccc000pu0w0nnnntttt00001101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRD_register_cccc000pu0w0nnnntttt00001101mmmm_case_0()
    : NamedClassDecoder(decoder_, "LDRD_register_cccc000pu0w0nnnntttt00001101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::LDRD_register_cccc000pu0w0nnnntttt00001101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRD_register_cccc000pu0w0nnnntttt00001101mmmm_case_0);
};

class NamedLDREXB_cccc00011101nnnntttt111110011111_case_0
    : public NamedClassDecoder {
 public:
  NamedLDREXB_cccc00011101nnnntttt111110011111_case_0()
    : NamedClassDecoder(decoder_, "LDREXB_cccc00011101nnnntttt111110011111_case_0")
  {}

 private:
  nacl_arm_dec::LDREXB_cccc00011101nnnntttt111110011111_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDREXB_cccc00011101nnnntttt111110011111_case_0);
};

class NamedLDREXD_cccc00011011nnnntttt111110011111_case_0
    : public NamedClassDecoder {
 public:
  NamedLDREXD_cccc00011011nnnntttt111110011111_case_0()
    : NamedClassDecoder(decoder_, "LDREXD_cccc00011011nnnntttt111110011111_case_0")
  {}

 private:
  nacl_arm_dec::LDREXD_cccc00011011nnnntttt111110011111_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDREXD_cccc00011011nnnntttt111110011111_case_0);
};

class NamedLDREX_cccc00011001nnnntttt111110011111_case_0
    : public NamedClassDecoder {
 public:
  NamedLDREX_cccc00011001nnnntttt111110011111_case_0()
    : NamedClassDecoder(decoder_, "LDREX_cccc00011001nnnntttt111110011111_case_0")
  {}

 private:
  nacl_arm_dec::LDREX_cccc00011001nnnntttt111110011111_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDREX_cccc00011001nnnntttt111110011111_case_0);
};

class NamedLDRH_immediate_cccc000pu1w1nnnnttttiiii1011iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRH_immediate_cccc000pu1w1nnnnttttiiii1011iiii_case_0()
    : NamedClassDecoder(decoder_, "LDRH_immediate_cccc000pu1w1nnnnttttiiii1011iiii_case_0")
  {}

 private:
  nacl_arm_dec::LDRH_immediate_cccc000pu1w1nnnnttttiiii1011iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRH_immediate_cccc000pu1w1nnnnttttiiii1011iiii_case_0);
};

class NamedLDRH_literal_cccc000pu1w11111ttttiiii1011iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRH_literal_cccc000pu1w11111ttttiiii1011iiii_case_0()
    : NamedClassDecoder(decoder_, "LDRH_literal_cccc000pu1w11111ttttiiii1011iiii_case_0")
  {}

 private:
  nacl_arm_dec::LDRH_literal_cccc000pu1w11111ttttiiii1011iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRH_literal_cccc000pu1w11111ttttiiii1011iiii_case_0);
};

class NamedLDRH_register_cccc000pu0w1nnnntttt00001011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRH_register_cccc000pu0w1nnnntttt00001011mmmm_case_0()
    : NamedClassDecoder(decoder_, "LDRH_register_cccc000pu0w1nnnntttt00001011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::LDRH_register_cccc000pu0w1nnnntttt00001011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRH_register_cccc000pu0w1nnnntttt00001011mmmm_case_0);
};

class NamedLDRSB_immediate_cccc000pu1w1nnnnttttiiii1101iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRSB_immediate_cccc000pu1w1nnnnttttiiii1101iiii_case_0()
    : NamedClassDecoder(decoder_, "LDRSB_immediate_cccc000pu1w1nnnnttttiiii1101iiii_case_0")
  {}

 private:
  nacl_arm_dec::LDRSB_immediate_cccc000pu1w1nnnnttttiiii1101iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRSB_immediate_cccc000pu1w1nnnnttttiiii1101iiii_case_0);
};

class NamedLDRSB_literal_cccc0001u1011111ttttiiii1101iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRSB_literal_cccc0001u1011111ttttiiii1101iiii_case_0()
    : NamedClassDecoder(decoder_, "LDRSB_literal_cccc0001u1011111ttttiiii1101iiii_case_0")
  {}

 private:
  nacl_arm_dec::LDRSB_literal_cccc0001u1011111ttttiiii1101iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRSB_literal_cccc0001u1011111ttttiiii1101iiii_case_0);
};

class NamedLDRSB_literal_cccc0001u1011111ttttiiii1111iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRSB_literal_cccc0001u1011111ttttiiii1111iiii_case_0()
    : NamedClassDecoder(decoder_, "LDRSB_literal_cccc0001u1011111ttttiiii1111iiii_case_0")
  {}

 private:
  nacl_arm_dec::LDRSB_literal_cccc0001u1011111ttttiiii1111iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRSB_literal_cccc0001u1011111ttttiiii1111iiii_case_0);
};

class NamedLDRSB_register_cccc000pu0w1nnnntttt00001101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRSB_register_cccc000pu0w1nnnntttt00001101mmmm_case_0()
    : NamedClassDecoder(decoder_, "LDRSB_register_cccc000pu0w1nnnntttt00001101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::LDRSB_register_cccc000pu0w1nnnntttt00001101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRSB_register_cccc000pu0w1nnnntttt00001101mmmm_case_0);
};

class NamedLDRSH_immediate_cccc000pu1w1nnnnttttiiii1111iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRSH_immediate_cccc000pu1w1nnnnttttiiii1111iiii_case_0()
    : NamedClassDecoder(decoder_, "LDRSH_immediate_cccc000pu1w1nnnnttttiiii1111iiii_case_0")
  {}

 private:
  nacl_arm_dec::LDRSH_immediate_cccc000pu1w1nnnnttttiiii1111iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRSH_immediate_cccc000pu1w1nnnnttttiiii1111iiii_case_0);
};

class NamedLDRSH_register_cccc000pu0w1nnnntttt00001111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedLDRSH_register_cccc000pu0w1nnnntttt00001111mmmm_case_0()
    : NamedClassDecoder(decoder_, "LDRSH_register_cccc000pu0w1nnnntttt00001111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::LDRSH_register_cccc000pu0w1nnnntttt00001111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDRSH_register_cccc000pu0w1nnnntttt00001111mmmm_case_0);
};

class NamedLDR_immediate_cccc010pu0w1nnnnttttiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDR_immediate_cccc010pu0w1nnnnttttiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "LDR_immediate_cccc010pu0w1nnnnttttiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::LDR_immediate_cccc010pu0w1nnnnttttiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDR_immediate_cccc010pu0w1nnnnttttiiiiiiiiiiii_case_0);
};

class NamedLDR_literal_cccc0101u0011111ttttiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDR_literal_cccc0101u0011111ttttiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "LDR_literal_cccc0101u0011111ttttiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::LDR_literal_cccc0101u0011111ttttiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDR_literal_cccc0101u0011111ttttiiiiiiiiiiii_case_0);
};

class NamedLDR_register_cccc011pu0w1nnnnttttiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedLDR_register_cccc011pu0w1nnnnttttiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "LDR_register_cccc011pu0w1nnnnttttiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::LDR_register_cccc011pu0w1nnnnttttiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDR_register_cccc011pu0w1nnnnttttiiiiitt0mmmm_case_0);
};

class NamedLSL_immediate_cccc0001101s0000ddddiiiii000mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedLSL_immediate_cccc0001101s0000ddddiiiii000mmmm_case_0()
    : NamedClassDecoder(decoder_, "LSL_immediate_cccc0001101s0000ddddiiiii000mmmm_case_0")
  {}

 private:
  nacl_arm_dec::LSL_immediate_cccc0001101s0000ddddiiiii000mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLSL_immediate_cccc0001101s0000ddddiiiii000mmmm_case_0);
};

class NamedLSL_register_cccc0001101s0000ddddmmmm0001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedLSL_register_cccc0001101s0000ddddmmmm0001nnnn_case_0()
    : NamedClassDecoder(decoder_, "LSL_register_cccc0001101s0000ddddmmmm0001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::LSL_register_cccc0001101s0000ddddmmmm0001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLSL_register_cccc0001101s0000ddddmmmm0001nnnn_case_0);
};

class NamedLSR_immediate_cccc0001101s0000ddddiiiii010mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedLSR_immediate_cccc0001101s0000ddddiiiii010mmmm_case_0()
    : NamedClassDecoder(decoder_, "LSR_immediate_cccc0001101s0000ddddiiiii010mmmm_case_0")
  {}

 private:
  nacl_arm_dec::LSR_immediate_cccc0001101s0000ddddiiiii010mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLSR_immediate_cccc0001101s0000ddddiiiii010mmmm_case_0);
};

class NamedLSR_register_cccc0001101s0000ddddmmmm0011nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedLSR_register_cccc0001101s0000ddddmmmm0011nnnn_case_0()
    : NamedClassDecoder(decoder_, "LSR_register_cccc0001101s0000ddddmmmm0011nnnn_case_0")
  {}

 private:
  nacl_arm_dec::LSR_register_cccc0001101s0000ddddmmmm0011nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLSR_register_cccc0001101s0000ddddmmmm0011nnnn_case_0);
};

class NamedMLA_A1_cccc0000001sddddaaaammmm1001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedMLA_A1_cccc0000001sddddaaaammmm1001nnnn_case_0()
    : NamedClassDecoder(decoder_, "MLA_A1_cccc0000001sddddaaaammmm1001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::MLA_A1_cccc0000001sddddaaaammmm1001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMLA_A1_cccc0000001sddddaaaammmm1001nnnn_case_0);
};

class NamedMLS_A1_cccc00000110ddddaaaammmm1001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedMLS_A1_cccc00000110ddddaaaammmm1001nnnn_case_0()
    : NamedClassDecoder(decoder_, "MLS_A1_cccc00000110ddddaaaammmm1001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::MLS_A1_cccc00000110ddddaaaammmm1001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMLS_A1_cccc00000110ddddaaaammmm1001nnnn_case_0);
};

class NamedMOVE_scalar_to_ARM_core_register_cccc1110iii1nnnntttt1011nii10000_case_0
    : public NamedClassDecoder {
 public:
  NamedMOVE_scalar_to_ARM_core_register_cccc1110iii1nnnntttt1011nii10000_case_0()
    : NamedClassDecoder(decoder_, "MOVE_scalar_to_ARM_core_register_cccc1110iii1nnnntttt1011nii10000_case_0")
  {}

 private:
  nacl_arm_dec::MOVE_scalar_to_ARM_core_register_cccc1110iii1nnnntttt1011nii10000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMOVE_scalar_to_ARM_core_register_cccc1110iii1nnnntttt1011nii10000_case_0);
};

class NamedMOVT_cccc00110100iiiiddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedMOVT_cccc00110100iiiiddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "MOVT_cccc00110100iiiiddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::MOVT_cccc00110100iiiiddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMOVT_cccc00110100iiiiddddiiiiiiiiiiii_case_0);
};

class NamedMOVW_cccc00110000iiiiddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedMOVW_cccc00110000iiiiddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "MOVW_cccc00110000iiiiddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::MOVW_cccc00110000iiiiddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMOVW_cccc00110000iiiiddddiiiiiiiiiiii_case_0);
};

class NamedMOV_immediate_A1_cccc0011101s0000ddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedMOV_immediate_A1_cccc0011101s0000ddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "MOV_immediate_A1_cccc0011101s0000ddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::MOV_immediate_A1_cccc0011101s0000ddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMOV_immediate_A1_cccc0011101s0000ddddiiiiiiiiiiii_case_0);
};

class NamedMOV_register_cccc0001101s0000dddd00000000mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedMOV_register_cccc0001101s0000dddd00000000mmmm_case_0()
    : NamedClassDecoder(decoder_, "MOV_register_cccc0001101s0000dddd00000000mmmm_case_0")
  {}

 private:
  nacl_arm_dec::MOV_register_cccc0001101s0000dddd00000000mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMOV_register_cccc0001101s0000dddd00000000mmmm_case_0);
};

class NamedMRS_cccc00010r001111dddd000000000000_case_0
    : public NamedClassDecoder {
 public:
  NamedMRS_cccc00010r001111dddd000000000000_case_0()
    : NamedClassDecoder(decoder_, "MRS_cccc00010r001111dddd000000000000_case_0")
  {}

 private:
  nacl_arm_dec::MRS_cccc00010r001111dddd000000000000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMRS_cccc00010r001111dddd000000000000_case_0);
};

class NamedMSR_immediate_cccc00110010mm001111iiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedMSR_immediate_cccc00110010mm001111iiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "MSR_immediate_cccc00110010mm001111iiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::MSR_immediate_cccc00110010mm001111iiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMSR_immediate_cccc00110010mm001111iiiiiiiiiiii_case_0);
};

class NamedMSR_immediate_cccc00110r10mmmm1111iiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedMSR_immediate_cccc00110r10mmmm1111iiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "MSR_immediate_cccc00110r10mmmm1111iiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::MSR_immediate_cccc00110r10mmmm1111iiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMSR_immediate_cccc00110r10mmmm1111iiiiiiiiiiii_case_0);
};

class NamedMSR_register_cccc00010010mm00111100000000nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedMSR_register_cccc00010010mm00111100000000nnnn_case_0()
    : NamedClassDecoder(decoder_, "MSR_register_cccc00010010mm00111100000000nnnn_case_0")
  {}

 private:
  nacl_arm_dec::MSR_register_cccc00010010mm00111100000000nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMSR_register_cccc00010010mm00111100000000nnnn_case_0);
};

class NamedMUL_A1_cccc0000000sdddd0000mmmm1001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedMUL_A1_cccc0000000sdddd0000mmmm1001nnnn_case_0()
    : NamedClassDecoder(decoder_, "MUL_A1_cccc0000000sdddd0000mmmm1001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::MUL_A1_cccc0000000sdddd0000mmmm1001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMUL_A1_cccc0000000sdddd0000mmmm1001nnnn_case_0);
};

class NamedMVN_immediate_cccc0011111s0000ddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedMVN_immediate_cccc0011111s0000ddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "MVN_immediate_cccc0011111s0000ddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::MVN_immediate_cccc0011111s0000ddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMVN_immediate_cccc0011111s0000ddddiiiiiiiiiiii_case_0);
};

class NamedMVN_register_cccc0001111s0000ddddiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedMVN_register_cccc0001111s0000ddddiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "MVN_register_cccc0001111s0000ddddiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::MVN_register_cccc0001111s0000ddddiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMVN_register_cccc0001111s0000ddddiiiiitt0mmmm_case_0);
};

class NamedMVN_register_shifted_register_cccc0001111s0000ddddssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedMVN_register_shifted_register_cccc0001111s0000ddddssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "MVN_register_shifted_register_cccc0001111s0000ddddssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::MVN_register_shifted_register_cccc0001111s0000ddddssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMVN_register_shifted_register_cccc0001111s0000ddddssss0tt1mmmm_case_0);
};

class NamedNOP_cccc0011001000001111000000000000_case_0
    : public NamedClassDecoder {
 public:
  NamedNOP_cccc0011001000001111000000000000_case_0()
    : NamedClassDecoder(decoder_, "NOP_cccc0011001000001111000000000000_case_0")
  {}

 private:
  nacl_arm_dec::NOP_cccc0011001000001111000000000000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedNOP_cccc0011001000001111000000000000_case_0);
};

class NamedORR_immediate_cccc0011100snnnnddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedORR_immediate_cccc0011100snnnnddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "ORR_immediate_cccc0011100snnnnddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::ORR_immediate_cccc0011100snnnnddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedORR_immediate_cccc0011100snnnnddddiiiiiiiiiiii_case_0);
};

class NamedORR_register_cccc0001100snnnnddddiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedORR_register_cccc0001100snnnnddddiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "ORR_register_cccc0001100snnnnddddiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::ORR_register_cccc0001100snnnnddddiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedORR_register_cccc0001100snnnnddddiiiiitt0mmmm_case_0);
};

class NamedORR_register_shifted_register_cccc0001100snnnnddddssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedORR_register_shifted_register_cccc0001100snnnnddddssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "ORR_register_shifted_register_cccc0001100snnnnddddssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::ORR_register_shifted_register_cccc0001100snnnnddddssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedORR_register_shifted_register_cccc0001100snnnnddddssss0tt1mmmm_case_0);
};

class NamedPKH_cccc01101000nnnnddddiiiiit01mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedPKH_cccc01101000nnnnddddiiiiit01mmmm_case_0()
    : NamedClassDecoder(decoder_, "PKH_cccc01101000nnnnddddiiiiit01mmmm_case_0")
  {}

 private:
  nacl_arm_dec::PKH_cccc01101000nnnnddddiiiiit01mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedPKH_cccc01101000nnnnddddiiiiit01mmmm_case_0);
};

class NamedPLD_PLDW_immediate_11110101ur01nnnn1111iiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedPLD_PLDW_immediate_11110101ur01nnnn1111iiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "PLD_PLDW_immediate_11110101ur01nnnn1111iiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::PLD_PLDW_immediate_11110101ur01nnnn1111iiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedPLD_PLDW_immediate_11110101ur01nnnn1111iiiiiiiiiiii_case_0);
};

class NamedPLD_PLDW_immediate_11110101ur01nnnn1111iiiiiiiiiiii_case_1
    : public NamedClassDecoder {
 public:
  NamedPLD_PLDW_immediate_11110101ur01nnnn1111iiiiiiiiiiii_case_1()
    : NamedClassDecoder(decoder_, "PLD_PLDW_immediate_11110101ur01nnnn1111iiiiiiiiiiii_case_1")
  {}

 private:
  nacl_arm_dec::PLD_PLDW_immediate_11110101ur01nnnn1111iiiiiiiiiiii_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedPLD_PLDW_immediate_11110101ur01nnnn1111iiiiiiiiiiii_case_1);
};

class NamedPLD_PLDW_register_11110111u001nnnn1111iiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedPLD_PLDW_register_11110111u001nnnn1111iiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "PLD_PLDW_register_11110111u001nnnn1111iiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::PLD_PLDW_register_11110111u001nnnn1111iiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedPLD_PLDW_register_11110111u001nnnn1111iiiiitt0mmmm_case_0);
};

class NamedPLD_PLDW_register_11110111u101nnnn1111iiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedPLD_PLDW_register_11110111u101nnnn1111iiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "PLD_PLDW_register_11110111u101nnnn1111iiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::PLD_PLDW_register_11110111u101nnnn1111iiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedPLD_PLDW_register_11110111u101nnnn1111iiiiitt0mmmm_case_0);
};

class NamedPLD_literal_11110101u10111111111iiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedPLD_literal_11110101u10111111111iiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "PLD_literal_11110101u10111111111iiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::PLD_literal_11110101u10111111111iiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedPLD_literal_11110101u10111111111iiiiiiiiiiii_case_0);
};

class NamedPLI_immediate_literal_11110100u101nnnn1111iiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedPLI_immediate_literal_11110100u101nnnn1111iiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "PLI_immediate_literal_11110100u101nnnn1111iiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::PLI_immediate_literal_11110100u101nnnn1111iiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedPLI_immediate_literal_11110100u101nnnn1111iiiiiiiiiiii_case_0);
};

class NamedPLI_register_11110110u101nnnn1111iiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedPLI_register_11110110u101nnnn1111iiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "PLI_register_11110110u101nnnn1111iiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::PLI_register_11110110u101nnnn1111iiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedPLI_register_11110110u101nnnn1111iiiiitt0mmmm_case_0);
};

class NamedQADD16_cccc01100010nnnndddd11110001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedQADD16_cccc01100010nnnndddd11110001mmmm_case_0()
    : NamedClassDecoder(decoder_, "QADD16_cccc01100010nnnndddd11110001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::QADD16_cccc01100010nnnndddd11110001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedQADD16_cccc01100010nnnndddd11110001mmmm_case_0);
};

class NamedQADD8_cccc01100010nnnndddd11111001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedQADD8_cccc01100010nnnndddd11111001mmmm_case_0()
    : NamedClassDecoder(decoder_, "QADD8_cccc01100010nnnndddd11111001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::QADD8_cccc01100010nnnndddd11111001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedQADD8_cccc01100010nnnndddd11111001mmmm_case_0);
};

class NamedQADD_cccc00010000nnnndddd00000101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedQADD_cccc00010000nnnndddd00000101mmmm_case_0()
    : NamedClassDecoder(decoder_, "QADD_cccc00010000nnnndddd00000101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::QADD_cccc00010000nnnndddd00000101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedQADD_cccc00010000nnnndddd00000101mmmm_case_0);
};

class NamedQASX_cccc01100010nnnndddd11110011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedQASX_cccc01100010nnnndddd11110011mmmm_case_0()
    : NamedClassDecoder(decoder_, "QASX_cccc01100010nnnndddd11110011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::QASX_cccc01100010nnnndddd11110011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedQASX_cccc01100010nnnndddd11110011mmmm_case_0);
};

class NamedQDADD_cccc00010100nnnndddd00000101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedQDADD_cccc00010100nnnndddd00000101mmmm_case_0()
    : NamedClassDecoder(decoder_, "QDADD_cccc00010100nnnndddd00000101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::QDADD_cccc00010100nnnndddd00000101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedQDADD_cccc00010100nnnndddd00000101mmmm_case_0);
};

class NamedQDSUB_cccc00010110nnnndddd00000101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedQDSUB_cccc00010110nnnndddd00000101mmmm_case_0()
    : NamedClassDecoder(decoder_, "QDSUB_cccc00010110nnnndddd00000101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::QDSUB_cccc00010110nnnndddd00000101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedQDSUB_cccc00010110nnnndddd00000101mmmm_case_0);
};

class NamedQSAX_cccc01100010nnnndddd11110101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedQSAX_cccc01100010nnnndddd11110101mmmm_case_0()
    : NamedClassDecoder(decoder_, "QSAX_cccc01100010nnnndddd11110101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::QSAX_cccc01100010nnnndddd11110101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedQSAX_cccc01100010nnnndddd11110101mmmm_case_0);
};

class NamedQSUB16_cccc01100010nnnndddd11110111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedQSUB16_cccc01100010nnnndddd11110111mmmm_case_0()
    : NamedClassDecoder(decoder_, "QSUB16_cccc01100010nnnndddd11110111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::QSUB16_cccc01100010nnnndddd11110111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedQSUB16_cccc01100010nnnndddd11110111mmmm_case_0);
};

class NamedQSUB8_cccc01100010nnnndddd11111111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedQSUB8_cccc01100010nnnndddd11111111mmmm_case_0()
    : NamedClassDecoder(decoder_, "QSUB8_cccc01100010nnnndddd11111111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::QSUB8_cccc01100010nnnndddd11111111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedQSUB8_cccc01100010nnnndddd11111111mmmm_case_0);
};

class NamedQSUB_cccc00010010nnnndddd00000101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedQSUB_cccc00010010nnnndddd00000101mmmm_case_0()
    : NamedClassDecoder(decoder_, "QSUB_cccc00010010nnnndddd00000101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::QSUB_cccc00010010nnnndddd00000101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedQSUB_cccc00010010nnnndddd00000101mmmm_case_0);
};

class NamedRBIT_cccc011011111111dddd11110011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedRBIT_cccc011011111111dddd11110011mmmm_case_0()
    : NamedClassDecoder(decoder_, "RBIT_cccc011011111111dddd11110011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::RBIT_cccc011011111111dddd11110011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedRBIT_cccc011011111111dddd11110011mmmm_case_0);
};

class NamedREV16_cccc011010111111dddd11111011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedREV16_cccc011010111111dddd11111011mmmm_case_0()
    : NamedClassDecoder(decoder_, "REV16_cccc011010111111dddd11111011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::REV16_cccc011010111111dddd11111011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedREV16_cccc011010111111dddd11111011mmmm_case_0);
};

class NamedREVSH_cccc011011111111dddd11111011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedREVSH_cccc011011111111dddd11111011mmmm_case_0()
    : NamedClassDecoder(decoder_, "REVSH_cccc011011111111dddd11111011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::REVSH_cccc011011111111dddd11111011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedREVSH_cccc011011111111dddd11111011mmmm_case_0);
};

class NamedREV_cccc011010111111dddd11110011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedREV_cccc011010111111dddd11110011mmmm_case_0()
    : NamedClassDecoder(decoder_, "REV_cccc011010111111dddd11110011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::REV_cccc011010111111dddd11110011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedREV_cccc011010111111dddd11110011mmmm_case_0);
};

class NamedROR_immediate_cccc0001101s0000ddddiiiii110mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedROR_immediate_cccc0001101s0000ddddiiiii110mmmm_case_0()
    : NamedClassDecoder(decoder_, "ROR_immediate_cccc0001101s0000ddddiiiii110mmmm_case_0")
  {}

 private:
  nacl_arm_dec::ROR_immediate_cccc0001101s0000ddddiiiii110mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedROR_immediate_cccc0001101s0000ddddiiiii110mmmm_case_0);
};

class NamedROR_register_cccc0001101s0000ddddmmmm0111nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedROR_register_cccc0001101s0000ddddmmmm0111nnnn_case_0()
    : NamedClassDecoder(decoder_, "ROR_register_cccc0001101s0000ddddmmmm0111nnnn_case_0")
  {}

 private:
  nacl_arm_dec::ROR_register_cccc0001101s0000ddddmmmm0111nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedROR_register_cccc0001101s0000ddddmmmm0111nnnn_case_0);
};

class NamedRRX_cccc0001101s0000dddd00000110mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedRRX_cccc0001101s0000dddd00000110mmmm_case_0()
    : NamedClassDecoder(decoder_, "RRX_cccc0001101s0000dddd00000110mmmm_case_0")
  {}

 private:
  nacl_arm_dec::RRX_cccc0001101s0000dddd00000110mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedRRX_cccc0001101s0000dddd00000110mmmm_case_0);
};

class NamedRSB_immediate_cccc0010011snnnnddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedRSB_immediate_cccc0010011snnnnddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "RSB_immediate_cccc0010011snnnnddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::RSB_immediate_cccc0010011snnnnddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedRSB_immediate_cccc0010011snnnnddddiiiiiiiiiiii_case_0);
};

class NamedRSB_register_cccc0000011snnnnddddiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedRSB_register_cccc0000011snnnnddddiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "RSB_register_cccc0000011snnnnddddiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::RSB_register_cccc0000011snnnnddddiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedRSB_register_cccc0000011snnnnddddiiiiitt0mmmm_case_0);
};

class NamedRSB_register_shfited_register_cccc0000011snnnnddddssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedRSB_register_shfited_register_cccc0000011snnnnddddssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "RSB_register_shfited_register_cccc0000011snnnnddddssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::RSB_register_shfited_register_cccc0000011snnnnddddssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedRSB_register_shfited_register_cccc0000011snnnnddddssss0tt1mmmm_case_0);
};

class NamedRSC_immediate_cccc0010111snnnnddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedRSC_immediate_cccc0010111snnnnddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "RSC_immediate_cccc0010111snnnnddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::RSC_immediate_cccc0010111snnnnddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedRSC_immediate_cccc0010111snnnnddddiiiiiiiiiiii_case_0);
};

class NamedRSC_register_cccc0000111snnnnddddiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedRSC_register_cccc0000111snnnnddddiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "RSC_register_cccc0000111snnnnddddiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::RSC_register_cccc0000111snnnnddddiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedRSC_register_cccc0000111snnnnddddiiiiitt0mmmm_case_0);
};

class NamedRSC_register_shifted_register_cccc0000111snnnnddddssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedRSC_register_shifted_register_cccc0000111snnnnddddssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "RSC_register_shifted_register_cccc0000111snnnnddddssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::RSC_register_shifted_register_cccc0000111snnnnddddssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedRSC_register_shifted_register_cccc0000111snnnnddddssss0tt1mmmm_case_0);
};

class NamedSADD16_cccc01100001nnnndddd11110001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSADD16_cccc01100001nnnndddd11110001mmmm_case_0()
    : NamedClassDecoder(decoder_, "SADD16_cccc01100001nnnndddd11110001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SADD16_cccc01100001nnnndddd11110001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSADD16_cccc01100001nnnndddd11110001mmmm_case_0);
};

class NamedSADD8_cccc01100001nnnndddd11111001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSADD8_cccc01100001nnnndddd11111001mmmm_case_0()
    : NamedClassDecoder(decoder_, "SADD8_cccc01100001nnnndddd11111001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SADD8_cccc01100001nnnndddd11111001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSADD8_cccc01100001nnnndddd11111001mmmm_case_0);
};

class NamedSASX_cccc01100001nnnndddd11110011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSASX_cccc01100001nnnndddd11110011mmmm_case_0()
    : NamedClassDecoder(decoder_, "SASX_cccc01100001nnnndddd11110011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SASX_cccc01100001nnnndddd11110011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSASX_cccc01100001nnnndddd11110011mmmm_case_0);
};

class NamedSBC_immediate_cccc0010110snnnnddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedSBC_immediate_cccc0010110snnnnddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "SBC_immediate_cccc0010110snnnnddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::SBC_immediate_cccc0010110snnnnddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSBC_immediate_cccc0010110snnnnddddiiiiiiiiiiii_case_0);
};

class NamedSBC_register_cccc0000110snnnnddddiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSBC_register_cccc0000110snnnnddddiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "SBC_register_cccc0000110snnnnddddiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SBC_register_cccc0000110snnnnddddiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSBC_register_cccc0000110snnnnddddiiiiitt0mmmm_case_0);
};

class NamedSBC_register_shifted_register_cccc0000110snnnnddddssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSBC_register_shifted_register_cccc0000110snnnnddddssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "SBC_register_shifted_register_cccc0000110snnnnddddssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SBC_register_shifted_register_cccc0000110snnnnddddssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSBC_register_shifted_register_cccc0000110snnnnddddssss0tt1mmmm_case_0);
};

class NamedSBFX_cccc0111101wwwwwddddlllll101nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSBFX_cccc0111101wwwwwddddlllll101nnnn_case_0()
    : NamedClassDecoder(decoder_, "SBFX_cccc0111101wwwwwddddlllll101nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SBFX_cccc0111101wwwwwddddlllll101nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSBFX_cccc0111101wwwwwddddlllll101nnnn_case_0);
};

class NamedSDIV_cccc01110001dddd1111mmmm0001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSDIV_cccc01110001dddd1111mmmm0001nnnn_case_0()
    : NamedClassDecoder(decoder_, "SDIV_cccc01110001dddd1111mmmm0001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SDIV_cccc01110001dddd1111mmmm0001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSDIV_cccc01110001dddd1111mmmm0001nnnn_case_0);
};

class NamedSEL_cccc01101000nnnndddd11111011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSEL_cccc01101000nnnndddd11111011mmmm_case_0()
    : NamedClassDecoder(decoder_, "SEL_cccc01101000nnnndddd11111011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SEL_cccc01101000nnnndddd11111011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSEL_cccc01101000nnnndddd11111011mmmm_case_0);
};

class NamedSEV_cccc0011001000001111000000000100_case_0
    : public NamedClassDecoder {
 public:
  NamedSEV_cccc0011001000001111000000000100_case_0()
    : NamedClassDecoder(decoder_, "SEV_cccc0011001000001111000000000100_case_0")
  {}

 private:
  nacl_arm_dec::SEV_cccc0011001000001111000000000100_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSEV_cccc0011001000001111000000000100_case_0);
};

class NamedSHADD16_cccc01100011nnnndddd11110001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSHADD16_cccc01100011nnnndddd11110001mmmm_case_0()
    : NamedClassDecoder(decoder_, "SHADD16_cccc01100011nnnndddd11110001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SHADD16_cccc01100011nnnndddd11110001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSHADD16_cccc01100011nnnndddd11110001mmmm_case_0);
};

class NamedSHADD8_cccc01100011nnnndddd11111001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSHADD8_cccc01100011nnnndddd11111001mmmm_case_0()
    : NamedClassDecoder(decoder_, "SHADD8_cccc01100011nnnndddd11111001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SHADD8_cccc01100011nnnndddd11111001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSHADD8_cccc01100011nnnndddd11111001mmmm_case_0);
};

class NamedSHASX_cccc01100011nnnndddd11110011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSHASX_cccc01100011nnnndddd11110011mmmm_case_0()
    : NamedClassDecoder(decoder_, "SHASX_cccc01100011nnnndddd11110011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SHASX_cccc01100011nnnndddd11110011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSHASX_cccc01100011nnnndddd11110011mmmm_case_0);
};

class NamedSHSAX_cccc01100011nnnndddd11110101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSHSAX_cccc01100011nnnndddd11110101mmmm_case_0()
    : NamedClassDecoder(decoder_, "SHSAX_cccc01100011nnnndddd11110101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SHSAX_cccc01100011nnnndddd11110101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSHSAX_cccc01100011nnnndddd11110101mmmm_case_0);
};

class NamedSHSUB16_cccc01100011nnnndddd11110111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSHSUB16_cccc01100011nnnndddd11110111mmmm_case_0()
    : NamedClassDecoder(decoder_, "SHSUB16_cccc01100011nnnndddd11110111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SHSUB16_cccc01100011nnnndddd11110111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSHSUB16_cccc01100011nnnndddd11110111mmmm_case_0);
};

class NamedSHSUB8_cccc01100011nnnndddd11111111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSHSUB8_cccc01100011nnnndddd11111111mmmm_case_0()
    : NamedClassDecoder(decoder_, "SHSUB8_cccc01100011nnnndddd11111111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SHSUB8_cccc01100011nnnndddd11111111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSHSUB8_cccc01100011nnnndddd11111111mmmm_case_0);
};

class NamedSMLABB_SMLABT_SMLATB_SMLATT_cccc00010000ddddaaaammmm1xx0nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMLABB_SMLABT_SMLATB_SMLATT_cccc00010000ddddaaaammmm1xx0nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMLABB_SMLABT_SMLATB_SMLATT_cccc00010000ddddaaaammmm1xx0nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMLABB_SMLABT_SMLATB_SMLATT_cccc00010000ddddaaaammmm1xx0nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMLABB_SMLABT_SMLATB_SMLATT_cccc00010000ddddaaaammmm1xx0nnnn_case_0);
};

class NamedSMLAD_cccc01110000ddddaaaammmm00m1nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMLAD_cccc01110000ddddaaaammmm00m1nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMLAD_cccc01110000ddddaaaammmm00m1nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMLAD_cccc01110000ddddaaaammmm00m1nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMLAD_cccc01110000ddddaaaammmm00m1nnnn_case_0);
};

class NamedSMLALBB_SMLALBT_SMLALTB_SMLALTT_cccc00010100hhhhllllmmmm1xx0nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMLALBB_SMLALBT_SMLALTB_SMLALTT_cccc00010100hhhhllllmmmm1xx0nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMLALBB_SMLALBT_SMLALTB_SMLALTT_cccc00010100hhhhllllmmmm1xx0nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMLALBB_SMLALBT_SMLALTB_SMLALTT_cccc00010100hhhhllllmmmm1xx0nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMLALBB_SMLALBT_SMLALTB_SMLALTT_cccc00010100hhhhllllmmmm1xx0nnnn_case_0);
};

class NamedSMLALD_cccc01110100hhhhllllmmmm00m1nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMLALD_cccc01110100hhhhllllmmmm00m1nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMLALD_cccc01110100hhhhllllmmmm00m1nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMLALD_cccc01110100hhhhllllmmmm00m1nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMLALD_cccc01110100hhhhllllmmmm00m1nnnn_case_0);
};

class NamedSMLAL_A1_cccc0000111shhhhllllmmmm1001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMLAL_A1_cccc0000111shhhhllllmmmm1001nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMLAL_A1_cccc0000111shhhhllllmmmm1001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMLAL_A1_cccc0000111shhhhllllmmmm1001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMLAL_A1_cccc0000111shhhhllllmmmm1001nnnn_case_0);
};

class NamedSMLAWB_SMLAWT_cccc00010010ddddaaaammmm1x00nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMLAWB_SMLAWT_cccc00010010ddddaaaammmm1x00nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMLAWB_SMLAWT_cccc00010010ddddaaaammmm1x00nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMLAWB_SMLAWT_cccc00010010ddddaaaammmm1x00nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMLAWB_SMLAWT_cccc00010010ddddaaaammmm1x00nnnn_case_0);
};

class NamedSMLSD_cccc01110000ddddaaaammmm01m1nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMLSD_cccc01110000ddddaaaammmm01m1nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMLSD_cccc01110000ddddaaaammmm01m1nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMLSD_cccc01110000ddddaaaammmm01m1nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMLSD_cccc01110000ddddaaaammmm01m1nnnn_case_0);
};

class NamedSMLSLD_cccc01110100hhhhllllmmmm01m1nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMLSLD_cccc01110100hhhhllllmmmm01m1nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMLSLD_cccc01110100hhhhllllmmmm01m1nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMLSLD_cccc01110100hhhhllllmmmm01m1nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMLSLD_cccc01110100hhhhllllmmmm01m1nnnn_case_0);
};

class NamedSMMLA_cccc01110101ddddaaaammmm00r1nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMMLA_cccc01110101ddddaaaammmm00r1nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMMLA_cccc01110101ddddaaaammmm00r1nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMMLA_cccc01110101ddddaaaammmm00r1nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMMLA_cccc01110101ddddaaaammmm00r1nnnn_case_0);
};

class NamedSMMLS_cccc01110101ddddaaaammmm11r1nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMMLS_cccc01110101ddddaaaammmm11r1nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMMLS_cccc01110101ddddaaaammmm11r1nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMMLS_cccc01110101ddddaaaammmm11r1nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMMLS_cccc01110101ddddaaaammmm11r1nnnn_case_0);
};

class NamedSMMUL_cccc01110101dddd1111mmmm00r1nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMMUL_cccc01110101dddd1111mmmm00r1nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMMUL_cccc01110101dddd1111mmmm00r1nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMMUL_cccc01110101dddd1111mmmm00r1nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMMUL_cccc01110101dddd1111mmmm00r1nnnn_case_0);
};

class NamedSMUAD_cccc01110000dddd1111mmmm00m1nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMUAD_cccc01110000dddd1111mmmm00m1nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMUAD_cccc01110000dddd1111mmmm00m1nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMUAD_cccc01110000dddd1111mmmm00m1nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMUAD_cccc01110000dddd1111mmmm00m1nnnn_case_0);
};

class NamedSMULBB_SMULBT_SMULTB_SMULTT_cccc00010110dddd0000mmmm1xx0nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMULBB_SMULBT_SMULTB_SMULTT_cccc00010110dddd0000mmmm1xx0nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMULBB_SMULBT_SMULTB_SMULTT_cccc00010110dddd0000mmmm1xx0nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMULBB_SMULBT_SMULTB_SMULTT_cccc00010110dddd0000mmmm1xx0nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMULBB_SMULBT_SMULTB_SMULTT_cccc00010110dddd0000mmmm1xx0nnnn_case_0);
};

class NamedSMULL_A1_cccc0000110shhhhllllmmmm1001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMULL_A1_cccc0000110shhhhllllmmmm1001nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMULL_A1_cccc0000110shhhhllllmmmm1001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMULL_A1_cccc0000110shhhhllllmmmm1001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMULL_A1_cccc0000110shhhhllllmmmm1001nnnn_case_0);
};

class NamedSMULWB_SMULWT_cccc00010010dddd0000mmmm1x10nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMULWB_SMULWT_cccc00010010dddd0000mmmm1x10nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMULWB_SMULWT_cccc00010010dddd0000mmmm1x10nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMULWB_SMULWT_cccc00010010dddd0000mmmm1x10nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMULWB_SMULWT_cccc00010010dddd0000mmmm1x10nnnn_case_0);
};

class NamedSMUSD_cccc01110000dddd1111mmmm01m1nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSMUSD_cccc01110000dddd1111mmmm01m1nnnn_case_0()
    : NamedClassDecoder(decoder_, "SMUSD_cccc01110000dddd1111mmmm01m1nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SMUSD_cccc01110000dddd1111mmmm01m1nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSMUSD_cccc01110000dddd1111mmmm01m1nnnn_case_0);
};

class NamedSSAT16_cccc01101010iiiidddd11110011nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSSAT16_cccc01101010iiiidddd11110011nnnn_case_0()
    : NamedClassDecoder(decoder_, "SSAT16_cccc01101010iiiidddd11110011nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SSAT16_cccc01101010iiiidddd11110011nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSSAT16_cccc01101010iiiidddd11110011nnnn_case_0);
};

class NamedSSAT_cccc0110101iiiiiddddiiiiis01nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedSSAT_cccc0110101iiiiiddddiiiiis01nnnn_case_0()
    : NamedClassDecoder(decoder_, "SSAT_cccc0110101iiiiiddddiiiiis01nnnn_case_0")
  {}

 private:
  nacl_arm_dec::SSAT_cccc0110101iiiiiddddiiiiis01nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSSAT_cccc0110101iiiiiddddiiiiis01nnnn_case_0);
};

class NamedSSAX_cccc01100001nnnndddd11110101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSSAX_cccc01100001nnnndddd11110101mmmm_case_0()
    : NamedClassDecoder(decoder_, "SSAX_cccc01100001nnnndddd11110101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SSAX_cccc01100001nnnndddd11110101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSSAX_cccc01100001nnnndddd11110101mmmm_case_0);
};

class NamedSSSUB16_cccc01100001nnnndddd11110111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSSSUB16_cccc01100001nnnndddd11110111mmmm_case_0()
    : NamedClassDecoder(decoder_, "SSSUB16_cccc01100001nnnndddd11110111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SSSUB16_cccc01100001nnnndddd11110111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSSSUB16_cccc01100001nnnndddd11110111mmmm_case_0);
};

class NamedSSUB8_cccc01100001nnnndddd11111111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSSUB8_cccc01100001nnnndddd11111111mmmm_case_0()
    : NamedClassDecoder(decoder_, "SSUB8_cccc01100001nnnndddd11111111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SSUB8_cccc01100001nnnndddd11111111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSSUB8_cccc01100001nnnndddd11111111mmmm_case_0);
};

class NamedSTMDA_STMED_cccc100000w0nnnnrrrrrrrrrrrrrrrr_case_0
    : public NamedClassDecoder {
 public:
  NamedSTMDA_STMED_cccc100000w0nnnnrrrrrrrrrrrrrrrr_case_0()
    : NamedClassDecoder(decoder_, "STMDA_STMED_cccc100000w0nnnnrrrrrrrrrrrrrrrr_case_0")
  {}

 private:
  nacl_arm_dec::STMDA_STMED_cccc100000w0nnnnrrrrrrrrrrrrrrrr_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTMDA_STMED_cccc100000w0nnnnrrrrrrrrrrrrrrrr_case_0);
};

class NamedSTMDB_STMFD_cccc100100w0nnnnrrrrrrrrrrrrrrrr_case_0
    : public NamedClassDecoder {
 public:
  NamedSTMDB_STMFD_cccc100100w0nnnnrrrrrrrrrrrrrrrr_case_0()
    : NamedClassDecoder(decoder_, "STMDB_STMFD_cccc100100w0nnnnrrrrrrrrrrrrrrrr_case_0")
  {}

 private:
  nacl_arm_dec::STMDB_STMFD_cccc100100w0nnnnrrrrrrrrrrrrrrrr_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTMDB_STMFD_cccc100100w0nnnnrrrrrrrrrrrrrrrr_case_0);
};

class NamedSTMIB_STMFA_cccc100110w0nnnnrrrrrrrrrrrrrrrr_case_0
    : public NamedClassDecoder {
 public:
  NamedSTMIB_STMFA_cccc100110w0nnnnrrrrrrrrrrrrrrrr_case_0()
    : NamedClassDecoder(decoder_, "STMIB_STMFA_cccc100110w0nnnnrrrrrrrrrrrrrrrr_case_0")
  {}

 private:
  nacl_arm_dec::STMIB_STMFA_cccc100110w0nnnnrrrrrrrrrrrrrrrr_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTMIB_STMFA_cccc100110w0nnnnrrrrrrrrrrrrrrrr_case_0);
};

class NamedSTM_STMIA_STMEA_cccc100010w0nnnnrrrrrrrrrrrrrrrr_case_0
    : public NamedClassDecoder {
 public:
  NamedSTM_STMIA_STMEA_cccc100010w0nnnnrrrrrrrrrrrrrrrr_case_0()
    : NamedClassDecoder(decoder_, "STM_STMIA_STMEA_cccc100010w0nnnnrrrrrrrrrrrrrrrr_case_0")
  {}

 private:
  nacl_arm_dec::STM_STMIA_STMEA_cccc100010w0nnnnrrrrrrrrrrrrrrrr_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTM_STMIA_STMEA_cccc100010w0nnnnrrrrrrrrrrrrrrrr_case_0);
};

class NamedSTRB_immediate_cccc010pu1w0nnnnttttiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedSTRB_immediate_cccc010pu1w0nnnnttttiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "STRB_immediate_cccc010pu1w0nnnnttttiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::STRB_immediate_cccc010pu1w0nnnnttttiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTRB_immediate_cccc010pu1w0nnnnttttiiiiiiiiiiii_case_0);
};

class NamedSTRB_register_cccc011pu1w0nnnnttttiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSTRB_register_cccc011pu1w0nnnnttttiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "STRB_register_cccc011pu1w0nnnnttttiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::STRB_register_cccc011pu1w0nnnnttttiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTRB_register_cccc011pu1w0nnnnttttiiiiitt0mmmm_case_0);
};

class NamedSTRD_immediate_cccc000pu1w0nnnnttttiiii1111iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedSTRD_immediate_cccc000pu1w0nnnnttttiiii1111iiii_case_0()
    : NamedClassDecoder(decoder_, "STRD_immediate_cccc000pu1w0nnnnttttiiii1111iiii_case_0")
  {}

 private:
  nacl_arm_dec::STRD_immediate_cccc000pu1w0nnnnttttiiii1111iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTRD_immediate_cccc000pu1w0nnnnttttiiii1111iiii_case_0);
};

class NamedSTRD_register_cccc000pu0w0nnnntttt00001111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSTRD_register_cccc000pu0w0nnnntttt00001111mmmm_case_0()
    : NamedClassDecoder(decoder_, "STRD_register_cccc000pu0w0nnnntttt00001111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::STRD_register_cccc000pu0w0nnnntttt00001111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTRD_register_cccc000pu0w0nnnntttt00001111mmmm_case_0);
};

class NamedSTREXB_cccc00011100nnnndddd11111001tttt_case_0
    : public NamedClassDecoder {
 public:
  NamedSTREXB_cccc00011100nnnndddd11111001tttt_case_0()
    : NamedClassDecoder(decoder_, "STREXB_cccc00011100nnnndddd11111001tttt_case_0")
  {}

 private:
  nacl_arm_dec::STREXB_cccc00011100nnnndddd11111001tttt_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTREXB_cccc00011100nnnndddd11111001tttt_case_0);
};

class NamedSTREXD_cccc00011010nnnndddd11111001tttt_case_0
    : public NamedClassDecoder {
 public:
  NamedSTREXD_cccc00011010nnnndddd11111001tttt_case_0()
    : NamedClassDecoder(decoder_, "STREXD_cccc00011010nnnndddd11111001tttt_case_0")
  {}

 private:
  nacl_arm_dec::STREXD_cccc00011010nnnndddd11111001tttt_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTREXD_cccc00011010nnnndddd11111001tttt_case_0);
};

class NamedSTREXH_cccc00011110nnnndddd11111001tttt_case_0
    : public NamedClassDecoder {
 public:
  NamedSTREXH_cccc00011110nnnndddd11111001tttt_case_0()
    : NamedClassDecoder(decoder_, "STREXH_cccc00011110nnnndddd11111001tttt_case_0")
  {}

 private:
  nacl_arm_dec::STREXH_cccc00011110nnnndddd11111001tttt_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTREXH_cccc00011110nnnndddd11111001tttt_case_0);
};

class NamedSTREXH_cccc00011111nnnntttt111110011111_case_0
    : public NamedClassDecoder {
 public:
  NamedSTREXH_cccc00011111nnnntttt111110011111_case_0()
    : NamedClassDecoder(decoder_, "STREXH_cccc00011111nnnntttt111110011111_case_0")
  {}

 private:
  nacl_arm_dec::STREXH_cccc00011111nnnntttt111110011111_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTREXH_cccc00011111nnnntttt111110011111_case_0);
};

class NamedSTREX_cccc00011000nnnndddd11111001tttt_case_0
    : public NamedClassDecoder {
 public:
  NamedSTREX_cccc00011000nnnndddd11111001tttt_case_0()
    : NamedClassDecoder(decoder_, "STREX_cccc00011000nnnndddd11111001tttt_case_0")
  {}

 private:
  nacl_arm_dec::STREX_cccc00011000nnnndddd11111001tttt_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTREX_cccc00011000nnnndddd11111001tttt_case_0);
};

class NamedSTRH_immediate_cccc000pu1w0nnnnttttiiii1011iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedSTRH_immediate_cccc000pu1w0nnnnttttiiii1011iiii_case_0()
    : NamedClassDecoder(decoder_, "STRH_immediate_cccc000pu1w0nnnnttttiiii1011iiii_case_0")
  {}

 private:
  nacl_arm_dec::STRH_immediate_cccc000pu1w0nnnnttttiiii1011iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTRH_immediate_cccc000pu1w0nnnnttttiiii1011iiii_case_0);
};

class NamedSTRH_register_cccc000pu0w0nnnntttt00001011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSTRH_register_cccc000pu0w0nnnntttt00001011mmmm_case_0()
    : NamedClassDecoder(decoder_, "STRH_register_cccc000pu0w0nnnntttt00001011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::STRH_register_cccc000pu0w0nnnntttt00001011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTRH_register_cccc000pu0w0nnnntttt00001011mmmm_case_0);
};

class NamedSTR_immediate_cccc010pu0w0nnnnttttiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedSTR_immediate_cccc010pu0w0nnnnttttiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "STR_immediate_cccc010pu0w0nnnnttttiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::STR_immediate_cccc010pu0w0nnnnttttiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTR_immediate_cccc010pu0w0nnnnttttiiiiiiiiiiii_case_0);
};

class NamedSTR_register_cccc011pd0w0nnnnttttiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSTR_register_cccc011pd0w0nnnnttttiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "STR_register_cccc011pd0w0nnnnttttiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::STR_register_cccc011pd0w0nnnnttttiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTR_register_cccc011pd0w0nnnnttttiiiiitt0mmmm_case_0);
};

class NamedSUB_immediate_cccc0010010snnnnddddiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedSUB_immediate_cccc0010010snnnnddddiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "SUB_immediate_cccc0010010snnnnddddiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::SUB_immediate_cccc0010010snnnnddddiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSUB_immediate_cccc0010010snnnnddddiiiiiiiiiiii_case_0);
};

class NamedSUB_register_cccc0000010snnnnddddiiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSUB_register_cccc0000010snnnnddddiiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "SUB_register_cccc0000010snnnnddddiiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SUB_register_cccc0000010snnnnddddiiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSUB_register_cccc0000010snnnnddddiiiiitt0mmmm_case_0);
};

class NamedSUB_register_shifted_register_cccc0000010snnnnddddssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSUB_register_shifted_register_cccc0000010snnnnddddssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "SUB_register_shifted_register_cccc0000010snnnnddddssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SUB_register_shifted_register_cccc0000010snnnnddddssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSUB_register_shifted_register_cccc0000010snnnnddddssss0tt1mmmm_case_0);
};

class NamedSXTAB16_cccc01101000nnnnddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSXTAB16_cccc01101000nnnnddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "SXTAB16_cccc01101000nnnnddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SXTAB16_cccc01101000nnnnddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSXTAB16_cccc01101000nnnnddddrr000111mmmm_case_0);
};

class NamedSXTAB_cccc01101010nnnnddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSXTAB_cccc01101010nnnnddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "SXTAB_cccc01101010nnnnddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SXTAB_cccc01101010nnnnddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSXTAB_cccc01101010nnnnddddrr000111mmmm_case_0);
};

class NamedSXTAH_cccc01101011nnnnddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSXTAH_cccc01101011nnnnddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "SXTAH_cccc01101011nnnnddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SXTAH_cccc01101011nnnnddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSXTAH_cccc01101011nnnnddddrr000111mmmm_case_0);
};

class NamedSXTB16_cccc011010001111ddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSXTB16_cccc011010001111ddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "SXTB16_cccc011010001111ddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SXTB16_cccc011010001111ddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSXTB16_cccc011010001111ddddrr000111mmmm_case_0);
};

class NamedSXTB_cccc011010101111ddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSXTB_cccc011010101111ddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "SXTB_cccc011010101111ddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SXTB_cccc011010101111ddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSXTB_cccc011010101111ddddrr000111mmmm_case_0);
};

class NamedSXTH_cccc011010111111ddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedSXTH_cccc011010111111ddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "SXTH_cccc011010111111ddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::SXTH_cccc011010111111ddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSXTH_cccc011010111111ddddrr000111mmmm_case_0);
};

class NamedTEQ_immediate_cccc00110011nnnn0000iiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedTEQ_immediate_cccc00110011nnnn0000iiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "TEQ_immediate_cccc00110011nnnn0000iiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::TEQ_immediate_cccc00110011nnnn0000iiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedTEQ_immediate_cccc00110011nnnn0000iiiiiiiiiiii_case_0);
};

class NamedTEQ_register_cccc00010011nnnn0000iiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedTEQ_register_cccc00010011nnnn0000iiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "TEQ_register_cccc00010011nnnn0000iiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::TEQ_register_cccc00010011nnnn0000iiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedTEQ_register_cccc00010011nnnn0000iiiiitt0mmmm_case_0);
};

class NamedTEQ_register_shifted_register_cccc00010011nnnn0000ssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedTEQ_register_shifted_register_cccc00010011nnnn0000ssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "TEQ_register_shifted_register_cccc00010011nnnn0000ssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::TEQ_register_shifted_register_cccc00010011nnnn0000ssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedTEQ_register_shifted_register_cccc00010011nnnn0000ssss0tt1mmmm_case_0);
};

class NamedTST_immediate_cccc00110001nnnn0000iiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedTST_immediate_cccc00110001nnnn0000iiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "TST_immediate_cccc00110001nnnn0000iiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::TST_immediate_cccc00110001nnnn0000iiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedTST_immediate_cccc00110001nnnn0000iiiiiiiiiiii_case_0);
};

class NamedTST_register_cccc00010001nnnn0000iiiiitt0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedTST_register_cccc00010001nnnn0000iiiiitt0mmmm_case_0()
    : NamedClassDecoder(decoder_, "TST_register_cccc00010001nnnn0000iiiiitt0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::TST_register_cccc00010001nnnn0000iiiiitt0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedTST_register_cccc00010001nnnn0000iiiiitt0mmmm_case_0);
};

class NamedTST_register_shifted_register_cccc00010001nnnn0000ssss0tt1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedTST_register_shifted_register_cccc00010001nnnn0000ssss0tt1mmmm_case_0()
    : NamedClassDecoder(decoder_, "TST_register_shifted_register_cccc00010001nnnn0000ssss0tt1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::TST_register_shifted_register_cccc00010001nnnn0000ssss0tt1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedTST_register_shifted_register_cccc00010001nnnn0000ssss0tt1mmmm_case_0);
};

class NamedUADD16_cccc01100101nnnndddd11110001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUADD16_cccc01100101nnnndddd11110001mmmm_case_0()
    : NamedClassDecoder(decoder_, "UADD16_cccc01100101nnnndddd11110001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UADD16_cccc01100101nnnndddd11110001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUADD16_cccc01100101nnnndddd11110001mmmm_case_0);
};

class NamedUADD8_cccc01100101nnnndddd11111001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUADD8_cccc01100101nnnndddd11111001mmmm_case_0()
    : NamedClassDecoder(decoder_, "UADD8_cccc01100101nnnndddd11111001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UADD8_cccc01100101nnnndddd11111001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUADD8_cccc01100101nnnndddd11111001mmmm_case_0);
};

class NamedUASX_cccc01100101nnnndddd11110011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUASX_cccc01100101nnnndddd11110011mmmm_case_0()
    : NamedClassDecoder(decoder_, "UASX_cccc01100101nnnndddd11110011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UASX_cccc01100101nnnndddd11110011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUASX_cccc01100101nnnndddd11110011mmmm_case_0);
};

class NamedUBFX_cccc0111111mmmmmddddlllll101nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedUBFX_cccc0111111mmmmmddddlllll101nnnn_case_0()
    : NamedClassDecoder(decoder_, "UBFX_cccc0111111mmmmmddddlllll101nnnn_case_0")
  {}

 private:
  nacl_arm_dec::UBFX_cccc0111111mmmmmddddlllll101nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUBFX_cccc0111111mmmmmddddlllll101nnnn_case_0);
};

class NamedUDIV_cccc01110011dddd1111mmmm0001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedUDIV_cccc01110011dddd1111mmmm0001nnnn_case_0()
    : NamedClassDecoder(decoder_, "UDIV_cccc01110011dddd1111mmmm0001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::UDIV_cccc01110011dddd1111mmmm0001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUDIV_cccc01110011dddd1111mmmm0001nnnn_case_0);
};

class NamedUHADD16_cccc01100111nnnndddd11110001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUHADD16_cccc01100111nnnndddd11110001mmmm_case_0()
    : NamedClassDecoder(decoder_, "UHADD16_cccc01100111nnnndddd11110001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UHADD16_cccc01100111nnnndddd11110001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUHADD16_cccc01100111nnnndddd11110001mmmm_case_0);
};

class NamedUHADD8_cccc01100111nnnndddd11111001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUHADD8_cccc01100111nnnndddd11111001mmmm_case_0()
    : NamedClassDecoder(decoder_, "UHADD8_cccc01100111nnnndddd11111001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UHADD8_cccc01100111nnnndddd11111001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUHADD8_cccc01100111nnnndddd11111001mmmm_case_0);
};

class NamedUHASX_cccc01100111nnnndddd11110011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUHASX_cccc01100111nnnndddd11110011mmmm_case_0()
    : NamedClassDecoder(decoder_, "UHASX_cccc01100111nnnndddd11110011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UHASX_cccc01100111nnnndddd11110011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUHASX_cccc01100111nnnndddd11110011mmmm_case_0);
};

class NamedUHSAX_cccc01100111nnnndddd11110101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUHSAX_cccc01100111nnnndddd11110101mmmm_case_0()
    : NamedClassDecoder(decoder_, "UHSAX_cccc01100111nnnndddd11110101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UHSAX_cccc01100111nnnndddd11110101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUHSAX_cccc01100111nnnndddd11110101mmmm_case_0);
};

class NamedUHSUB16_cccc01100111nnnndddd11110111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUHSUB16_cccc01100111nnnndddd11110111mmmm_case_0()
    : NamedClassDecoder(decoder_, "UHSUB16_cccc01100111nnnndddd11110111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UHSUB16_cccc01100111nnnndddd11110111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUHSUB16_cccc01100111nnnndddd11110111mmmm_case_0);
};

class NamedUHSUB8_cccc01100111nnnndddd11111111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUHSUB8_cccc01100111nnnndddd11111111mmmm_case_0()
    : NamedClassDecoder(decoder_, "UHSUB8_cccc01100111nnnndddd11111111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UHSUB8_cccc01100111nnnndddd11111111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUHSUB8_cccc01100111nnnndddd11111111mmmm_case_0);
};

class NamedUMAAL_A1_cccc00000100hhhhllllmmmm1001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedUMAAL_A1_cccc00000100hhhhllllmmmm1001nnnn_case_0()
    : NamedClassDecoder(decoder_, "UMAAL_A1_cccc00000100hhhhllllmmmm1001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::UMAAL_A1_cccc00000100hhhhllllmmmm1001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUMAAL_A1_cccc00000100hhhhllllmmmm1001nnnn_case_0);
};

class NamedUMLAL_A1_cccc0000101shhhhllllmmmm1001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedUMLAL_A1_cccc0000101shhhhllllmmmm1001nnnn_case_0()
    : NamedClassDecoder(decoder_, "UMLAL_A1_cccc0000101shhhhllllmmmm1001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::UMLAL_A1_cccc0000101shhhhllllmmmm1001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUMLAL_A1_cccc0000101shhhhllllmmmm1001nnnn_case_0);
};

class NamedUMULL_A1_cccc0000100shhhhllllmmmm1001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedUMULL_A1_cccc0000100shhhhllllmmmm1001nnnn_case_0()
    : NamedClassDecoder(decoder_, "UMULL_A1_cccc0000100shhhhllllmmmm1001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::UMULL_A1_cccc0000100shhhhllllmmmm1001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUMULL_A1_cccc0000100shhhhllllmmmm1001nnnn_case_0);
};

class NamedUQADD16_cccc01100110nnnndddd11110001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUQADD16_cccc01100110nnnndddd11110001mmmm_case_0()
    : NamedClassDecoder(decoder_, "UQADD16_cccc01100110nnnndddd11110001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UQADD16_cccc01100110nnnndddd11110001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUQADD16_cccc01100110nnnndddd11110001mmmm_case_0);
};

class NamedUQADD8_cccc01100110nnnndddd11111001mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUQADD8_cccc01100110nnnndddd11111001mmmm_case_0()
    : NamedClassDecoder(decoder_, "UQADD8_cccc01100110nnnndddd11111001mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UQADD8_cccc01100110nnnndddd11111001mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUQADD8_cccc01100110nnnndddd11111001mmmm_case_0);
};

class NamedUQASX_cccc01100110nnnndddd11110011mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUQASX_cccc01100110nnnndddd11110011mmmm_case_0()
    : NamedClassDecoder(decoder_, "UQASX_cccc01100110nnnndddd11110011mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UQASX_cccc01100110nnnndddd11110011mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUQASX_cccc01100110nnnndddd11110011mmmm_case_0);
};

class NamedUQSAX_cccc01100110nnnndddd11110101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUQSAX_cccc01100110nnnndddd11110101mmmm_case_0()
    : NamedClassDecoder(decoder_, "UQSAX_cccc01100110nnnndddd11110101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UQSAX_cccc01100110nnnndddd11110101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUQSAX_cccc01100110nnnndddd11110101mmmm_case_0);
};

class NamedUQSUB16_cccc01100110nnnndddd11110111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUQSUB16_cccc01100110nnnndddd11110111mmmm_case_0()
    : NamedClassDecoder(decoder_, "UQSUB16_cccc01100110nnnndddd11110111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UQSUB16_cccc01100110nnnndddd11110111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUQSUB16_cccc01100110nnnndddd11110111mmmm_case_0);
};

class NamedUQSUB8_cccc01100110nnnndddd11111111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUQSUB8_cccc01100110nnnndddd11111111mmmm_case_0()
    : NamedClassDecoder(decoder_, "UQSUB8_cccc01100110nnnndddd11111111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UQSUB8_cccc01100110nnnndddd11111111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUQSUB8_cccc01100110nnnndddd11111111mmmm_case_0);
};

class NamedUSAD8_cccc01111000dddd1111mmmm0001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedUSAD8_cccc01111000dddd1111mmmm0001nnnn_case_0()
    : NamedClassDecoder(decoder_, "USAD8_cccc01111000dddd1111mmmm0001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::USAD8_cccc01111000dddd1111mmmm0001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUSAD8_cccc01111000dddd1111mmmm0001nnnn_case_0);
};

class NamedUSADA8_cccc01111000ddddaaaammmm0001nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedUSADA8_cccc01111000ddddaaaammmm0001nnnn_case_0()
    : NamedClassDecoder(decoder_, "USADA8_cccc01111000ddddaaaammmm0001nnnn_case_0")
  {}

 private:
  nacl_arm_dec::USADA8_cccc01111000ddddaaaammmm0001nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUSADA8_cccc01111000ddddaaaammmm0001nnnn_case_0);
};

class NamedUSAT16_cccc01101110iiiidddd11110011nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedUSAT16_cccc01101110iiiidddd11110011nnnn_case_0()
    : NamedClassDecoder(decoder_, "USAT16_cccc01101110iiiidddd11110011nnnn_case_0")
  {}

 private:
  nacl_arm_dec::USAT16_cccc01101110iiiidddd11110011nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUSAT16_cccc01101110iiiidddd11110011nnnn_case_0);
};

class NamedUSAT_cccc0110111iiiiiddddiiiiis01nnnn_case_0
    : public NamedClassDecoder {
 public:
  NamedUSAT_cccc0110111iiiiiddddiiiiis01nnnn_case_0()
    : NamedClassDecoder(decoder_, "USAT_cccc0110111iiiiiddddiiiiis01nnnn_case_0")
  {}

 private:
  nacl_arm_dec::USAT_cccc0110111iiiiiddddiiiiis01nnnn_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUSAT_cccc0110111iiiiiddddiiiiis01nnnn_case_0);
};

class NamedUSAX_cccc01100101nnnndddd11110101mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUSAX_cccc01100101nnnndddd11110101mmmm_case_0()
    : NamedClassDecoder(decoder_, "USAX_cccc01100101nnnndddd11110101mmmm_case_0")
  {}

 private:
  nacl_arm_dec::USAX_cccc01100101nnnndddd11110101mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUSAX_cccc01100101nnnndddd11110101mmmm_case_0);
};

class NamedUSUB16_cccc01100101nnnndddd11110111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUSUB16_cccc01100101nnnndddd11110111mmmm_case_0()
    : NamedClassDecoder(decoder_, "USUB16_cccc01100101nnnndddd11110111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::USUB16_cccc01100101nnnndddd11110111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUSUB16_cccc01100101nnnndddd11110111mmmm_case_0);
};

class NamedUSUB8_cccc01100101nnnndddd11111111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUSUB8_cccc01100101nnnndddd11111111mmmm_case_0()
    : NamedClassDecoder(decoder_, "USUB8_cccc01100101nnnndddd11111111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::USUB8_cccc01100101nnnndddd11111111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUSUB8_cccc01100101nnnndddd11111111mmmm_case_0);
};

class NamedUXTAB16_cccc01101100nnnnddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUXTAB16_cccc01101100nnnnddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "UXTAB16_cccc01101100nnnnddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UXTAB16_cccc01101100nnnnddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUXTAB16_cccc01101100nnnnddddrr000111mmmm_case_0);
};

class NamedUXTAB_cccc01101110nnnnddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUXTAB_cccc01101110nnnnddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "UXTAB_cccc01101110nnnnddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UXTAB_cccc01101110nnnnddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUXTAB_cccc01101110nnnnddddrr000111mmmm_case_0);
};

class NamedUXTAH_cccc01101111nnnnddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUXTAH_cccc01101111nnnnddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "UXTAH_cccc01101111nnnnddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UXTAH_cccc01101111nnnnddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUXTAH_cccc01101111nnnnddddrr000111mmmm_case_0);
};

class NamedUXTB16_cccc011011001111ddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUXTB16_cccc011011001111ddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "UXTB16_cccc011011001111ddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UXTB16_cccc011011001111ddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUXTB16_cccc011011001111ddddrr000111mmmm_case_0);
};

class NamedUXTB_cccc011011101111ddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUXTB_cccc011011101111ddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "UXTB_cccc011011101111ddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UXTB_cccc011011101111ddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUXTB_cccc011011101111ddddrr000111mmmm_case_0);
};

class NamedUXTH_cccc011011111111ddddrr000111mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedUXTH_cccc011011111111ddddrr000111mmmm_case_0()
    : NamedClassDecoder(decoder_, "UXTH_cccc011011111111ddddrr000111mmmm_case_0")
  {}

 private:
  nacl_arm_dec::UXTH_cccc011011111111ddddrr000111mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUXTH_cccc011011111111ddddrr000111mmmm_case_0);
};

class NamedUnnamed_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_case_0);
};

class NamedVABAL_A2_1111001u1dssnnnndddd0101n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVABAL_A2_1111001u1dssnnnndddd0101n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VABAL_A2_1111001u1dssnnnndddd0101n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VABAL_A2_1111001u1dssnnnndddd0101n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVABAL_A2_1111001u1dssnnnndddd0101n0m0mmmm_case_0);
};

class NamedVABA_1111001u0dssnnnndddd0111nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVABA_1111001u0dssnnnndddd0111nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VABA_1111001u0dssnnnndddd0111nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VABA_1111001u0dssnnnndddd0111nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVABA_1111001u0dssnnnndddd0111nqm1mmmm_case_0);
};

class NamedVABDL_integer_A2_1111001u1dssnnnndddd0111n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVABDL_integer_A2_1111001u1dssnnnndddd0111n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VABDL_integer_A2_1111001u1dssnnnndddd0111n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VABDL_integer_A2_1111001u1dssnnnndddd0111n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVABDL_integer_A2_1111001u1dssnnnndddd0111n0m0mmmm_case_0);
};

class NamedVABD_1111001u0dssnnnndddd0111nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVABD_1111001u0dssnnnndddd0111nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VABD_1111001u0dssnnnndddd0111nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VABD_1111001u0dssnnnndddd0111nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVABD_1111001u0dssnnnndddd0111nqm0mmmm_case_0);
};

class NamedVABD_floating_point_111100110d1snnnndddd1101nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVABD_floating_point_111100110d1snnnndddd1101nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VABD_floating_point_111100110d1snnnndddd1101nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VABD_floating_point_111100110d1snnnndddd1101nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVABD_floating_point_111100110d1snnnndddd1101nqm0mmmm_case_0);
};

class NamedVABS_A1_111100111d11ss01dddd0f110qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVABS_A1_111100111d11ss01dddd0f110qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VABS_A1_111100111d11ss01dddd0f110qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VABS_A1_111100111d11ss01dddd0f110qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVABS_A1_111100111d11ss01dddd0f110qm0mmmm_case_0);
};

class NamedVABS_A1_111100111d11ss01dddd0f110qm0mmmm_case_1
    : public NamedClassDecoder {
 public:
  NamedVABS_A1_111100111d11ss01dddd0f110qm0mmmm_case_1()
    : NamedClassDecoder(decoder_, "VABS_A1_111100111d11ss01dddd0f110qm0mmmm_case_1")
  {}

 private:
  nacl_arm_dec::VABS_A1_111100111d11ss01dddd0f110qm0mmmm_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVABS_A1_111100111d11ss01dddd0f110qm0mmmm_case_1);
};

class NamedVABS_cccc11101d110000dddd101s11m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVABS_cccc11101d110000dddd101s11m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VABS_cccc11101d110000dddd101s11m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VABS_cccc11101d110000dddd101s11m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVABS_cccc11101d110000dddd101s11m0mmmm_case_0);
};

class NamedVACGE_111100110dssnnnndddd1110nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVACGE_111100110dssnnnndddd1110nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VACGE_111100110dssnnnndddd1110nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VACGE_111100110dssnnnndddd1110nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVACGE_111100110dssnnnndddd1110nqm1mmmm_case_0);
};

class NamedVACGT_111100110dssnnnndddd1110nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVACGT_111100110dssnnnndddd1110nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VACGT_111100110dssnnnndddd1110nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VACGT_111100110dssnnnndddd1110nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVACGT_111100110dssnnnndddd1110nqm1mmmm_case_0);
};

class NamedVADDHN_111100101dssnnnndddd0100n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVADDHN_111100101dssnnnndddd0100n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VADDHN_111100101dssnnnndddd0100n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VADDHN_111100101dssnnnndddd0100n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVADDHN_111100101dssnnnndddd0100n0m0mmmm_case_0);
};

class NamedVADDL_VADDW_1111001u1dssnnnndddd000pn0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVADDL_VADDW_1111001u1dssnnnndddd000pn0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VADDL_VADDW_1111001u1dssnnnndddd000pn0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VADDL_VADDW_1111001u1dssnnnndddd000pn0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVADDL_VADDW_1111001u1dssnnnndddd000pn0m0mmmm_case_0);
};

class NamedVADD_floating_point_A1_111100100d0snnnndddd1101nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVADD_floating_point_A1_111100100d0snnnndddd1101nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VADD_floating_point_A1_111100100d0snnnndddd1101nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VADD_floating_point_A1_111100100d0snnnndddd1101nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVADD_floating_point_A1_111100100d0snnnndddd1101nqm0mmmm_case_0);
};

class NamedVADD_floating_point_cccc11100d11nnnndddd101sn0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVADD_floating_point_cccc11100d11nnnndddd101sn0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VADD_floating_point_cccc11100d11nnnndddd101sn0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VADD_floating_point_cccc11100d11nnnndddd101sn0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVADD_floating_point_cccc11100d11nnnndddd101sn0m0mmmm_case_0);
};

class NamedVADD_integer_111100100dssnnnndddd1000nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVADD_integer_111100100dssnnnndddd1000nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VADD_integer_111100100dssnnnndddd1000nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VADD_integer_111100100dssnnnndddd1000nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVADD_integer_111100100dssnnnndddd1000nqm0mmmm_case_0);
};

class NamedVAND_register_111100100d00nnnndddd0001nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVAND_register_111100100d00nnnndddd0001nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VAND_register_111100100d00nnnndddd0001nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VAND_register_111100100d00nnnndddd0001nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVAND_register_111100100d00nnnndddd0001nqm1mmmm_case_0);
};

class NamedVBIC_immediate_1111001i1d000mmmddddcccc0q11mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVBIC_immediate_1111001i1d000mmmddddcccc0q11mmmm_case_0()
    : NamedClassDecoder(decoder_, "VBIC_immediate_1111001i1d000mmmddddcccc0q11mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VBIC_immediate_1111001i1d000mmmddddcccc0q11mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVBIC_immediate_1111001i1d000mmmddddcccc0q11mmmm_case_0);
};

class NamedVBIC_register_111100100d01nnnndddd0001nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVBIC_register_111100100d01nnnndddd0001nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VBIC_register_111100100d01nnnndddd0001nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VBIC_register_111100100d01nnnndddd0001nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVBIC_register_111100100d01nnnndddd0001nqm1mmmm_case_0);
};

class NamedVBIF_111100110d11nnnndddd0001nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVBIF_111100110d11nnnndddd0001nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VBIF_111100110d11nnnndddd0001nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VBIF_111100110d11nnnndddd0001nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVBIF_111100110d11nnnndddd0001nqm1mmmm_case_0);
};

class NamedVBIT_111100110d10nnnndddd0001nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVBIT_111100110d10nnnndddd0001nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VBIT_111100110d10nnnndddd0001nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VBIT_111100110d10nnnndddd0001nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVBIT_111100110d10nnnndddd0001nqm1mmmm_case_0);
};

class NamedVBSL_111100110d01nnnndddd0001nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVBSL_111100110d01nnnndddd0001nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VBSL_111100110d01nnnndddd0001nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VBSL_111100110d01nnnndddd0001nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVBSL_111100110d01nnnndddd0001nqm1mmmm_case_0);
};

class NamedVCEQ_immediate_0_111100111d11ss01dddd0f010qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCEQ_immediate_0_111100111d11ss01dddd0f010qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCEQ_immediate_0_111100111d11ss01dddd0f010qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCEQ_immediate_0_111100111d11ss01dddd0f010qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCEQ_immediate_0_111100111d11ss01dddd0f010qm0mmmm_case_0);
};

class NamedVCEQ_immediate_0_111100111d11ss01dddd0f010qm0mmmm_case_1
    : public NamedClassDecoder {
 public:
  NamedVCEQ_immediate_0_111100111d11ss01dddd0f010qm0mmmm_case_1()
    : NamedClassDecoder(decoder_, "VCEQ_immediate_0_111100111d11ss01dddd0f010qm0mmmm_case_1")
  {}

 private:
  nacl_arm_dec::VCEQ_immediate_0_111100111d11ss01dddd0f010qm0mmmm_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCEQ_immediate_0_111100111d11ss01dddd0f010qm0mmmm_case_1);
};

class NamedVCEQ_register_A1_111100110dssnnnndddd1000nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCEQ_register_A1_111100110dssnnnndddd1000nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCEQ_register_A1_111100110dssnnnndddd1000nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCEQ_register_A1_111100110dssnnnndddd1000nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCEQ_register_A1_111100110dssnnnndddd1000nqm1mmmm_case_0);
};

class NamedVCEQ_register_A2_111100100d0snnnndddd1110nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCEQ_register_A2_111100100d0snnnndddd1110nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCEQ_register_A2_111100100d0snnnndddd1110nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCEQ_register_A2_111100100d0snnnndddd1110nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCEQ_register_A2_111100100d0snnnndddd1110nqm0mmmm_case_0);
};

class NamedVCGE_immediate_0_111100111d11ss01dddd0f001qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCGE_immediate_0_111100111d11ss01dddd0f001qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCGE_immediate_0_111100111d11ss01dddd0f001qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCGE_immediate_0_111100111d11ss01dddd0f001qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCGE_immediate_0_111100111d11ss01dddd0f001qm0mmmm_case_0);
};

class NamedVCGE_immediate_0_111100111d11ss01dddd0f001qm0mmmm_case_1
    : public NamedClassDecoder {
 public:
  NamedVCGE_immediate_0_111100111d11ss01dddd0f001qm0mmmm_case_1()
    : NamedClassDecoder(decoder_, "VCGE_immediate_0_111100111d11ss01dddd0f001qm0mmmm_case_1")
  {}

 private:
  nacl_arm_dec::VCGE_immediate_0_111100111d11ss01dddd0f001qm0mmmm_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCGE_immediate_0_111100111d11ss01dddd0f001qm0mmmm_case_1);
};

class NamedVCGE_register_A1_1111001u0dssnnnndddd0011nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCGE_register_A1_1111001u0dssnnnndddd0011nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCGE_register_A1_1111001u0dssnnnndddd0011nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCGE_register_A1_1111001u0dssnnnndddd0011nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCGE_register_A1_1111001u0dssnnnndddd0011nqm1mmmm_case_0);
};

class NamedVCGE_register_A2_111100110d0snnnndddd1110nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCGE_register_A2_111100110d0snnnndddd1110nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCGE_register_A2_111100110d0snnnndddd1110nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCGE_register_A2_111100110d0snnnndddd1110nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCGE_register_A2_111100110d0snnnndddd1110nqm0mmmm_case_0);
};

class NamedVCGT_immediate_0_111100111d11ss01dddd0f000qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCGT_immediate_0_111100111d11ss01dddd0f000qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCGT_immediate_0_111100111d11ss01dddd0f000qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCGT_immediate_0_111100111d11ss01dddd0f000qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCGT_immediate_0_111100111d11ss01dddd0f000qm0mmmm_case_0);
};

class NamedVCGT_immediate_0_111100111d11ss01dddd0f000qm0mmmm_case_1
    : public NamedClassDecoder {
 public:
  NamedVCGT_immediate_0_111100111d11ss01dddd0f000qm0mmmm_case_1()
    : NamedClassDecoder(decoder_, "VCGT_immediate_0_111100111d11ss01dddd0f000qm0mmmm_case_1")
  {}

 private:
  nacl_arm_dec::VCGT_immediate_0_111100111d11ss01dddd0f000qm0mmmm_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCGT_immediate_0_111100111d11ss01dddd0f000qm0mmmm_case_1);
};

class NamedVCGT_register_A1_1111001u0dssnnnndddd0011nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCGT_register_A1_1111001u0dssnnnndddd0011nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCGT_register_A1_1111001u0dssnnnndddd0011nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCGT_register_A1_1111001u0dssnnnndddd0011nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCGT_register_A1_1111001u0dssnnnndddd0011nqm0mmmm_case_0);
};

class NamedVCGT_register_A2_111100110d1snnnndddd1110nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCGT_register_A2_111100110d1snnnndddd1110nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCGT_register_A2_111100110d1snnnndddd1110nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCGT_register_A2_111100110d1snnnndddd1110nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCGT_register_A2_111100110d1snnnndddd1110nqm0mmmm_case_0);
};

class NamedVCLE_immediate_0_111100111d11ss01dddd0f011qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCLE_immediate_0_111100111d11ss01dddd0f011qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCLE_immediate_0_111100111d11ss01dddd0f011qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCLE_immediate_0_111100111d11ss01dddd0f011qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCLE_immediate_0_111100111d11ss01dddd0f011qm0mmmm_case_0);
};

class NamedVCLE_immediate_0_111100111d11ss01dddd0f011qm0mmmm_case_1
    : public NamedClassDecoder {
 public:
  NamedVCLE_immediate_0_111100111d11ss01dddd0f011qm0mmmm_case_1()
    : NamedClassDecoder(decoder_, "VCLE_immediate_0_111100111d11ss01dddd0f011qm0mmmm_case_1")
  {}

 private:
  nacl_arm_dec::VCLE_immediate_0_111100111d11ss01dddd0f011qm0mmmm_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCLE_immediate_0_111100111d11ss01dddd0f011qm0mmmm_case_1);
};

class NamedVCLS_111100111d11ss00dddd01000qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCLS_111100111d11ss00dddd01000qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCLS_111100111d11ss00dddd01000qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCLS_111100111d11ss00dddd01000qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCLS_111100111d11ss00dddd01000qm0mmmm_case_0);
};

class NamedVCLT_immediate_0_111100111d11ss01dddd0f100qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCLT_immediate_0_111100111d11ss01dddd0f100qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCLT_immediate_0_111100111d11ss01dddd0f100qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCLT_immediate_0_111100111d11ss01dddd0f100qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCLT_immediate_0_111100111d11ss01dddd0f100qm0mmmm_case_0);
};

class NamedVCLT_immediate_0_111100111d11ss01dddd0f100qm0mmmm_case_1
    : public NamedClassDecoder {
 public:
  NamedVCLT_immediate_0_111100111d11ss01dddd0f100qm0mmmm_case_1()
    : NamedClassDecoder(decoder_, "VCLT_immediate_0_111100111d11ss01dddd0f100qm0mmmm_case_1")
  {}

 private:
  nacl_arm_dec::VCLT_immediate_0_111100111d11ss01dddd0f100qm0mmmm_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCLT_immediate_0_111100111d11ss01dddd0f100qm0mmmm_case_1);
};

class NamedVCLZ_111100111d11ss00dddd01001qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCLZ_111100111d11ss00dddd01001qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCLZ_111100111d11ss00dddd01001qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCLZ_111100111d11ss00dddd01001qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCLZ_111100111d11ss00dddd01001qm0mmmm_case_0);
};

class NamedVCMP_VCMPE_cccc11101d110100dddd101se1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCMP_VCMPE_cccc11101d110100dddd101se1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCMP_VCMPE_cccc11101d110100dddd101se1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCMP_VCMPE_cccc11101d110100dddd101se1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCMP_VCMPE_cccc11101d110100dddd101se1m0mmmm_case_0);
};

class NamedVCMP_VCMPE_cccc11101d110101dddd101se1000000_case_0
    : public NamedClassDecoder {
 public:
  NamedVCMP_VCMPE_cccc11101d110101dddd101se1000000_case_0()
    : NamedClassDecoder(decoder_, "VCMP_VCMPE_cccc11101d110101dddd101se1000000_case_0")
  {}

 private:
  nacl_arm_dec::VCMP_VCMPE_cccc11101d110101dddd101se1000000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCMP_VCMPE_cccc11101d110101dddd101se1000000_case_0);
};

class NamedVCNT_111100111d11ss00dddd01010qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCNT_111100111d11ss00dddd01010qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCNT_111100111d11ss00dddd01010qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCNT_111100111d11ss00dddd01010qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCNT_111100111d11ss00dddd01010qm0mmmm_case_0);
};

class NamedVCVTB_VCVTT_cccc11101d11001odddd1010t1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCVTB_VCVTT_cccc11101d11001odddd1010t1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCVTB_VCVTT_cccc11101d11001odddd1010t1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCVTB_VCVTT_cccc11101d11001odddd1010t1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCVTB_VCVTT_cccc11101d11001odddd1010t1m0mmmm_case_0);
};

class NamedVCVT_111100111d11ss11dddd011ppqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCVT_111100111d11ss11dddd011ppqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCVT_111100111d11ss11dddd011ppqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCVT_111100111d11ss11dddd011ppqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCVT_111100111d11ss11dddd011ppqm0mmmm_case_0);
};

class NamedVCVT_VCVTR_between_floating_point_and_integer_Floating_point_cccc11101d111ooodddd101sp1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCVT_VCVTR_between_floating_point_and_integer_Floating_point_cccc11101d111ooodddd101sp1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCVT_VCVTR_between_floating_point_and_integer_Floating_point_cccc11101d111ooodddd101sp1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCVT_VCVTR_between_floating_point_and_integer_Floating_point_cccc11101d111ooodddd101sp1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCVT_VCVTR_between_floating_point_and_integer_Floating_point_cccc11101d111ooodddd101sp1m0mmmm_case_0);
};

class NamedVCVT_between_double_precision_and_single_precision_cccc11101d110111dddd101s11m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCVT_between_double_precision_and_single_precision_cccc11101d110111dddd101s11m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCVT_between_double_precision_and_single_precision_cccc11101d110111dddd101s11m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCVT_between_double_precision_and_single_precision_cccc11101d110111dddd101s11m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCVT_between_double_precision_and_single_precision_cccc11101d110111dddd101s11m0mmmm_case_0);
};

class NamedVCVT_between_floating_point_and_fixed_point_1111001u1diiiiiidddd111p0qm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVCVT_between_floating_point_and_fixed_point_1111001u1diiiiiidddd111p0qm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VCVT_between_floating_point_and_fixed_point_1111001u1diiiiiidddd111p0qm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VCVT_between_floating_point_and_fixed_point_1111001u1diiiiiidddd111p0qm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCVT_between_floating_point_and_fixed_point_1111001u1diiiiiidddd111p0qm1mmmm_case_0);
};

class NamedVCVT_between_floating_point_and_fixed_point_Floating_point_cccc11101d111o1udddd101fx1i0iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVCVT_between_floating_point_and_fixed_point_Floating_point_cccc11101d111o1udddd101fx1i0iiii_case_0()
    : NamedClassDecoder(decoder_, "VCVT_between_floating_point_and_fixed_point_Floating_point_cccc11101d111o1udddd101fx1i0iiii_case_0")
  {}

 private:
  nacl_arm_dec::VCVT_between_floating_point_and_fixed_point_Floating_point_cccc11101d111o1udddd101fx1i0iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVCVT_between_floating_point_and_fixed_point_Floating_point_cccc11101d111o1udddd101fx1i0iiii_case_0);
};

class NamedVDIV_cccc11101d00nnnndddd101sn0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVDIV_cccc11101d00nnnndddd101sn0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VDIV_cccc11101d00nnnndddd101sn0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VDIV_cccc11101d00nnnndddd101sn0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVDIV_cccc11101d00nnnndddd101sn0m0mmmm_case_0);
};

class NamedVDUP_arm_core_register_cccc11101bq0ddddtttt1011d0e10000_case_0
    : public NamedClassDecoder {
 public:
  NamedVDUP_arm_core_register_cccc11101bq0ddddtttt1011d0e10000_case_0()
    : NamedClassDecoder(decoder_, "VDUP_arm_core_register_cccc11101bq0ddddtttt1011d0e10000_case_0")
  {}

 private:
  nacl_arm_dec::VDUP_arm_core_register_cccc11101bq0ddddtttt1011d0e10000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVDUP_arm_core_register_cccc11101bq0ddddtttt1011d0e10000_case_0);
};

class NamedVEOR_111100110d00nnnndddd0001nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVEOR_111100110d00nnnndddd0001nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VEOR_111100110d00nnnndddd0001nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VEOR_111100110d00nnnndddd0001nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVEOR_111100110d00nnnndddd0001nqm1mmmm_case_0);
};

class NamedVFMA_A1_111100100d00nnnndddd1100nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVFMA_A1_111100100d00nnnndddd1100nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VFMA_A1_111100100d00nnnndddd1100nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VFMA_A1_111100100d00nnnndddd1100nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVFMA_A1_111100100d00nnnndddd1100nqm1mmmm_case_0);
};

class NamedVFMA_VFMS_cccc11101d10nnnndddd101snom0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVFMA_VFMS_cccc11101d10nnnndddd101snom0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VFMA_VFMS_cccc11101d10nnnndddd101snom0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VFMA_VFMS_cccc11101d10nnnndddd101snom0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVFMA_VFMS_cccc11101d10nnnndddd101snom0mmmm_case_0);
};

class NamedVFMS_A1_111100100d10nnnndddd1100nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVFMS_A1_111100100d10nnnndddd1100nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VFMS_A1_111100100d10nnnndddd1100nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VFMS_A1_111100100d10nnnndddd1100nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVFMS_A1_111100100d10nnnndddd1100nqm1mmmm_case_0);
};

class NamedVFNMA_VFNMS_cccc11101d01nnnndddd101snom0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVFNMA_VFNMS_cccc11101d01nnnndddd101snom0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VFNMA_VFNMS_cccc11101d01nnnndddd101snom0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VFNMA_VFNMS_cccc11101d01nnnndddd101snom0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVFNMA_VFNMS_cccc11101d01nnnndddd101snom0mmmm_case_0);
};

class NamedVHADD_1111001u0dssnnnndddd0000nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVHADD_1111001u0dssnnnndddd0000nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VHADD_1111001u0dssnnnndddd0000nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VHADD_1111001u0dssnnnndddd0000nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVHADD_1111001u0dssnnnndddd0000nqm0mmmm_case_0);
};

class NamedVHSUB_1111001u0dssnnnndddd0010nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVHSUB_1111001u0dssnnnndddd0010nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VHSUB_1111001u0dssnnnndddd0010nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VHSUB_1111001u0dssnnnndddd0010nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVHSUB_1111001u0dssnnnndddd0010nqm0mmmm_case_0);
};

class NamedVLD1_multiple_single_elements_111101000d10nnnnddddttttssaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD1_multiple_single_elements_111101000d10nnnnddddttttssaammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD1_multiple_single_elements_111101000d10nnnnddddttttssaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD1_multiple_single_elements_111101000d10nnnnddddttttssaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD1_multiple_single_elements_111101000d10nnnnddddttttssaammmm_case_0);
};

class NamedVLD1_single_element_to_all_lanes_111101001d10nnnndddd1100sstammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD1_single_element_to_all_lanes_111101001d10nnnndddd1100sstammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD1_single_element_to_all_lanes_111101001d10nnnndddd1100sstammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD1_single_element_to_all_lanes_111101001d10nnnndddd1100sstammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD1_single_element_to_all_lanes_111101001d10nnnndddd1100sstammmm_case_0);
};

class NamedVLD1_single_element_to_one_lane_111101001d10nnnnddddss00aaaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD1_single_element_to_one_lane_111101001d10nnnnddddss00aaaammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD1_single_element_to_one_lane_111101001d10nnnnddddss00aaaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD1_single_element_to_one_lane_111101001d10nnnnddddss00aaaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD1_single_element_to_one_lane_111101001d10nnnnddddss00aaaammmm_case_0);
};

class NamedVLD2_multiple_2_element_structures_111101000d10nnnnddddttttssaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD2_multiple_2_element_structures_111101000d10nnnnddddttttssaammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD2_multiple_2_element_structures_111101000d10nnnnddddttttssaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD2_multiple_2_element_structures_111101000d10nnnnddddttttssaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD2_multiple_2_element_structures_111101000d10nnnnddddttttssaammmm_case_0);
};

class NamedVLD2_single_2_element_structure_to_all_lanes_111101001d10nnnndddd1101sstammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD2_single_2_element_structure_to_all_lanes_111101001d10nnnndddd1101sstammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD2_single_2_element_structure_to_all_lanes_111101001d10nnnndddd1101sstammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD2_single_2_element_structure_to_all_lanes_111101001d10nnnndddd1101sstammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD2_single_2_element_structure_to_all_lanes_111101001d10nnnndddd1101sstammmm_case_0);
};

class NamedVLD2_single_2_element_structure_to_one_lane_111101001d10nnnnddddss01aaaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD2_single_2_element_structure_to_one_lane_111101001d10nnnnddddss01aaaammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD2_single_2_element_structure_to_one_lane_111101001d10nnnnddddss01aaaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD2_single_2_element_structure_to_one_lane_111101001d10nnnnddddss01aaaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD2_single_2_element_structure_to_one_lane_111101001d10nnnnddddss01aaaammmm_case_0);
};

class NamedVLD3_multiple_3_element_structures_111101000d10nnnnddddttttssaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD3_multiple_3_element_structures_111101000d10nnnnddddttttssaammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD3_multiple_3_element_structures_111101000d10nnnnddddttttssaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD3_multiple_3_element_structures_111101000d10nnnnddddttttssaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD3_multiple_3_element_structures_111101000d10nnnnddddttttssaammmm_case_0);
};

class NamedVLD3_single_3_element_structure_to_all_lanes_111101001d10nnnndddd1110sstammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD3_single_3_element_structure_to_all_lanes_111101001d10nnnndddd1110sstammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD3_single_3_element_structure_to_all_lanes_111101001d10nnnndddd1110sstammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD3_single_3_element_structure_to_all_lanes_111101001d10nnnndddd1110sstammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD3_single_3_element_structure_to_all_lanes_111101001d10nnnndddd1110sstammmm_case_0);
};

class NamedVLD3_single_3_element_structure_to_one_lane_111101001d10nnnnddddss10aaaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD3_single_3_element_structure_to_one_lane_111101001d10nnnnddddss10aaaammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD3_single_3_element_structure_to_one_lane_111101001d10nnnnddddss10aaaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD3_single_3_element_structure_to_one_lane_111101001d10nnnnddddss10aaaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD3_single_3_element_structure_to_one_lane_111101001d10nnnnddddss10aaaammmm_case_0);
};

class NamedVLD4_multiple_4_element_structures_111101000d10nnnnddddttttssaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD4_multiple_4_element_structures_111101000d10nnnnddddttttssaammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD4_multiple_4_element_structures_111101000d10nnnnddddttttssaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD4_multiple_4_element_structures_111101000d10nnnnddddttttssaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD4_multiple_4_element_structures_111101000d10nnnnddddttttssaammmm_case_0);
};

class NamedVLD4_single_4_element_structure_to_all_lanes_111101001d10nnnndddd1111sstammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD4_single_4_element_structure_to_all_lanes_111101001d10nnnndddd1111sstammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD4_single_4_element_structure_to_all_lanes_111101001d10nnnndddd1111sstammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD4_single_4_element_structure_to_all_lanes_111101001d10nnnndddd1111sstammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD4_single_4_element_structure_to_all_lanes_111101001d10nnnndddd1111sstammmm_case_0);
};

class NamedVLD4_single_4_element_structure_to_one_lane_111101001d10nnnnddddss11aaaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVLD4_single_4_element_structure_to_one_lane_111101001d10nnnnddddss11aaaammmm_case_0()
    : NamedClassDecoder(decoder_, "VLD4_single_4_element_structure_to_one_lane_111101001d10nnnnddddss11aaaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VLD4_single_4_element_structure_to_one_lane_111101001d10nnnnddddss11aaaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLD4_single_4_element_structure_to_one_lane_111101001d10nnnnddddss11aaaammmm_case_0);
};

class NamedVLDM_cccc110pudw1nnnndddd1010iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVLDM_cccc110pudw1nnnndddd1010iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VLDM_cccc110pudw1nnnndddd1010iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VLDM_cccc110pudw1nnnndddd1010iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLDM_cccc110pudw1nnnndddd1010iiiiiiii_case_0);
};

class NamedVLDM_cccc110pudw1nnnndddd1011iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVLDM_cccc110pudw1nnnndddd1011iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VLDM_cccc110pudw1nnnndddd1011iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VLDM_cccc110pudw1nnnndddd1011iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLDM_cccc110pudw1nnnndddd1011iiiiiiii_case_0);
};

class NamedVLDR_cccc1101ud01nnnndddd1010iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVLDR_cccc1101ud01nnnndddd1010iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VLDR_cccc1101ud01nnnndddd1010iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VLDR_cccc1101ud01nnnndddd1010iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLDR_cccc1101ud01nnnndddd1010iiiiiiii_case_0);
};

class NamedVLDR_cccc1101ud01nnnndddd1011iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVLDR_cccc1101ud01nnnndddd1011iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VLDR_cccc1101ud01nnnndddd1011iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VLDR_cccc1101ud01nnnndddd1011iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVLDR_cccc1101ud01nnnndddd1011iiiiiiii_case_0);
};

class NamedVMAX_1111001u0dssnnnndddd0110nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMAX_1111001u0dssnnnndddd0110nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMAX_1111001u0dssnnnndddd0110nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMAX_1111001u0dssnnnndddd0110nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMAX_1111001u0dssnnnndddd0110nqm0mmmm_case_0);
};

class NamedVMAX_floating_point_111100100dssnnnndddd1111nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMAX_floating_point_111100100dssnnnndddd1111nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMAX_floating_point_111100100dssnnnndddd1111nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMAX_floating_point_111100100dssnnnndddd1111nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMAX_floating_point_111100100dssnnnndddd1111nqm0mmmm_case_0);
};

class NamedVMIN_1111001u0dssnnnndddd0110nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMIN_1111001u0dssnnnndddd0110nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMIN_1111001u0dssnnnndddd0110nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMIN_1111001u0dssnnnndddd0110nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMIN_1111001u0dssnnnndddd0110nqm1mmmm_case_0);
};

class NamedVMIN_floating_point_111100100dssnnnndddd1111nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMIN_floating_point_111100100dssnnnndddd1111nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMIN_floating_point_111100100dssnnnndddd1111nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMIN_floating_point_111100100dssnnnndddd1111nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMIN_floating_point_111100100dssnnnndddd1111nqm0mmmm_case_0);
};

class NamedVMLAL_VMLSL_integer_A2_1111001u1dssnnnndddd10p0n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMLAL_VMLSL_integer_A2_1111001u1dssnnnndddd10p0n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMLAL_VMLSL_integer_A2_1111001u1dssnnnndddd10p0n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMLAL_VMLSL_integer_A2_1111001u1dssnnnndddd10p0n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLAL_VMLSL_integer_A2_1111001u1dssnnnndddd10p0n0m0mmmm_case_0);
};

class NamedVMLAL_by_scalar_A2_1111001u1dssnnnndddd0p10n1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMLAL_by_scalar_A2_1111001u1dssnnnndddd0p10n1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMLAL_by_scalar_A2_1111001u1dssnnnndddd0p10n1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMLAL_by_scalar_A2_1111001u1dssnnnndddd0p10n1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLAL_by_scalar_A2_1111001u1dssnnnndddd0p10n1m0mmmm_case_0);
};

class NamedVMLA_VMLS_floating_point_cccc11100d00nnnndddd101snom0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMLA_VMLS_floating_point_cccc11100d00nnnndddd101snom0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMLA_VMLS_floating_point_cccc11100d00nnnndddd101snom0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMLA_VMLS_floating_point_cccc11100d00nnnndddd101snom0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLA_VMLS_floating_point_cccc11100d00nnnndddd101snom0mmmm_case_0);
};

class NamedVMLA_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMLA_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMLA_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMLA_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLA_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_0);
};

class NamedVMLA_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_1
    : public NamedClassDecoder {
 public:
  NamedVMLA_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_1()
    : NamedClassDecoder(decoder_, "VMLA_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_1")
  {}

 private:
  nacl_arm_dec::VMLA_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLA_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_1);
};

class NamedVMLA_floating_point_A1_111100100dpsnnnndddd1101nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMLA_floating_point_A1_111100100dpsnnnndddd1101nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMLA_floating_point_A1_111100100dpsnnnndddd1101nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMLA_floating_point_A1_111100100dpsnnnndddd1101nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLA_floating_point_A1_111100100dpsnnnndddd1101nqm1mmmm_case_0);
};

class NamedVMLA_integer_A1_1111001u0dssnnnndddd1001nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMLA_integer_A1_1111001u0dssnnnndddd1001nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMLA_integer_A1_1111001u0dssnnnndddd1001nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMLA_integer_A1_1111001u0dssnnnndddd1001nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLA_integer_A1_1111001u0dssnnnndddd1001nqm0mmmm_case_0);
};

class NamedVMLSL_by_scalar_A2_1111001u1dssnnnndddd0p10n1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMLSL_by_scalar_A2_1111001u1dssnnnndddd0p10n1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMLSL_by_scalar_A2_1111001u1dssnnnndddd0p10n1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMLSL_by_scalar_A2_1111001u1dssnnnndddd0p10n1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLSL_by_scalar_A2_1111001u1dssnnnndddd0p10n1m0mmmm_case_0);
};

class NamedVMLS_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMLS_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMLS_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMLS_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLS_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_0);
};

class NamedVMLS_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_1
    : public NamedClassDecoder {
 public:
  NamedVMLS_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_1()
    : NamedClassDecoder(decoder_, "VMLS_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_1")
  {}

 private:
  nacl_arm_dec::VMLS_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLS_by_scalar_A1_1111001q1dssnnnndddd0p0fn1m0mmmm_case_1);
};

class NamedVMLS_floating_point_A1_111100100dpsnnnndddd1101nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMLS_floating_point_A1_111100100dpsnnnndddd1101nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMLS_floating_point_A1_111100100dpsnnnndddd1101nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMLS_floating_point_A1_111100100dpsnnnndddd1101nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLS_floating_point_A1_111100100dpsnnnndddd1101nqm1mmmm_case_0);
};

class NamedVMLS_integer_A1_1111001u0dssnnnndddd1001nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMLS_integer_A1_1111001u0dssnnnndddd1001nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMLS_integer_A1_1111001u0dssnnnndddd1001nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMLS_integer_A1_1111001u0dssnnnndddd1001nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMLS_integer_A1_1111001u0dssnnnndddd1001nqm0mmmm_case_0);
};

class NamedVMOVN_111100111d11ss10dddd001000m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMOVN_111100111d11ss10dddd001000m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMOVN_111100111d11ss10dddd001000m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMOVN_111100111d11ss10dddd001000m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMOVN_111100111d11ss10dddd001000m0mmmm_case_0);
};

class NamedVMOV_ARM_core_register_to_scalar_cccc11100ii0ddddtttt1011dii10000_case_0
    : public NamedClassDecoder {
 public:
  NamedVMOV_ARM_core_register_to_scalar_cccc11100ii0ddddtttt1011dii10000_case_0()
    : NamedClassDecoder(decoder_, "VMOV_ARM_core_register_to_scalar_cccc11100ii0ddddtttt1011dii10000_case_0")
  {}

 private:
  nacl_arm_dec::VMOV_ARM_core_register_to_scalar_cccc11100ii0ddddtttt1011dii10000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMOV_ARM_core_register_to_scalar_cccc11100ii0ddddtttt1011dii10000_case_0);
};

class NamedVMOV_between_ARM_core_register_and_single_precision_register_cccc1110000onnnntttt1010n0010000_case_0
    : public NamedClassDecoder {
 public:
  NamedVMOV_between_ARM_core_register_and_single_precision_register_cccc1110000onnnntttt1010n0010000_case_0()
    : NamedClassDecoder(decoder_, "VMOV_between_ARM_core_register_and_single_precision_register_cccc1110000onnnntttt1010n0010000_case_0")
  {}

 private:
  nacl_arm_dec::VMOV_between_ARM_core_register_and_single_precision_register_cccc1110000onnnntttt1010n0010000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMOV_between_ARM_core_register_and_single_precision_register_cccc1110000onnnntttt1010n0010000_case_0);
};

class NamedVMOV_between_ARM_core_register_and_single_precision_register_cccc1110000xnnnntttt1010n0010000_case_0
    : public NamedClassDecoder {
 public:
  NamedVMOV_between_ARM_core_register_and_single_precision_register_cccc1110000xnnnntttt1010n0010000_case_0()
    : NamedClassDecoder(decoder_, "VMOV_between_ARM_core_register_and_single_precision_register_cccc1110000xnnnntttt1010n0010000_case_0")
  {}

 private:
  nacl_arm_dec::VMOV_between_ARM_core_register_and_single_precision_register_cccc1110000xnnnntttt1010n0010000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMOV_between_ARM_core_register_and_single_precision_register_cccc1110000xnnnntttt1010n0010000_case_0);
};

class NamedVMOV_between_two_ARM_core_registers_and_a_doubleword_extension_register_cccc1100010otttttttt101100m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMOV_between_two_ARM_core_registers_and_a_doubleword_extension_register_cccc1100010otttttttt101100m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMOV_between_two_ARM_core_registers_and_a_doubleword_extension_register_cccc1100010otttttttt101100m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMOV_between_two_ARM_core_registers_and_a_doubleword_extension_register_cccc1100010otttttttt101100m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMOV_between_two_ARM_core_registers_and_a_doubleword_extension_register_cccc1100010otttttttt101100m1mmmm_case_0);
};

class NamedVMOV_between_two_ARM_core_registers_and_two_single_precision_registers_cccc1100010otttttttt101000m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMOV_between_two_ARM_core_registers_and_two_single_precision_registers_cccc1100010otttttttt101000m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMOV_between_two_ARM_core_registers_and_two_single_precision_registers_cccc1100010otttttttt101000m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMOV_between_two_ARM_core_registers_and_two_single_precision_registers_cccc1100010otttttttt101000m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMOV_between_two_ARM_core_registers_and_two_single_precision_registers_cccc1100010otttttttt101000m1mmmm_case_0);
};

class NamedVMOV_immediate_A1_1111001m1d000mmmddddcccc0qp1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMOV_immediate_A1_1111001m1d000mmmddddcccc0qp1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMOV_immediate_A1_1111001m1d000mmmddddcccc0qp1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMOV_immediate_A1_1111001m1d000mmmddddcccc0qp1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMOV_immediate_A1_1111001m1d000mmmddddcccc0qp1mmmm_case_0);
};

class NamedVMOV_immediate_cccc11101d11iiiidddd101s0000iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVMOV_immediate_cccc11101d11iiiidddd101s0000iiii_case_0()
    : NamedClassDecoder(decoder_, "VMOV_immediate_cccc11101d11iiiidddd101s0000iiii_case_0")
  {}

 private:
  nacl_arm_dec::VMOV_immediate_cccc11101d11iiiidddd101s0000iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMOV_immediate_cccc11101d11iiiidddd101s0000iiii_case_0);
};

class NamedVMOV_register_cccc11101d110000dddd101s01m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMOV_register_cccc11101d110000dddd101s01m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMOV_register_cccc11101d110000dddd101s01m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMOV_register_cccc11101d110000dddd101s01m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMOV_register_cccc11101d110000dddd101s01m0mmmm_case_0);
};

class NamedVMRS_cccc111011110001tttt101000010000_case_0
    : public NamedClassDecoder {
 public:
  NamedVMRS_cccc111011110001tttt101000010000_case_0()
    : NamedClassDecoder(decoder_, "VMRS_cccc111011110001tttt101000010000_case_0")
  {}

 private:
  nacl_arm_dec::VMRS_cccc111011110001tttt101000010000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMRS_cccc111011110001tttt101000010000_case_0);
};

class NamedVMSR_cccc111011100001tttt101000010000_case_0
    : public NamedClassDecoder {
 public:
  NamedVMSR_cccc111011100001tttt101000010000_case_0()
    : NamedClassDecoder(decoder_, "VMSR_cccc111011100001tttt101000010000_case_0")
  {}

 private:
  nacl_arm_dec::VMSR_cccc111011100001tttt101000010000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMSR_cccc111011100001tttt101000010000_case_0);
};

class NamedVMULL_by_scalar_A2_1111001u1dssnnnndddd1010n1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMULL_by_scalar_A2_1111001u1dssnnnndddd1010n1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMULL_by_scalar_A2_1111001u1dssnnnndddd1010n1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMULL_by_scalar_A2_1111001u1dssnnnndddd1010n1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMULL_by_scalar_A2_1111001u1dssnnnndddd1010n1m0mmmm_case_0);
};

class NamedVMULL_integer_A2_1111001u1dssnnnndddd11p0n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMULL_integer_A2_1111001u1dssnnnndddd11p0n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMULL_integer_A2_1111001u1dssnnnndddd11p0n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMULL_integer_A2_1111001u1dssnnnndddd11p0n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMULL_integer_A2_1111001u1dssnnnndddd11p0n0m0mmmm_case_0);
};

class NamedVMULL_polynomial_A2_1111001u1dssnnnndddd11p0n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMULL_polynomial_A2_1111001u1dssnnnndddd11p0n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMULL_polynomial_A2_1111001u1dssnnnndddd11p0n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMULL_polynomial_A2_1111001u1dssnnnndddd11p0n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMULL_polynomial_A2_1111001u1dssnnnndddd11p0n0m0mmmm_case_0);
};

class NamedVMUL_by_scalar_A1_1111001q1dssnnnndddd100fn1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMUL_by_scalar_A1_1111001q1dssnnnndddd100fn1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMUL_by_scalar_A1_1111001q1dssnnnndddd100fn1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMUL_by_scalar_A1_1111001q1dssnnnndddd100fn1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMUL_by_scalar_A1_1111001q1dssnnnndddd100fn1m0mmmm_case_0);
};

class NamedVMUL_by_scalar_A1_1111001q1dssnnnndddd100fn1m0mmmm_case_1
    : public NamedClassDecoder {
 public:
  NamedVMUL_by_scalar_A1_1111001q1dssnnnndddd100fn1m0mmmm_case_1()
    : NamedClassDecoder(decoder_, "VMUL_by_scalar_A1_1111001q1dssnnnndddd100fn1m0mmmm_case_1")
  {}

 private:
  nacl_arm_dec::VMUL_by_scalar_A1_1111001q1dssnnnndddd100fn1m0mmmm_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMUL_by_scalar_A1_1111001q1dssnnnndddd100fn1m0mmmm_case_1);
};

class NamedVMUL_floating_point_A1_111100110d0snnnndddd1101nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMUL_floating_point_A1_111100110d0snnnndddd1101nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMUL_floating_point_A1_111100110d0snnnndddd1101nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMUL_floating_point_A1_111100110d0snnnndddd1101nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMUL_floating_point_A1_111100110d0snnnndddd1101nqm1mmmm_case_0);
};

class NamedVMUL_floating_point_cccc11100d10nnnndddd101sn0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMUL_floating_point_cccc11100d10nnnndddd101sn0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMUL_floating_point_cccc11100d10nnnndddd101sn0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMUL_floating_point_cccc11100d10nnnndddd101sn0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMUL_floating_point_cccc11100d10nnnndddd101sn0m0mmmm_case_0);
};

class NamedVMUL_integer_A1_1111001u0dssnnnndddd1001nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMUL_integer_A1_1111001u0dssnnnndddd1001nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMUL_integer_A1_1111001u0dssnnnndddd1001nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMUL_integer_A1_1111001u0dssnnnndddd1001nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMUL_integer_A1_1111001u0dssnnnndddd1001nqm1mmmm_case_0);
};

class NamedVMUL_polynomial_A1_1111001u0dssnnnndddd1001nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMUL_polynomial_A1_1111001u0dssnnnndddd1001nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMUL_polynomial_A1_1111001u0dssnnnndddd1001nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMUL_polynomial_A1_1111001u0dssnnnndddd1001nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMUL_polynomial_A1_1111001u0dssnnnndddd1001nqm1mmmm_case_0);
};

class NamedVMVN_immediate_1111001i1d000mmmddddcccc0q11mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMVN_immediate_1111001i1d000mmmddddcccc0q11mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMVN_immediate_1111001i1d000mmmddddcccc0q11mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMVN_immediate_1111001i1d000mmmddddcccc0q11mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMVN_immediate_1111001i1d000mmmddddcccc0q11mmmm_case_0);
};

class NamedVMVN_register_111100111d11ss00dddd01011qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVMVN_register_111100111d11ss00dddd01011qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VMVN_register_111100111d11ss00dddd01011qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VMVN_register_111100111d11ss00dddd01011qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVMVN_register_111100111d11ss00dddd01011qm0mmmm_case_0);
};

class NamedVNEG_111100111d11ss01dddd0f111qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVNEG_111100111d11ss01dddd0f111qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VNEG_111100111d11ss01dddd0f111qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VNEG_111100111d11ss01dddd0f111qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVNEG_111100111d11ss01dddd0f111qm0mmmm_case_0);
};

class NamedVNEG_111100111d11ss01dddd0f111qm0mmmm_case_1
    : public NamedClassDecoder {
 public:
  NamedVNEG_111100111d11ss01dddd0f111qm0mmmm_case_1()
    : NamedClassDecoder(decoder_, "VNEG_111100111d11ss01dddd0f111qm0mmmm_case_1")
  {}

 private:
  nacl_arm_dec::VNEG_111100111d11ss01dddd0f111qm0mmmm_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVNEG_111100111d11ss01dddd0f111qm0mmmm_case_1);
};

class NamedVNEG_cccc11101d110001dddd101s01m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVNEG_cccc11101d110001dddd101s01m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VNEG_cccc11101d110001dddd101s01m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VNEG_cccc11101d110001dddd101s01m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVNEG_cccc11101d110001dddd101s01m0mmmm_case_0);
};

class NamedVNMLA_VNMLS_cccc11100d01nnnndddd101snom0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVNMLA_VNMLS_cccc11100d01nnnndddd101snom0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VNMLA_VNMLS_cccc11100d01nnnndddd101snom0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VNMLA_VNMLS_cccc11100d01nnnndddd101snom0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVNMLA_VNMLS_cccc11100d01nnnndddd101snom0mmmm_case_0);
};

class NamedVNMUL_cccc11100d10nnnndddd101sn1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVNMUL_cccc11100d10nnnndddd101sn1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VNMUL_cccc11100d10nnnndddd101sn1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VNMUL_cccc11100d10nnnndddd101sn1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVNMUL_cccc11100d10nnnndddd101sn1m0mmmm_case_0);
};

class NamedVORN_register_111100100d11nnnndddd0001nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVORN_register_111100100d11nnnndddd0001nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VORN_register_111100100d11nnnndddd0001nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VORN_register_111100100d11nnnndddd0001nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVORN_register_111100100d11nnnndddd0001nqm1mmmm_case_0);
};

class NamedVORR_immediate_1111001i1d000mmmddddcccc0q01mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVORR_immediate_1111001i1d000mmmddddcccc0q01mmmm_case_0()
    : NamedClassDecoder(decoder_, "VORR_immediate_1111001i1d000mmmddddcccc0q01mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VORR_immediate_1111001i1d000mmmddddcccc0q01mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVORR_immediate_1111001i1d000mmmddddcccc0q01mmmm_case_0);
};

class NamedVORR_register_or_VMOV_register_A1_111100100d10nnnndddd0001nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVORR_register_or_VMOV_register_A1_111100100d10nnnndddd0001nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VORR_register_or_VMOV_register_A1_111100100d10nnnndddd0001nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VORR_register_or_VMOV_register_A1_111100100d10nnnndddd0001nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVORR_register_or_VMOV_register_A1_111100100d10nnnndddd0001nqm1mmmm_case_0);
};

class NamedVPADAL_111100111d11ss00dddd0110p1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVPADAL_111100111d11ss00dddd0110p1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VPADAL_111100111d11ss00dddd0110p1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VPADAL_111100111d11ss00dddd0110p1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPADAL_111100111d11ss00dddd0110p1m0mmmm_case_0);
};

class NamedVPADDL_111100111d11ss00dddd0010p1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVPADDL_111100111d11ss00dddd0010p1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VPADDL_111100111d11ss00dddd0010p1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VPADDL_111100111d11ss00dddd0010p1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPADDL_111100111d11ss00dddd0010p1m0mmmm_case_0);
};

class NamedVPADD_floating_point_111100110d0snnnndddd1101nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVPADD_floating_point_111100110d0snnnndddd1101nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VPADD_floating_point_111100110d0snnnndddd1101nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VPADD_floating_point_111100110d0snnnndddd1101nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPADD_floating_point_111100110d0snnnndddd1101nqm0mmmm_case_0);
};

class NamedVPADD_integer_111100100dssnnnndddd1011n0m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVPADD_integer_111100100dssnnnndddd1011n0m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VPADD_integer_111100100dssnnnndddd1011n0m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VPADD_integer_111100100dssnnnndddd1011n0m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPADD_integer_111100100dssnnnndddd1011n0m1mmmm_case_0);
};

class NamedVPMAX_111100110dssnnnndddd1111nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVPMAX_111100110dssnnnndddd1111nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VPMAX_111100110dssnnnndddd1111nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VPMAX_111100110dssnnnndddd1111nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPMAX_111100110dssnnnndddd1111nqm0mmmm_case_0);
};

class NamedVPMAX_1111001u0dssnnnndddd1010n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVPMAX_1111001u0dssnnnndddd1010n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VPMAX_1111001u0dssnnnndddd1010n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VPMAX_1111001u0dssnnnndddd1010n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPMAX_1111001u0dssnnnndddd1010n0m0mmmm_case_0);
};

class NamedVPMIN_111100110dssnnnndddd1111nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVPMIN_111100110dssnnnndddd1111nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VPMIN_111100110dssnnnndddd1111nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VPMIN_111100110dssnnnndddd1111nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPMIN_111100110dssnnnndddd1111nqm0mmmm_case_0);
};

class NamedVPMIN_1111001u0dssnnnndddd1010n0m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVPMIN_1111001u0dssnnnndddd1010n0m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VPMIN_1111001u0dssnnnndddd1010n0m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VPMIN_1111001u0dssnnnndddd1010n0m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPMIN_1111001u0dssnnnndddd1010n0m1mmmm_case_0);
};

class NamedVPOP_cccc11001d111101dddd1010iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVPOP_cccc11001d111101dddd1010iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VPOP_cccc11001d111101dddd1010iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VPOP_cccc11001d111101dddd1010iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPOP_cccc11001d111101dddd1010iiiiiiii_case_0);
};

class NamedVPOP_cccc11001d111101dddd1011iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVPOP_cccc11001d111101dddd1011iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VPOP_cccc11001d111101dddd1011iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VPOP_cccc11001d111101dddd1011iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPOP_cccc11001d111101dddd1011iiiiiiii_case_0);
};

class NamedVPUSH_cccc11010d101101dddd1010iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVPUSH_cccc11010d101101dddd1010iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VPUSH_cccc11010d101101dddd1010iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VPUSH_cccc11010d101101dddd1010iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPUSH_cccc11010d101101dddd1010iiiiiiii_case_0);
};

class NamedVPUSH_cccc11010d101101dddd1011iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVPUSH_cccc11010d101101dddd1011iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VPUSH_cccc11010d101101dddd1011iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VPUSH_cccc11010d101101dddd1011iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVPUSH_cccc11010d101101dddd1011iiiiiiii_case_0);
};

class NamedVQABS_111100111d11ss00dddd01110qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQABS_111100111d11ss00dddd01110qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQABS_111100111d11ss00dddd01110qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQABS_111100111d11ss00dddd01110qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQABS_111100111d11ss00dddd01110qm0mmmm_case_0);
};

class NamedVQADD_1111001u0dssnnnndddd0000nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQADD_1111001u0dssnnnndddd0000nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQADD_1111001u0dssnnnndddd0000nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQADD_1111001u0dssnnnndddd0000nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQADD_1111001u0dssnnnndddd0000nqm1mmmm_case_0);
};

class NamedVQDMLAL_A1_111100101dssnnnndddd0p11n1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQDMLAL_A1_111100101dssnnnndddd0p11n1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQDMLAL_A1_111100101dssnnnndddd0p11n1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQDMLAL_A1_111100101dssnnnndddd0p11n1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQDMLAL_A1_111100101dssnnnndddd0p11n1m0mmmm_case_0);
};

class NamedVQDMLAL_VQDMLSL_A1_111100101dssnnnndddd10p1n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQDMLAL_VQDMLSL_A1_111100101dssnnnndddd10p1n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQDMLAL_VQDMLSL_A1_111100101dssnnnndddd10p1n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQDMLAL_VQDMLSL_A1_111100101dssnnnndddd10p1n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQDMLAL_VQDMLSL_A1_111100101dssnnnndddd10p1n0m0mmmm_case_0);
};

class NamedVQDMLSL_A1_111100101dssnnnndddd0p11n1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQDMLSL_A1_111100101dssnnnndddd0p11n1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQDMLSL_A1_111100101dssnnnndddd0p11n1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQDMLSL_A1_111100101dssnnnndddd0p11n1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQDMLSL_A1_111100101dssnnnndddd0p11n1m0mmmm_case_0);
};

class NamedVQDMULH_A1_111100100dssnnnndddd1011nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQDMULH_A1_111100100dssnnnndddd1011nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQDMULH_A1_111100100dssnnnndddd1011nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQDMULH_A1_111100100dssnnnndddd1011nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQDMULH_A1_111100100dssnnnndddd1011nqm0mmmm_case_0);
};

class NamedVQDMULH_A2_1111001q1dssnnnndddd1100n1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQDMULH_A2_1111001q1dssnnnndddd1100n1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQDMULH_A2_1111001q1dssnnnndddd1100n1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQDMULH_A2_1111001q1dssnnnndddd1100n1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQDMULH_A2_1111001q1dssnnnndddd1100n1m0mmmm_case_0);
};

class NamedVQDMULL_A1_111100101dssnnnndddd1101n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQDMULL_A1_111100101dssnnnndddd1101n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQDMULL_A1_111100101dssnnnndddd1101n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQDMULL_A1_111100101dssnnnndddd1101n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQDMULL_A1_111100101dssnnnndddd1101n0m0mmmm_case_0);
};

class NamedVQDMULL_A2_111100101dssnnnndddd1011n1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQDMULL_A2_111100101dssnnnndddd1011n1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQDMULL_A2_111100101dssnnnndddd1011n1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQDMULL_A2_111100101dssnnnndddd1011n1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQDMULL_A2_111100101dssnnnndddd1011n1m0mmmm_case_0);
};

class NamedVQMOVN_111100111d11ss10dddd0010ppm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQMOVN_111100111d11ss10dddd0010ppm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQMOVN_111100111d11ss10dddd0010ppm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQMOVN_111100111d11ss10dddd0010ppm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQMOVN_111100111d11ss10dddd0010ppm0mmmm_case_0);
};

class NamedVQMOVUN_111100111d11ss10dddd0010ppm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQMOVUN_111100111d11ss10dddd0010ppm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQMOVUN_111100111d11ss10dddd0010ppm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQMOVUN_111100111d11ss10dddd0010ppm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQMOVUN_111100111d11ss10dddd0010ppm0mmmm_case_0);
};

class NamedVQNEG_111100111d11ss00dddd01111qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQNEG_111100111d11ss00dddd01111qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQNEG_111100111d11ss00dddd01111qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQNEG_111100111d11ss00dddd01111qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQNEG_111100111d11ss00dddd01111qm0mmmm_case_0);
};

class NamedVQRDMULH_1111001q1dssnnnndddd1101n1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQRDMULH_1111001q1dssnnnndddd1101n1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQRDMULH_1111001q1dssnnnndddd1101n1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQRDMULH_1111001q1dssnnnndddd1101n1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQRDMULH_1111001q1dssnnnndddd1101n1m0mmmm_case_0);
};

class NamedVQRDMULH_A1_111100110dssnnnndddd1011nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQRDMULH_A1_111100110dssnnnndddd1011nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQRDMULH_A1_111100110dssnnnndddd1011nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQRDMULH_A1_111100110dssnnnndddd1011nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQRDMULH_A1_111100110dssnnnndddd1011nqm0mmmm_case_0);
};

class NamedVQRSHL_1111001u0dssnnnndddd0101nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQRSHL_1111001u0dssnnnndddd0101nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQRSHL_1111001u0dssnnnndddd0101nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQRSHL_1111001u0dssnnnndddd0101nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQRSHL_1111001u0dssnnnndddd0101nqm1mmmm_case_0);
};

class NamedVQRSHRN_1111001u1diiiiiidddd100p01m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQRSHRN_1111001u1diiiiiidddd100p01m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQRSHRN_1111001u1diiiiiidddd100p01m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQRSHRN_1111001u1diiiiiidddd100p01m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQRSHRN_1111001u1diiiiiidddd100p01m1mmmm_case_0);
};

class NamedVQRSHRUN_1111001u1diiiiiidddd100p00m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQRSHRUN_1111001u1diiiiiidddd100p00m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQRSHRUN_1111001u1diiiiiidddd100p00m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQRSHRUN_1111001u1diiiiiidddd100p00m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQRSHRUN_1111001u1diiiiiidddd100p00m1mmmm_case_0);
};

class NamedVQRSHRUN_1111001u1diiiiiidddd100p01m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQRSHRUN_1111001u1diiiiiidddd100p01m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQRSHRUN_1111001u1diiiiiidddd100p01m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQRSHRUN_1111001u1diiiiiidddd100p01m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQRSHRUN_1111001u1diiiiiidddd100p01m1mmmm_case_0);
};

class NamedVQSHL_VQSHLU_immediate_1111001u1diiiiiidddd011plqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQSHL_VQSHLU_immediate_1111001u1diiiiiidddd011plqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQSHL_VQSHLU_immediate_1111001u1diiiiiidddd011plqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQSHL_VQSHLU_immediate_1111001u1diiiiiidddd011plqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQSHL_VQSHLU_immediate_1111001u1diiiiiidddd011plqm1mmmm_case_0);
};

class NamedVQSHL_register_1111001u0dssnnnndddd0100nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQSHL_register_1111001u0dssnnnndddd0100nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQSHL_register_1111001u0dssnnnndddd0100nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQSHL_register_1111001u0dssnnnndddd0100nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQSHL_register_1111001u0dssnnnndddd0100nqm1mmmm_case_0);
};

class NamedVQSHRN_1111001u1diiiiiidddd100p00m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQSHRN_1111001u1diiiiiidddd100p00m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQSHRN_1111001u1diiiiiidddd100p00m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQSHRN_1111001u1diiiiiidddd100p00m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQSHRN_1111001u1diiiiiidddd100p00m1mmmm_case_0);
};

class NamedVQSHRUN_1111001u1diiiiiidddd100p00m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQSHRUN_1111001u1diiiiiidddd100p00m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQSHRUN_1111001u1diiiiiidddd100p00m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQSHRUN_1111001u1diiiiiidddd100p00m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQSHRUN_1111001u1diiiiiidddd100p00m1mmmm_case_0);
};

class NamedVQSUB_1111001u0dssnnnndddd0010nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVQSUB_1111001u0dssnnnndddd0010nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VQSUB_1111001u0dssnnnndddd0010nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VQSUB_1111001u0dssnnnndddd0010nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVQSUB_1111001u0dssnnnndddd0010nqm1mmmm_case_0);
};

class NamedVRADDHN_111100111dssnnnndddd0100n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVRADDHN_111100111dssnnnndddd0100n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VRADDHN_111100111dssnnnndddd0100n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VRADDHN_111100111dssnnnndddd0100n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVRADDHN_111100111dssnnnndddd0100n0m0mmmm_case_0);
};

class NamedVRECPE_111100111d11ss11dddd010f0qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVRECPE_111100111d11ss11dddd010f0qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VRECPE_111100111d11ss11dddd010f0qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VRECPE_111100111d11ss11dddd010f0qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVRECPE_111100111d11ss11dddd010f0qm0mmmm_case_0);
};

class NamedVRECPS_111100100d0snnnndddd1111nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVRECPS_111100100d0snnnndddd1111nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VRECPS_111100100d0snnnndddd1111nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VRECPS_111100100d0snnnndddd1111nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVRECPS_111100100d0snnnndddd1111nqm1mmmm_case_0);
};

class NamedVREV16_111100111d11ss00dddd000ppqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVREV16_111100111d11ss00dddd000ppqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VREV16_111100111d11ss00dddd000ppqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VREV16_111100111d11ss00dddd000ppqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVREV16_111100111d11ss00dddd000ppqm0mmmm_case_0);
};

class NamedVREV32_111100111d11ss00dddd000ppqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVREV32_111100111d11ss00dddd000ppqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VREV32_111100111d11ss00dddd000ppqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VREV32_111100111d11ss00dddd000ppqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVREV32_111100111d11ss00dddd000ppqm0mmmm_case_0);
};

class NamedVREV64_111100111d11ss00dddd000ppqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVREV64_111100111d11ss00dddd000ppqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VREV64_111100111d11ss00dddd000ppqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VREV64_111100111d11ss00dddd000ppqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVREV64_111100111d11ss00dddd000ppqm0mmmm_case_0);
};

class NamedVRHADD_1111001u0dssnnnndddd0001nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVRHADD_1111001u0dssnnnndddd0001nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VRHADD_1111001u0dssnnnndddd0001nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VRHADD_1111001u0dssnnnndddd0001nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVRHADD_1111001u0dssnnnndddd0001nqm0mmmm_case_0);
};

class NamedVRSHL_1111001u0dssnnnndddd0101nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVRSHL_1111001u0dssnnnndddd0101nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VRSHL_1111001u0dssnnnndddd0101nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VRSHL_1111001u0dssnnnndddd0101nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVRSHL_1111001u0dssnnnndddd0101nqm0mmmm_case_0);
};

class NamedVRSHRN_111100101diiiiiidddd100001m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVRSHRN_111100101diiiiiidddd100001m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VRSHRN_111100101diiiiiidddd100001m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VRSHRN_111100101diiiiiidddd100001m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVRSHRN_111100101diiiiiidddd100001m1mmmm_case_0);
};

class NamedVRSHR_1111001u1diiiiiidddd0010lqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVRSHR_1111001u1diiiiiidddd0010lqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VRSHR_1111001u1diiiiiidddd0010lqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VRSHR_1111001u1diiiiiidddd0010lqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVRSHR_1111001u1diiiiiidddd0010lqm1mmmm_case_0);
};

class NamedVRSQRTE_111100111d11ss11dddd010f1qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVRSQRTE_111100111d11ss11dddd010f1qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VRSQRTE_111100111d11ss11dddd010f1qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VRSQRTE_111100111d11ss11dddd010f1qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVRSQRTE_111100111d11ss11dddd010f1qm0mmmm_case_0);
};

class NamedVRSQRTS_111100100d1snnnndddd1111nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVRSQRTS_111100100d1snnnndddd1111nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VRSQRTS_111100100d1snnnndddd1111nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VRSQRTS_111100100d1snnnndddd1111nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVRSQRTS_111100100d1snnnndddd1111nqm1mmmm_case_0);
};

class NamedVRSRA_1111001u1diiiiiidddd0011lqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVRSRA_1111001u1diiiiiidddd0011lqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VRSRA_1111001u1diiiiiidddd0011lqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VRSRA_1111001u1diiiiiidddd0011lqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVRSRA_1111001u1diiiiiidddd0011lqm1mmmm_case_0);
};

class NamedVRSUBHN_111100111dssnnnndddd0110n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVRSUBHN_111100111dssnnnndddd0110n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VRSUBHN_111100111dssnnnndddd0110n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VRSUBHN_111100111dssnnnndddd0110n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVRSUBHN_111100111dssnnnndddd0110n0m0mmmm_case_0);
};

class NamedVSHLL_A1_or_VMOVL_1111001u1diiiiiidddd101000m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSHLL_A1_or_VMOVL_1111001u1diiiiiidddd101000m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSHLL_A1_or_VMOVL_1111001u1diiiiiidddd101000m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSHLL_A1_or_VMOVL_1111001u1diiiiiidddd101000m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSHLL_A1_or_VMOVL_1111001u1diiiiiidddd101000m1mmmm_case_0);
};

class NamedVSHLL_A2_111100111d11ss10dddd001100m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSHLL_A2_111100111d11ss10dddd001100m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSHLL_A2_111100111d11ss10dddd001100m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSHLL_A2_111100111d11ss10dddd001100m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSHLL_A2_111100111d11ss10dddd001100m0mmmm_case_0);
};

class NamedVSHL_immediate_111100101diiiiiidddd0101lqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSHL_immediate_111100101diiiiiidddd0101lqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSHL_immediate_111100101diiiiiidddd0101lqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSHL_immediate_111100101diiiiiidddd0101lqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSHL_immediate_111100101diiiiiidddd0101lqm1mmmm_case_0);
};

class NamedVSHL_register_1111001u0dssnnnndddd0100nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSHL_register_1111001u0dssnnnndddd0100nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSHL_register_1111001u0dssnnnndddd0100nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSHL_register_1111001u0dssnnnndddd0100nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSHL_register_1111001u0dssnnnndddd0100nqm0mmmm_case_0);
};

class NamedVSHRN_111100101diiiiiidddd100000m1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSHRN_111100101diiiiiidddd100000m1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSHRN_111100101diiiiiidddd100000m1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSHRN_111100101diiiiiidddd100000m1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSHRN_111100101diiiiiidddd100000m1mmmm_case_0);
};

class NamedVSHR_1111001u1diiiiiidddd0000lqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSHR_1111001u1diiiiiidddd0000lqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSHR_1111001u1diiiiiidddd0000lqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSHR_1111001u1diiiiiidddd0000lqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSHR_1111001u1diiiiiidddd0000lqm1mmmm_case_0);
};

class NamedVSLI_111100111diiiiiidddd0101lqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSLI_111100111diiiiiidddd0101lqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSLI_111100111diiiiiidddd0101lqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSLI_111100111diiiiiidddd0101lqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSLI_111100111diiiiiidddd0101lqm1mmmm_case_0);
};

class NamedVSQRT_cccc11101d110001dddd101s11m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSQRT_cccc11101d110001dddd101s11m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSQRT_cccc11101d110001dddd101s11m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSQRT_cccc11101d110001dddd101s11m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSQRT_cccc11101d110001dddd101s11m0mmmm_case_0);
};

class NamedVSRA_1111001u1diiiiiidddd0001lqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSRA_1111001u1diiiiiidddd0001lqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSRA_1111001u1diiiiiidddd0001lqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSRA_1111001u1diiiiiidddd0001lqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSRA_1111001u1diiiiiidddd0001lqm1mmmm_case_0);
};

class NamedVSRI_111100111diiiiiidddd0100lqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSRI_111100111diiiiiidddd0100lqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSRI_111100111diiiiiidddd0100lqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSRI_111100111diiiiiidddd0100lqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSRI_111100111diiiiiidddd0100lqm1mmmm_case_0);
};

class NamedVST1_multiple_single_elements_111101000d00nnnnddddttttssaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVST1_multiple_single_elements_111101000d00nnnnddddttttssaammmm_case_0()
    : NamedClassDecoder(decoder_, "VST1_multiple_single_elements_111101000d00nnnnddddttttssaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VST1_multiple_single_elements_111101000d00nnnnddddttttssaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVST1_multiple_single_elements_111101000d00nnnnddddttttssaammmm_case_0);
};

class NamedVST1_single_element_from_one_lane_111101001d00nnnnddddss00aaaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVST1_single_element_from_one_lane_111101001d00nnnnddddss00aaaammmm_case_0()
    : NamedClassDecoder(decoder_, "VST1_single_element_from_one_lane_111101001d00nnnnddddss00aaaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VST1_single_element_from_one_lane_111101001d00nnnnddddss00aaaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVST1_single_element_from_one_lane_111101001d00nnnnddddss00aaaammmm_case_0);
};

class NamedVST2_multiple_2_element_structures_111101000d00nnnnddddttttssaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVST2_multiple_2_element_structures_111101000d00nnnnddddttttssaammmm_case_0()
    : NamedClassDecoder(decoder_, "VST2_multiple_2_element_structures_111101000d00nnnnddddttttssaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VST2_multiple_2_element_structures_111101000d00nnnnddddttttssaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVST2_multiple_2_element_structures_111101000d00nnnnddddttttssaammmm_case_0);
};

class NamedVST2_single_2_element_structure_from_one_lane_111101001d00nnnnddddss01aaaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVST2_single_2_element_structure_from_one_lane_111101001d00nnnnddddss01aaaammmm_case_0()
    : NamedClassDecoder(decoder_, "VST2_single_2_element_structure_from_one_lane_111101001d00nnnnddddss01aaaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VST2_single_2_element_structure_from_one_lane_111101001d00nnnnddddss01aaaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVST2_single_2_element_structure_from_one_lane_111101001d00nnnnddddss01aaaammmm_case_0);
};

class NamedVST3_multiple_3_element_structures_111101000d00nnnnddddttttssaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVST3_multiple_3_element_structures_111101000d00nnnnddddttttssaammmm_case_0()
    : NamedClassDecoder(decoder_, "VST3_multiple_3_element_structures_111101000d00nnnnddddttttssaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VST3_multiple_3_element_structures_111101000d00nnnnddddttttssaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVST3_multiple_3_element_structures_111101000d00nnnnddddttttssaammmm_case_0);
};

class NamedVST3_single_3_element_structure_from_one_lane_111101001d00nnnnddddss10aaaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVST3_single_3_element_structure_from_one_lane_111101001d00nnnnddddss10aaaammmm_case_0()
    : NamedClassDecoder(decoder_, "VST3_single_3_element_structure_from_one_lane_111101001d00nnnnddddss10aaaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VST3_single_3_element_structure_from_one_lane_111101001d00nnnnddddss10aaaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVST3_single_3_element_structure_from_one_lane_111101001d00nnnnddddss10aaaammmm_case_0);
};

class NamedVST4_multiple_4_element_structures_111101000d00nnnnddddttttssaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVST4_multiple_4_element_structures_111101000d00nnnnddddttttssaammmm_case_0()
    : NamedClassDecoder(decoder_, "VST4_multiple_4_element_structures_111101000d00nnnnddddttttssaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VST4_multiple_4_element_structures_111101000d00nnnnddddttttssaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVST4_multiple_4_element_structures_111101000d00nnnnddddttttssaammmm_case_0);
};

class NamedVST4_single_4_element_structure_form_one_lane_111101001d00nnnnddddss11aaaammmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVST4_single_4_element_structure_form_one_lane_111101001d00nnnnddddss11aaaammmm_case_0()
    : NamedClassDecoder(decoder_, "VST4_single_4_element_structure_form_one_lane_111101001d00nnnnddddss11aaaammmm_case_0")
  {}

 private:
  nacl_arm_dec::VST4_single_4_element_structure_form_one_lane_111101001d00nnnnddddss11aaaammmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVST4_single_4_element_structure_form_one_lane_111101001d00nnnnddddss11aaaammmm_case_0);
};

class NamedVSTM_cccc110pudw0nnnndddd1010iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVSTM_cccc110pudw0nnnndddd1010iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VSTM_cccc110pudw0nnnndddd1010iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VSTM_cccc110pudw0nnnndddd1010iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSTM_cccc110pudw0nnnndddd1010iiiiiiii_case_0);
};

class NamedVSTM_cccc110pudw0nnnndddd1011iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVSTM_cccc110pudw0nnnndddd1011iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VSTM_cccc110pudw0nnnndddd1011iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VSTM_cccc110pudw0nnnndddd1011iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSTM_cccc110pudw0nnnndddd1011iiiiiiii_case_0);
};

class NamedVSTR_cccc1101ud00nnnndddd1010iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVSTR_cccc1101ud00nnnndddd1010iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VSTR_cccc1101ud00nnnndddd1010iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VSTR_cccc1101ud00nnnndddd1010iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSTR_cccc1101ud00nnnndddd1010iiiiiiii_case_0);
};

class NamedVSTR_cccc1101ud00nnnndddd1011iiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedVSTR_cccc1101ud00nnnndddd1011iiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "VSTR_cccc1101ud00nnnndddd1011iiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::VSTR_cccc1101ud00nnnndddd1011iiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSTR_cccc1101ud00nnnndddd1011iiiiiiii_case_0);
};

class NamedVSUBHN_111100101dssnnnndddd0110n0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSUBHN_111100101dssnnnndddd0110n0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSUBHN_111100101dssnnnndddd0110n0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSUBHN_111100101dssnnnndddd0110n0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSUBHN_111100101dssnnnndddd0110n0m0mmmm_case_0);
};

class NamedVSUBL_VSUBW_1111001u1dssnnnndddd001pn0m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSUBL_VSUBW_1111001u1dssnnnndddd001pn0m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSUBL_VSUBW_1111001u1dssnnnndddd001pn0m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSUBL_VSUBW_1111001u1dssnnnndddd001pn0m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSUBL_VSUBW_1111001u1dssnnnndddd001pn0m0mmmm_case_0);
};

class NamedVSUB_floating_point_A1_111100100d1snnnndddd1101nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSUB_floating_point_A1_111100100d1snnnndddd1101nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSUB_floating_point_A1_111100100d1snnnndddd1101nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSUB_floating_point_A1_111100100d1snnnndddd1101nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSUB_floating_point_A1_111100100d1snnnndddd1101nqm0mmmm_case_0);
};

class NamedVSUB_floating_point_cccc11100d11nnnndddd101sn1m0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSUB_floating_point_cccc11100d11nnnndddd101sn1m0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSUB_floating_point_cccc11100d11nnnndddd101sn1m0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSUB_floating_point_cccc11100d11nnnndddd101sn1m0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSUB_floating_point_cccc11100d11nnnndddd101sn1m0mmmm_case_0);
};

class NamedVSUB_integer_111100110dssnnnndddd1000nqm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSUB_integer_111100110dssnnnndddd1000nqm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSUB_integer_111100110dssnnnndddd1000nqm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSUB_integer_111100110dssnnnndddd1000nqm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSUB_integer_111100110dssnnnndddd1000nqm0mmmm_case_0);
};

class NamedVSWP_111100111d11ss10dddd00000qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVSWP_111100111d11ss10dddd00000qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VSWP_111100111d11ss10dddd00000qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VSWP_111100111d11ss10dddd00000qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVSWP_111100111d11ss10dddd00000qm0mmmm_case_0);
};

class NamedVTRN_111100111d11ss10dddd00001qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVTRN_111100111d11ss10dddd00001qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VTRN_111100111d11ss10dddd00001qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VTRN_111100111d11ss10dddd00001qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVTRN_111100111d11ss10dddd00001qm0mmmm_case_0);
};

class NamedVTST_111100100dssnnnndddd1000nqm1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVTST_111100100dssnnnndddd1000nqm1mmmm_case_0()
    : NamedClassDecoder(decoder_, "VTST_111100100dssnnnndddd1000nqm1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VTST_111100100dssnnnndddd1000nqm1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVTST_111100100dssnnnndddd1000nqm1mmmm_case_0);
};

class NamedVUZP_111100111d11ss10dddd00010qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVUZP_111100111d11ss10dddd00010qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VUZP_111100111d11ss10dddd00010qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VUZP_111100111d11ss10dddd00010qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVUZP_111100111d11ss10dddd00010qm0mmmm_case_0);
};

class NamedVZIP_111100111d11ss10dddd00011qm0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedVZIP_111100111d11ss10dddd00011qm0mmmm_case_0()
    : NamedClassDecoder(decoder_, "VZIP_111100111d11ss10dddd00011qm0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::VZIP_111100111d11ss10dddd00011qm0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedVZIP_111100111d11ss10dddd00011qm0mmmm_case_0);
};

class NamedWFE_cccc0011001000001111000000000010_case_0
    : public NamedClassDecoder {
 public:
  NamedWFE_cccc0011001000001111000000000010_case_0()
    : NamedClassDecoder(decoder_, "WFE_cccc0011001000001111000000000010_case_0")
  {}

 private:
  nacl_arm_dec::WFE_cccc0011001000001111000000000010_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedWFE_cccc0011001000001111000000000010_case_0);
};

class NamedWFI_cccc0011001000001111000000000011_case_0
    : public NamedClassDecoder {
 public:
  NamedWFI_cccc0011001000001111000000000011_case_0()
    : NamedClassDecoder(decoder_, "WFI_cccc0011001000001111000000000011_case_0")
  {}

 private:
  nacl_arm_dec::WFI_cccc0011001000001111000000000011_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedWFI_cccc0011001000001111000000000011_case_0);
};

class NamedYIELD_cccc0011001000001111000000000001_case_0
    : public NamedClassDecoder {
 public:
  NamedYIELD_cccc0011001000001111000000000001_case_0()
    : NamedClassDecoder(decoder_, "YIELD_cccc0011001000001111000000000001_case_0")
  {}

 private:
  nacl_arm_dec::YIELD_cccc0011001000001111000000000001_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedYIELD_cccc0011001000001111000000000001_case_0);
};

class NamedBLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedBLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::BLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedBLX_immediate_1111101hiiiiiiiiiiiiiiiiiiiiiiii_case_0);
};

class NamedCDP2_11111110iiiiiiiiiiiiiiiiiii0iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedCDP2_11111110iiiiiiiiiiiiiiiiiii0iiii_case_0()
    : NamedClassDecoder(decoder_, "CDP2_11111110iiiiiiiiiiiiiiiiiii0iiii_case_0")
  {}

 private:
  nacl_arm_dec::CDP2_11111110iiiiiiiiiiiiiiiiiii0iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCDP2_11111110iiiiiiiiiiiiiiiiiii0iiii_case_0);
};

class NamedCDP_cccc1110oooonnnnddddccccooo0mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedCDP_cccc1110oooonnnnddddccccooo0mmmm_case_0()
    : NamedClassDecoder(decoder_, "CDP_cccc1110oooonnnnddddccccooo0mmmm_case_0")
  {}

 private:
  nacl_arm_dec::CDP_cccc1110oooonnnnddddccccooo0mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCDP_cccc1110oooonnnnddddccccooo0mmmm_case_0);
};

class NamedCLREX_11110101011111111111000000011111_case_0
    : public NamedClassDecoder {
 public:
  NamedCLREX_11110101011111111111000000011111_case_0()
    : NamedClassDecoder(decoder_, "CLREX_11110101011111111111000000011111_case_0")
  {}

 private:
  nacl_arm_dec::CLREX_11110101011111111111000000011111_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCLREX_11110101011111111111000000011111_case_0);
};

class NamedCPS_111100010000iii00000000iii0iiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedCPS_111100010000iii00000000iii0iiiii_case_0()
    : NamedClassDecoder(decoder_, "CPS_111100010000iii00000000iii0iiiii_case_0")
  {}

 private:
  nacl_arm_dec::CPS_111100010000iii00000000iii0iiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedCPS_111100010000iii00000000iii0iiiii_case_0);
};

class NamedLDC2_immediate_1111110pudw1nnnniiiiiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDC2_immediate_1111110pudw1nnnniiiiiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "LDC2_immediate_1111110pudw1nnnniiiiiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::LDC2_immediate_1111110pudw1nnnniiiiiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDC2_immediate_1111110pudw1nnnniiiiiiiiiiiiiiii_case_0);
};

class NamedLDC2_literal_1111110pudw11111iiiiiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDC2_literal_1111110pudw11111iiiiiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "LDC2_literal_1111110pudw11111iiiiiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::LDC2_literal_1111110pudw11111iiiiiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDC2_literal_1111110pudw11111iiiiiiiiiiiiiiii_case_0);
};

class NamedLDC_immediate_cccc110pudw1nnnnddddcccciiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDC_immediate_cccc110pudw1nnnnddddcccciiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "LDC_immediate_cccc110pudw1nnnnddddcccciiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::LDC_immediate_cccc110pudw1nnnnddddcccciiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDC_immediate_cccc110pudw1nnnnddddcccciiiiiiii_case_0);
};

class NamedLDC_literal_cccc110pudw11111ddddcccciiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedLDC_literal_cccc110pudw11111ddddcccciiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "LDC_literal_cccc110pudw11111ddddcccciiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::LDC_literal_cccc110pudw11111ddddcccciiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedLDC_literal_cccc110pudw11111ddddcccciiiiiiii_case_0);
};

class NamedMCR2_11111110iii0iiiittttiiiiiii1iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedMCR2_11111110iii0iiiittttiiiiiii1iiii_case_0()
    : NamedClassDecoder(decoder_, "MCR2_11111110iii0iiiittttiiiiiii1iiii_case_0")
  {}

 private:
  nacl_arm_dec::MCR2_11111110iii0iiiittttiiiiiii1iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMCR2_11111110iii0iiiittttiiiiiii1iiii_case_0);
};

class NamedMCRR2_111111000100ssssttttiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedMCRR2_111111000100ssssttttiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "MCRR2_111111000100ssssttttiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::MCRR2_111111000100ssssttttiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMCRR2_111111000100ssssttttiiiiiiiiiiii_case_0);
};

class NamedMCRR_cccc11000100ttttttttccccoooommmm_case_0
    : public NamedClassDecoder {
 public:
  NamedMCRR_cccc11000100ttttttttccccoooommmm_case_0()
    : NamedClassDecoder(decoder_, "MCRR_cccc11000100ttttttttccccoooommmm_case_0")
  {}

 private:
  nacl_arm_dec::MCRR_cccc11000100ttttttttccccoooommmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMCRR_cccc11000100ttttttttccccoooommmm_case_0);
};

class NamedMCR_cccc1110ooo0nnnnttttccccooo1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedMCR_cccc1110ooo0nnnnttttccccooo1mmmm_case_0()
    : NamedClassDecoder(decoder_, "MCR_cccc1110ooo0nnnnttttccccooo1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::MCR_cccc1110ooo0nnnnttttccccooo1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMCR_cccc1110ooo0nnnnttttccccooo1mmmm_case_0);
};

class NamedMRC2_11111110iii1iiiittttiiiiiii1iiii_case_0
    : public NamedClassDecoder {
 public:
  NamedMRC2_11111110iii1iiiittttiiiiiii1iiii_case_0()
    : NamedClassDecoder(decoder_, "MRC2_11111110iii1iiiittttiiiiiii1iiii_case_0")
  {}

 private:
  nacl_arm_dec::MRC2_11111110iii1iiiittttiiiiiii1iiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMRC2_11111110iii1iiiittttiiiiiii1iiii_case_0);
};

class NamedMRC_cccc1110ooo1nnnnttttccccooo1mmmm_case_0
    : public NamedClassDecoder {
 public:
  NamedMRC_cccc1110ooo1nnnnttttccccooo1mmmm_case_0()
    : NamedClassDecoder(decoder_, "MRC_cccc1110ooo1nnnnttttccccooo1mmmm_case_0")
  {}

 private:
  nacl_arm_dec::MRC_cccc1110ooo1nnnnttttccccooo1mmmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMRC_cccc1110ooo1nnnnttttccccooo1mmmm_case_0);
};

class NamedMRRC2_111111000101ssssttttiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedMRRC2_111111000101ssssttttiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "MRRC2_111111000101ssssttttiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::MRRC2_111111000101ssssttttiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMRRC2_111111000101ssssttttiiiiiiiiiiii_case_0);
};

class NamedMRRC_cccc11000101ttttttttccccoooommmm_case_0
    : public NamedClassDecoder {
 public:
  NamedMRRC_cccc11000101ttttttttccccoooommmm_case_0()
    : NamedClassDecoder(decoder_, "MRRC_cccc11000101ttttttttccccoooommmm_case_0")
  {}

 private:
  nacl_arm_dec::MRRC_cccc11000101ttttttttccccoooommmm_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedMRRC_cccc11000101ttttttttccccoooommmm_case_0);
};

class NamedRFE_1111100pu0w1nnnn0000101000000000_case_0
    : public NamedClassDecoder {
 public:
  NamedRFE_1111100pu0w1nnnn0000101000000000_case_0()
    : NamedClassDecoder(decoder_, "RFE_1111100pu0w1nnnn0000101000000000_case_0")
  {}

 private:
  nacl_arm_dec::RFE_1111100pu0w1nnnn0000101000000000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedRFE_1111100pu0w1nnnn0000101000000000_case_0);
};

class NamedSETEND_1111000100000001000000i000000000_case_0
    : public NamedClassDecoder {
 public:
  NamedSETEND_1111000100000001000000i000000000_case_0()
    : NamedClassDecoder(decoder_, "SETEND_1111000100000001000000i000000000_case_0")
  {}

 private:
  nacl_arm_dec::SETEND_1111000100000001000000i000000000_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSETEND_1111000100000001000000i000000000_case_0);
};

class NamedSRS_1111100pu1w0110100000101000iiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedSRS_1111100pu1w0110100000101000iiiii_case_0()
    : NamedClassDecoder(decoder_, "SRS_1111100pu1w0110100000101000iiiii_case_0")
  {}

 private:
  nacl_arm_dec::SRS_1111100pu1w0110100000101000iiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSRS_1111100pu1w0110100000101000iiiii_case_0);
};

class NamedSTC2_1111110pudw0nnnniiiiiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedSTC2_1111110pudw0nnnniiiiiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "STC2_1111110pudw0nnnniiiiiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::STC2_1111110pudw0nnnniiiiiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTC2_1111110pudw0nnnniiiiiiiiiiiiiiii_case_0);
};

class NamedSTC_cccc110pudw0nnnnddddcccciiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedSTC_cccc110pudw0nnnnddddcccciiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "STC_cccc110pudw0nnnnddddcccciiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::STC_cccc110pudw0nnnnddddcccciiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSTC_cccc110pudw0nnnnddddcccciiiiiiii_case_0);
};

class NamedSVC_cccc1111iiiiiiiiiiiiiiiiiiiiiiii_case_0
    : public NamedClassDecoder {
 public:
  NamedSVC_cccc1111iiiiiiiiiiiiiiiiiiiiiiii_case_0()
    : NamedClassDecoder(decoder_, "SVC_cccc1111iiiiiiiiiiiiiiiiiiiiiiii_case_0")
  {}

 private:
  nacl_arm_dec::SVC_cccc1111iiiiiiiiiiiiiiiiiiiiiiii_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedSVC_cccc1111iiiiiiiiiiiiiiiiiiiiiiii_case_0);
};

class NamedUnnamed_11110100x001xxxxxxxxxxxxxxxxxxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_11110100x001xxxxxxxxxxxxxxxxxxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_11110100x001xxxxxxxxxxxxxxxxxxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_11110100x001xxxxxxxxxxxxxxxxxxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_11110100x001xxxxxxxxxxxxxxxxxxxx_case_0);
};

class NamedUnnamed_11110100xx11xxxxxxxxxxxxxxxxxxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_11110100xx11xxxxxxxxxxxxxxxxxxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_11110100xx11xxxxxxxxxxxxxxxxxxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_11110100xx11xxxxxxxxxxxxxxxxxxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_11110100xx11xxxxxxxxxxxxxxxxxxxx_case_0);
};

class NamedUnnamed_111101010011xxxxxxxxxxxxxxxxxxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_111101010011xxxxxxxxxxxxxxxxxxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_111101010011xxxxxxxxxxxxxxxxxxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_111101010011xxxxxxxxxxxxxxxxxxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_111101010011xxxxxxxxxxxxxxxxxxxx_case_0);
};

class NamedUnnamed_111101010111xxxxxxxxxxxx0000xxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_111101010111xxxxxxxxxxxx0000xxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_111101010111xxxxxxxxxxxx0000xxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_111101010111xxxxxxxxxxxx0000xxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_111101010111xxxxxxxxxxxx0000xxxx_case_0);
};

class NamedUnnamed_111101010111xxxxxxxxxxxx001xxxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_111101010111xxxxxxxxxxxx001xxxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_111101010111xxxxxxxxxxxx001xxxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_111101010111xxxxxxxxxxxx001xxxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_111101010111xxxxxxxxxxxx001xxxxx_case_0);
};

class NamedUnnamed_111101010111xxxxxxxxxxxx0111xxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_111101010111xxxxxxxxxxxx0111xxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_111101010111xxxxxxxxxxxx0111xxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_111101010111xxxxxxxxxxxx0111xxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_111101010111xxxxxxxxxxxx0111xxxx_case_0);
};

class NamedUnnamed_111101010111xxxxxxxxxxxx1xxxxxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_111101010111xxxxxxxxxxxx1xxxxxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_111101010111xxxxxxxxxxxx1xxxxxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_111101010111xxxxxxxxxxxx1xxxxxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_111101010111xxxxxxxxxxxx1xxxxxxx_case_0);
};

class NamedUnnamed_111101011x11xxxxxxxxxxxxxxxxxxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_111101011x11xxxxxxxxxxxxxxxxxxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_111101011x11xxxxxxxxxxxxxxxxxxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_111101011x11xxxxxxxxxxxxxxxxxxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_111101011x11xxxxxxxxxxxxxxxxxxxx_case_0);
};

class NamedUnnamed_11110101x001xxxxxxxxxxxxxxxxxxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_11110101x001xxxxxxxxxxxxxxxxxxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_11110101x001xxxxxxxxxxxxxxxxxxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_11110101x001xxxxxxxxxxxxxxxxxxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_11110101x001xxxxxxxxxxxxxxxxxxxx_case_0);
};

class NamedUnnamed_11110110x001xxxxxxxxxxxxxxx0xxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_11110110x001xxxxxxxxxxxxxxx0xxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_11110110x001xxxxxxxxxxxxxxx0xxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_11110110x001xxxxxxxxxxxxxxx0xxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_11110110x001xxxxxxxxxxxxxxx0xxxx_case_0);
};

class NamedUnnamed_1111011xxx11xxxxxxxxxxxxxxx0xxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_1111011xxx11xxxxxxxxxxxxxxx0xxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_1111011xxx11xxxxxxxxxxxxxxx0xxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_1111011xxx11xxxxxxxxxxxxxxx0xxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_1111011xxx11xxxxxxxxxxxxxxx0xxxx_case_0);
};

class NamedUnnamed_case_1
    : public NamedClassDecoder {
 public:
  NamedUnnamed_case_1()
    : NamedClassDecoder(decoder_, "Unnamed_case_1")
  {}

 private:
  nacl_arm_dec::Unnamed_case_1 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_case_1);
};

class NamedUnnamed_cccc00000101xxxxxxxxxxxx1001xxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_cccc00000101xxxxxxxxxxxx1001xxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_cccc00000101xxxxxxxxxxxx1001xxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_cccc00000101xxxxxxxxxxxx1001xxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_cccc00000101xxxxxxxxxxxx1001xxxx_case_0);
};

class NamedUnnamed_cccc00000111xxxxxxxxxxxx1001xxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_cccc00000111xxxxxxxxxxxx1001xxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_cccc00000111xxxxxxxxxxxx1001xxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_cccc00000111xxxxxxxxxxxx1001xxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_cccc00000111xxxxxxxxxxxx1001xxxx_case_0);
};

class NamedUnnamed_cccc1100000xnnnnxxxxccccxxxoxxxx_case_0
    : public NamedClassDecoder {
 public:
  NamedUnnamed_cccc1100000xnnnnxxxxccccxxxoxxxx_case_0()
    : NamedClassDecoder(decoder_, "Unnamed_cccc1100000xnnnnxxxxccccxxxoxxxx_case_0")
  {}

 private:
  nacl_arm_dec::Unnamed_cccc1100000xnnnnxxxxccccxxxoxxxx_case_0 decoder_;
  NACL_DISALLOW_COPY_AND_ASSIGN(NamedUnnamed_cccc1100000xnnnnxxxxccccxxxoxxxx_case_0);
};


} // namespace nacl_arm_test
#endif  // NATIVE_CLIENT_SRC_TRUSTED_VALIDATOR_ARM_GEN_ARM32_DECODE_NAMED_BASES_H_
